Add Files to Source Code Control Command (Development Environment)

See Also

Copies a file, or group of files, from your development environment project into a VSS project.

To use the Add Files to Source Code Control command

  • After you've added a development environment project to source code control, on the Tools SourceSafe menu, click Add Files to Source Code Control.

Remark

Use the Add To Source Code Control dialog box to place a development environment file into the source code control database. You can use this command only with files that are already part of your development environment project. If you have a file you want to add to source code control that isn't part of any project, add it to your development environment project first.

Note Development environment files already added to the current source code control project are not displayed under Files To Be Added.

Dialog Box Options

Files To Be Added

Files available to be added to the source code control database. Click the check box next to the file(s) you want to add.

Comment

Type an optional comment for all selected files.

OK

Adds file(s) to source code control.

Cancel

Cancels the Add Files To Source Code Control command.

Select All

Selects all files listed.


Add Project To Source Code Control Command (Development Environment)

See Also

Adds the current development environment project to the source code control database.

To use the Add Project To Source Code Control command

  • On the Tools SourceSafe menu, click Add Project to Source Code Control.

Note If you specify the name of your source code control provider, that name is displayed in place of "Source Code Control."

Remark

The Add Project to Source Code Control command takes the selected files in the development environment project window and creates a new source code control project containing those files. This command is available only when you select a project not already under source code control. Each selected file is automatically added at this time.


Add SourceSafe Project Dialog Box (Visual SourceSafe)

Project

Type the name of the VSS project you want, or click in the project list to choose a project. You can enter a full project path specification (as in $/CODE/RESOURCES) or just type a project name to have a project created under the current project.

OK

Adds the current development environment project to VSS.

Cancel

Cancels the Add Project to SourceSafe command.

Create

Creates a new VSS project. Type a name under Project and click Create.


Check In Command (Development Environment)

Checks in changes made in your development environment working folder to your source code control database.

To use the Check In command

  • On the Visual Basic Tools SourceSafe menu, click Check In.

Dialog Box Options

Files To Be Checked In

Lists the files available for check in. Click the files you want to check in, or click Select All to select all the files listed.

Comment

Type an optional comment.

Keep Checked Out

Updates the source code control database with your changes but keeps the file checked out to you.

OK

Checks in the selected files.

Cancel

Cancels the Check In command.


Advanced Check Out Options Dialog Box

Sets default Check Out command options.

To display the Advanced Check Out Options:

  • Click the Advanced button on the Check Out dialog box.

Dialog Box Options

Replace Writable

Determines how VSS behaves when you try to check out a file that is already marked as writable in your working directory. Select one of the following in the list box:

  • Ask [image] Asks you what to do with each file.

  • Replace [image] Replaces the file with a read-only version.

  • Skip [image] Skips the check out operation.

  • Merge [image] Merges the changes between the checked out file and the one you are now getting or checking out.

  • Default [image] Uses the defaults set on the Local Files Options tab in the SourceSafe Options dialog box (Tools menu).

Set File Time

Changes the time assigned to the check out operation. Select one of the following in the list box: current time, the last file modification time, the last file check-in time, or the default time (set on the Local Files Options tab).

End of Line

Specifies the end-of-line character that VSS gives to each line in the file it retrieves. Select one of the following in the list box: line feed (LF) for the UNIX platform, carriage return (CR) for the Macintosh, carriage-return/line-feed (CR/LF) for MS-DOS/Windows, or the default (set on the Local Files Options tab). Visual Basic users should always set this to CR/LF.

Don't Get Local Copy

Tells VSS not to copy the file to your working directory. VSS records that the file is checked out, but does not give you a new copy.


Check Out Command (Development Environment)

See Also

Checks out a copy of the selected file(s) from your source code control provider and places a writable copy in the corresponding development environment working folder.

To use the Check Out command

  • On the Visual Basic Tools SourceSafe menu, click Check Out.

Dialog Box Options

Files to be Checked Out

Lists the files available for check out. Click the files you want to check out, or click Select All to select all files listed.

Comment

Type a brief description of the reason for the check out.

OK

Confirms Check Out.

Cancel

Cancels the Check Out command.

Select All

Selects all files listed.


Create Local Project From SourceSafe Dialog Box

Allows user to create a new development project from an existing VSS project.

To use the Download SourceSafe Project command:

  1. From the File menu, click Open Workspace.

  2. Select the Source Control button in the lower right corner of the dialog box.

Dialog Box Options

Create a new project in this folder

The working folder for the selected project. Click Browse to create or change the working folder.

SourceSafe Project to download

VSS project list. Click the project you want to open.

OK

VSS gets the files, places them in your working folder, and opens the project in your development environment so that you can edit it.

Cancel

Cancels the Download SourceSafe Project command.


Create Project from SourceSafe Command (Development Environment)

Copies a project to your hard disk when the project is in source code control but not on your hard disk.

To use the Open New Project command

  • On the Tools SourceSafe menu, click Download SourceSafe Project.

Note After you locate a project you want, this command opens it in your development environment and automatically gets all of its files from the VSS database.


Connect to VSS Dialog Box

Allows the user to specify the location of the database they want to connect to.

To display the Connect to VSS dialog box:

  • On the Add-Ins menu, click SourceSafe, and then click Open New SourceSafe Project.

Dialog Box Options

SourceSafe database path

Type the full path and name of the VSS database you want to connect to. Use the Browse button to browse for the full name.

Data path (optional)

Type the identifier for the data project you want. See your VSS Administrator for more assistance with this identifier. (Your VSS administrator must set up this identifier using the Data_Path variable.)

OK

Connects to the specified database, if available.

Cancel

Cancels the database connection.


File Difference Dialog Box (Visual SourceSafe)

By default, VSS uses the Visual display option, with line width calculated to fit on your screen, and no context lines. If you specify a UNIX display, VSS uses the Ignore Case and Ignore White Space options. The Visual display shows all lines (infinite context).

Visual

Shows the entire file, with annotations of the changes.

SourceSafe

Shows a list of lines that were added, deleted, and changed, optimized for readability.

Unix

Shows differences information in the format used by the UNIX Diff utility.

Ignore Case

Shows differences without regard for upper- and lowercase differences.

Ignore White Space

Shows differences without regard for spacing characters, such as tabs.

Report

Sends a report to the clipboard, a text file, or a printer.

Project

Displays the Project Difference dialog box.

Advanced Options

Ignore OS Differences

Tells VSS to ignore operating system line-break character differences. This is useful if you are comparing files across a network where one computer is a Macintosh, for example, and the other is operating with Microsoft Windows NT.

Show Context Lines

Includes the specified number of context lines in the differences display. Context lines are the lines in your file surrounding the line identified as different by VSS. For example, setting Show Context Lines to three means you'll see three context lines above and three context lines below the difference line.

Save Settings

Saves your selected settings for future use.


File History Options Dialog Box (Visual SourceSafe)

Labels Only

Includes only labels in the project or file history.

From

Type a time, date, version, or label. Use the prefix D to indicate a date or time, and the prefix L to indicate a label. For example "D02/29/95;12:15" or "LBeta1."

To

Type a time, date, version or label. Use the prefix D to indicate a date or time, and the prefix L to indicate a label. For example "D02/29/95;12:15" or "LBeta1."

User

Type a username to show a history of the files worked on by the specified user.

OK

Displays the History of File dialog box.

Cancel

Cancels the Show History command.

Project

Displays the Project History Options dialog box. The Project History Options dialog box contains the same options as those in the File History Options dialog box, along with two additional options: Include Files includes file information in the History of Project display; Recursive includes subprojects and all files within the subprojects. Click OK to display the History of Project dialog box.


Find Makefile Dialog Box

Allows you to locate a project file so you can open it under source control.

Once the project file (make file) is located, click OK to open it under source control, or click Cancel to cancel the operation.


Find MakeFile Dialog Box (Development Environment)

Identifies your development environment project file so the source code control provider can properly perform its operations. Appears only when you perform operations on projects that contain more than one makefile is in the same folder.

Dialog Box Options

Select the Visual Basic project file

Select the development environment project file for the project you want to work with.

OK

Opens the selected project file.

Cancel

Cancels the command.


Advanced Get Options Dialog Box

Sets default Check Out command options.

To display the Advanced Get Options dialog box:

  • On the Tools menu, click Get, and then click the Advanced button.

Dialog Box Options

Replace Writable

Determines VSS's behavior when you attempt to get a file that is already marked as writable in your working directory. Select one of the following in the list box:

  • Ask [image] Asks you what to do in each case.

  • Replace [image] VSS replaces the file with a read-only version.

  • Skip [image] Skips the Get operation.

  • Merge [image] Merges the changes between the checked out-file and the one you are now getting or checking out.

Default [image] Uses the default set on the Local Files Options tab, via the Tools menu, Options command.

Set File Time

Changes the time assigned to the Get operation. Select one of the following in the list box: current time, the last file modification time, the last file check-in time, or the default time (set on the Local Files Options tab).

End of Line

Specifies the end-of-line character that VSS gives to each line in the file it retrieves. Select one of the following in the list box: line feed (LF) for the UNIX platform, carriage return (CR) for the Macintosh, carriage-return/line-feed (CR/LF) for MS-DOS/Windows, or the default (set on the Local Files Options tab).

Make Writable

Retrieves the file and makes it writable. This is not equivalent to a Check Out operation, because the Get command is a non-exclusive one or more people can perform the Get command on the same file. You cannot check in changes after a Get operation with this option set.


Get Latest Version Command (Development Environment)

See Also

Gets the selected files from your source code control provider and places a read-only file in the development environment project.

To use the Get Latest Version command

  • On the Visual Basic Tools SourceSafe menu, click Get Latest Version.

Dialog Box Options

Files to Get/Check In

Selects the file or files you want to get or check in.

OK

Confirms your selections.

Cancel

Cancels your selections.

Select All

Selects all files listed.


Integration Options Dialog Tab

Displays information about the integration between your Visual Basic project and the corresponding VSS project.

To display the Integration Options tab:

  • On the Add-Ins menu, click SourceSafe, then Options, and then click the Advanced button. From this dialog box, select the Integration tab.

Access Rights

You must have Read access right to use this dialog box.

Remarks

The Integration Options tab is most useful for seeing how your VSS and Visual Basic projects are connected. However, you can also set a couple options on this tab: whether to display intermediate dialog boxes for the History and Show Differences command, and whether to prompt for the VSS database to use when opening a new project.

Tab Options

SourceSafe project

Shows the full name of the VSS project associated with this Visual Basic project.

Database name

Displays the name (if any) of the VSS database the project is stored in.

Database path

Displays the path to the VSS database the project is stored in.

Data specifier

Displays the data directory for a specific project. (Your VSS Administrator can set up different data directories for different projects using the Data_Path variable.)

Display dialog box for

Check the box corresponding to the command if you want an options dialog box displayed when you select that command.

Choose SourceSafe database

Set to Use Default Database to always look in the default VSS database for your project information. Set to Prompt to display a prompt dialog box, allowing you to specify the database name, path, and data specifier each time you open a project.

OK

Sets the options as specified on the tab.

Cancel

Closes the Integration Options tab.


Options Command (Development Environment)

Customizes your source code control provider environment.

To use the Options command

  • After you've added a development environment project to your source code control provider, on the Tools SourceSafe menu click Options.

Remark

The Options command displays the Source Code Control Options dialog box.

Dialog Box Options

For each option, you can specify Yes, No, or Ask.

  • Get checked in version of project files when opening a project? (No is the default.)

  • Check in files when closing the project? (Ask is the default.)

  • Add files to source code control when adding them to Visual Basic? (Yes is the default.)

  • Remove files from source code control when deleting them from Visual Basic? (Ask is the default.)

Advanced

Displays advanced options.

OK

Confirms selections.

Cancel

Cancels selections.


Properties Command (File Menu)

Displays the Properties dialog box, which contains basic information about a VSS file or project, including the size, name, and type.

Access Rights

You must have the Read access right to view the Properties dialog box.

You must have the Add access right to change the type of a file.

You must have the Destroy access right to change the Store Only Latest Version state of a file.

Remark

Click the tab with the information you want. Tab content differs according to whether a file or project is currently selected in VSS Explorer.

Note Click the Report button on any of the tabs to create a report to send to the clipboard, a text file, or a printer.

File Properties Dialog Box Tabs

General

Shows the filename, type, size, latest version number, last modification date, comment, and whether the entire file history is stored in the VSS database (or just the latest version). You can change the comment and set whether or not to store only the latest version of the file to save disk space. You can also change the file type here.

Check Out Status

Shows the file's name, who it is checked out by (if anyone), whether it is exclusively checked out, when it was checked out, the current version, the check out path (with the computer name), the project the file is in, and the check out comment. You can change the check out comment.

Links

Shows the current share links a file has to other projects.

Paths

Shows which projects have branched versions of this file in the past.


Refresh File Status (Development Environment)

Refreshes the file status display in the Visual Basic project window.

To use the Refresh File Status command

  • On the Visual Basic Tools SourceSafe menu, click SourceSafe Refresh File Status.

Remark

Use this command when you have checked a file in or out, or want to check the project status in a multi-developer environment where other source code control users may have changed a project file's status.


Run Command (Development Environment)

Starts your source code control provider.

To use the Run command

  • On the Tools SourceSafe menu, click Run. In some cases, you may need to type your username and (if applicable) your password, and then click OK.

Remark

Note When you use the Run VSS command, you have access, through VSS Explorer, to all of the VSS features and commands. The VSS commands available from the Tools SourceSafe menu are a subset of the full VSS command set.


Share Files Command (Development Environment)

Makes the selected file a member of the current project, or creates a new branch project.

To use the Share Files command

After you've added a development environment project to your source code control provider, on the Tools SourceSafe menu, click Share Files.

Remark

Note To share a file, you create a share linkGloss_sharelink among projectsGloss_project. The file then exists simultaneously in two (or more) projects. When you check in the file to any one of the projects, your changes are automatically checked in to all of them.

If you create a branch, changes made in the branched file no longer propagate to the originating project, and vice versa.

When you share a project, you create a new project under the current project that is an exact duplicate of the specified project. All the files in the new project are shared with the corresponding files in the originating project, and changes to one are reflected in the other during check in.

Note When sharing a project with Visual Basic form files (.FRM), be sure to share the associated .FRX file created by Visual Basic. If you don't, the shared project will not have all the files it needs and will not work correctly.


Show Differences Command (Development Environment)

Compares a selected file in your development environment project to the current version stored in the source code control provider database and shows you the differences, if any.

To use the Show Differences command

  • After you've added a project to your source code control provider, on the Tools SourceSafe menu, click Show Differences.

Remark

Most commonly, you use the Show Differences command immediately before you check in a file to compare your modified copy of the file to the master copy. This gives you a list of the changes you have made, which can be helpful for generating your comment.

When you use the Show Differences command on an ASCII text file, your source code control provider displays a color-coded list of line differences between the database-stored version of the file and your local copy.

For binary files, your source code control provider tells you if the local copy of the file is different from the master copy, but cannot display the differences.


Show History Command (Development Environment)

See Also

Shows the history of a file or project under source code control.

To use the Show History command

  • After you've added a development environment project to your source code control provider, on the Tools SourceSafe menu, click Show History.

Remark

Every time you check in a file or project to your source code control provider, the file or project is given a new version number. Use the Show History command to display a list of a file's or project's past versions.

Note By default, the Show History command displays the File History Options dialog box; click Projects to display the Project History options dialog box.

The versions listed start with the most recent and return to the creation of the file or project. VSS provides information about the version number, which can be used with other commands (such as Get Latest Version) to indicate a specific version.

By default, the history of a project includes the histories of all its files, but is not recursive and does not include subprojects.


Source Code Control Results Window (Development Environment)

Displays the results of the last source code control command.

Dialog Box Options

Close

Closes the Source Code Control Results window.


SourceSafe Command Status Dialog Box

This dialog is displayed briefly when you are performing a get or a checkout of a file.

Dialog Box Options

Cancel

This button will cancel the file get operation.


Undo Check Out Command (Development Environment)

Overwrites your changes to a file, and copies the latest checked in version to your development environment working folder.

To use the Undo Check Out command

  • On the Visual Basic Tools SourceSafe menu, click Undo Check Out.

Dialog Box Options

Files to Un-Check Out

Lists the currently checked out files. Click the files whose check out you want to undo, or click Select All to select all the listed files.

OK

Confirms the selection.

Cancel

Cancels the selection.

Select All

Selects all files listed.


Visual SourceSafe

Visual SourceSafe (VSS) is the leading source control tool for code and Web developers. It can store and protect any type of file. For more information, open the VSS Help file on your system (if you have VSS installed).


A database by this name already exists in the source code control project <project>.

A database by this name already exists in the source code control project <project>. Would you like to reconnect to it?

This message has the following cause and solution:

  • You tried to add a project, but a project with that name was already under source control.

Choose Yes to reconnect to the existing project, or choose No if the project in source control is a different project by the same name. Then, choose a new name for the new project.


A project by this name already exists in the source code control project "<project>".

This message has the following cause and solution:

  • You tried to add a database to source code control in an existing project.

Click Yes to reconnect to the existing project, No to cancel this operation.


A VB project by this name already exists in the source code control project <project>.

A VB project by this name already exists in the source code control project <project>. Would you like to reconnect this VB project to the existing source code control project?

This error has the following cause and solution:

  • You tried to add a project, but a project with that name was already under source control.

Choose Yes to reconnect to the existing project, or choose No if the project in source control is a different project by the same name. Then, choose a new name for the new project.


Add Files command failed: The files were not added to source code control.

This error has the following solution:

  • Open the source code control provider application and manually add the files to the project.


Add this project to <project>?

This message has the following cause and solution:

  • You created a new project, or opened a project which hasn't been under source control before.

Choose Yes to add the project, or No to cancel the operation.


Add this project to source code control?

In most cases, click Yes to keep the Visual Basic and source code control projects synchronized. You may want to click No if you are experimenting with a file that you may add at a later date, or a file that you do not want to add.

Click Yes to add the file to source code control.

Click No to add the file to your Visual Basic project without adding it to the source code control project.


All available files have already been added to source control.

This error has the following cause and solution:

  • All the files in your current development project have already been added to source control.

    If you want to check in a file that is not yet in your development project, first add the file to your development project. VSS will prompt you to add it to source control.


All available files have already been checked out.

You attempted to check out a file, but all files are already checked out.


All available files have been added to the source code control project.

All files in the Visual Basic project have already been added to the source code control provider.


An error occurred reading file '<file>' to check for changes.

An error occurred reading file "<file>" to check for changes.

This message has the following cause and solution:

  • You have encountered an internal source code control error.

Quit and restart VSS. If that doesn't solve the problem, reinstall VSS and then reboot your computer. If that doesn't solve the problem, check for adequate memory and disk space, check disk space on the server, and check the network connection to your computer.


An error occurred while trying to connect to the <project> project.

This message has the following cause and solution:

  • The source control provider could not initialize the source control project.

Exit your development environment and re-start it. If this does not clear the error, re-run your source control provider’s setup program. Check your system resources, especially memory and disk space.


Another user (<user>) has placed this database under source code control and is the only person who should work with it.

This message has the following cause and solution:

  • You are trying to open a database owned by another user.

You were not the last user to use this file. If you continue, you will overwrite their changes and check out status. Log out from VSS, and then get your own copy of the file using the Create <object> From SourceSafe command.


Another user (<user>) has placed this project under source code control and is the only person who should work with it.

This message has the following cause and solution:

  • Another user has this database under source control and you opened it. You will overwrite all of the other user's changes unless you exit immediately. If the other user had anything checked out, his or her changes will be lost the next time they use the Get Command.

Exit immediately, or sacrifice the other user's changes.


Because you have not logged on to <provider>, source code control features are not enabled for this project.

This error has the following cause and solution:

  • You canceled your logon to the source code control provider; the source code provider features are not available.

    Open a different project, then return to this project and log on.


Can't add .FRX file to source code control.

This error has the following cause and solution:

  • An .FRX file was automatically generated to hold resources for the .FRM file, but the .FRX file could not be added to source code control.

    Add the file manually.


Can't re-load file <file> in the Visual Basic project.

This error has the following cause and solution:

  • The file cannot be re-loaded in the Visual Basic project.

    Be sure the Visual Basic project file is checked out. Check the filename, and if it is correct, you may have to reload the file in the Visual Basic project. This may require getting a new copy of the file from your source code control provider and placing it into your working folder, or may require restarting Visual Basic.


Check In command failed: The files were not checked in.

This error has the following solution:

  • Open the source code control provider application and manually check in the files.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


Check Out command failed: The files were not checked out.

This error has the following solution:

  • Open the source code control provider application and manually check out the files.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


Could not connect the source code control project to the current Visual Basic project.

This error has the following cause and solution:

  • The source code control provider could not associate the current Visual Basic project with a source code control provider project.

    Run VSS and get the project (if it is already in VSS).

    Try to perform the same operation on another project. If this works, rename the original project and perform the operation again. If this doesn't work, call Microsoft Technical Support Services.


Could not create a valid file name for <file>.

This message has the following cause and solution:

  • You can only add modules to VSS if the module name is a valid filename. The file name you chose is not valid.

Rename your object to something with a valid filename.

If you mistyped the file name, please try again with a valid file name. If you believe the file name is valid, and are working in a mixed-operating system environment, the problem may be that the file name you chose does not translate properly in one of the other operating system environments connected to your VSS database. In this case, try another filename.


Could not create a working folder for this project.

This message has the following cause and solution:

  • The working folder you specified could not be created.

You may not have permission to create a folder on the computer you specified, or the drive may be full, or the name you choose may already be in use. Try specifying another name.


Differences could not be shown.

This message has the following cause and solution:

  • You encountered an internal error while trying to check differences between objects.

Quit and restart Microsoft Access, and VSS if it is running.


Errors during load of file <file>.

This error has the following cause and solution:

  • Errors were encountered while loading the file.

The file may or may not have been loaded successfully by Visual Basic. Try opening the file again, or check the file for corruption.


Failed to add files to <project>.

This message has the following cause and solution:

  • VSS couldn't save the files that you want to add, and they contain unsaved changes.

The VSS operation may have failed, you may not have add rights in this project, or you could have run out of memory. Save your files manually and try again. If that fails, check your VSS connection and try again.


Failed to add file '<file>' to source code control.

Failed to add file "<file>" to source code control.

This message has the following cause and solution:

  • There is a file with the selected name already in the source code control project.

You can save your new file as a different name, or accept the file already in source code control (overwriting any changes).


Failed to create a new project based on a <source code control provider> project.

This message has the following cause and solution:

  • You encountered an internal error while trying to create a new folder.

Quit and restart Microsoft Access, and VSS if it is running.


Failed to initialize the current project.

Failed to initialize the current project. Please exit and reload this project.

This message has the following cause and solution:

  • This is usually caused by an internal VSS error.

Exit and reload the project. If that doesn't solve the problem, exit and reload your development environment application. If the problem persists, reboot your computer.


Failed to initialize the source code control provider.

This message has the following cause and solution:

  • The source provider could not connect properly to the host development environment..

Rerun the setup programs for your source control provider..


Failed to reload the project.

This message has the following cause and solution:

  • An internal application error occurred.

Close this project from the file menu and re-open it to get the correct version of all files loaded into memory.


Failed to update project location information in the host application.

This message has the following cause and solution:

  • Another application is using the .mdb file.

Make sure no other application is using the database (be sure to check for programmatic use through DAO).


File <file> could not be mapped to the Visual SourceSafe project <project>.

This error has the following cause and solution:

  • You must have the file in VSS before continuing the operation.

    Click Yes to copy the file to the specified project and continue.

    Click No to cancel the operation.


"<file>" does not have a valid file name. It must have a legal file name to be added to source code control.

This message has the following cause and solution:

  • Although the name of this object is valid for the host application, it isn't a valid file system name (it contains illegal characters).

Rename the object, and then add it to source code control.


File <File name> has not been changed. Do you want to create a new version of the file in VSS?

This error has the following cause and solution:

  • You are attempting to check in a checked-out file that you haven't changed.

    Click Yes, and VSS checks it in anyway. (Clicking Yes All checks in all selected files.) A checkin creates a new version of the file, with an optional comment.

    Click No, and VSS undoes the check out of the file. (Clicking No All undoes the check out for all selected files.) No new version of the file is created in this case.

Note To avoid this message in the future, disable this notification on the General tab that is accessed by selecting Options from the Tools menu.


File <file> is already checked out.

This error has the following cause and solution:

  • .FRM files can be checked out to only one user at a time.

    If necessary, run your source code control provider to find out who the file is checked out to.


File <File name> (file <File name> in VSS) was not found

This error has the following cause and solution:

  • VSS was unable to locate the specified file.

    Run the Analyze utility to make sure there are no errors in your VSS database. If running Analyze with the –F switch does not correct the problem please contact Product Support.

Note When running the Analyze utility first run it with no switches to find any errors in the database and then with run it with the –F switch to run in autofix mode.


The file <File name> could not be mapped to the VSS project <Project name>. Copy the file to <File name>

The file <File name> could not be mapped to the VSS project <Project name>. Copy the file to <Project name>

This error has the following cause and solution:

  • You added a file from a folder other than your project folder (or one of its subdirectories) and VSS can't determine which project corresponds to your new file's home folder.

    VSS must map the local copy into a VSS project path for this operation to work. Copy the file to a subfolder at or below your IDE project. If the file is already in VSS in a different project, share the file to your current project and try the operation again.

    You will continue to get this message for the file as long as the name cannot be mapped. If this happens, you should remove the file from your project file, copy or share it, and then re-add the file.


The file <File name> could not be mapped to the VSS project <Project name>

This error has the following cause and solution:

  • You must have the file in VSS before continuing the operation.

    Click Yes to copy the file to the specified project and continue.

    Click No to cancel the operation.


The file <File name> exceeds the maximum VSS file name size.

This error has the following cause and solution:

  • You have exceeded the maximum number of filenames in the VSS database.

    Please contact Product Support.


Get command failed: The files were not downloaded from source code control.

This error has the following solution:

  • Open the source code control provider application and manually get the files.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


Internal error: please exit and restart Visual Basic.

This error has the following cause and solution:

  • An internal error has occurred in Visual Basic or VSS.

Save your work, exit from Visual Basic and VSS, and restart those programs if you still need to use them.


No additional Help is available on this item

  • No more information is available on this dialog box. If the cause of the problem is not clear from the message, please call Technical Support for assistance.


No corresponding Visual Basic project file for this SourceSafe project.

This error has the following cause and solution:

  • The source code control provider could not locate the Visual Basic project file (.VBP or .MAK file). A project file is required because it stores the list of files included in the project, and the source code control provider uses this list to keep track of file status.


No files are available to be checked out from source control.

This error has the following cause and solution:

  • There are no unchecked-out files in the current VSS project.

    To check out a file not yet added to source control, use the Add Files command to add files. If the file is already in your project, make sure it is not already checked out.

    This error sometimes occurs if someone deletes the file that you wanted to operate on (or deletes the whole project, for that matter)- make sure your project is still there.


No files are available to get from source code control.

This message has the following cause and solution:

  • You chose the Get command, but after careful checking, no files were available for the operation.

This error sometimes occurs if someone deletes the file that you wanted to operate on (or deletes the whole project, for that matter)- make sure your project is still there. Next, make sure you have something checked out.


No files are available to get in this project.

This error has the following cause and solution:

  • There are no files in the current VSS project.

    Use the Add Files command to add files.


Not all options could be set correctly.

This message has the following cause and solution:

  • You encountered an error writing to your system registry.

Ensure that you have enough space on your drive for changes to the system registry.


Not all requested files could be added into the version control project.

Not all requested files could be added into the source code control project.

This error has the following cause:

  • While adding files to the source code control provider, not all files could be properly replaced.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


'<object>" is checked out somewhere else - you cannot rename it now.

"<object>" is checked out somewhere else - you cannot rename it now.

This message has the following cause and solution:

  • You are trying to rename a file that is currently checked out.

You can wait for the other user to check the file in, or get your VSS administrator to undo the user's checkout (which will overwrite his or her changes.)


Only a single project can be under source control at a time with this source code control provider.

This message has the following cause and solution:

  • Some source control providers can handle only one project at a time.

Contact your vendor for an updated version of the source code control provider. Or, choose a more advanced source control provider, or don't use multiple projects..


Only one copy of the source code control provider can run at a time.

This error has the following cause:

  • Although multiple, simultaneous sessions of Visual Basic can be run, only one source code control provider can run at a time; this session of Visual Basic has source code control disabled.


Out of memory

You do not have sufficient computer memory to perform this operation. This error has the following cause and solution:

  • You have too many applications, documents, or source files open.

    Close any unnecessary applications, documents, or source files that are open.

  • You have loaded too many device drivers.

    Eliminate unnecessary device drivers.


Out of Memory - could not complete operation.

This message has the following cause and solution:

  • Your computer has run out of memory.

Close unused applications. If the problem persists, restart your computer.


Please save and check-in your makefile.

Please save and check-in your Visual Basic project file.

This error has the following cause and solution:

  • You have made changes that modify your Visual Basic project file.

You need to save and check-in your makefile. Otherwise, your project will contain references to the copied-in files in their old locations instead of the current locations.


Project <Project> has been deleted and must be recovered before opening

See Also

This error has the following cause and solution:

  • You are trying to act on a project that has been deleted. This error will occur in the integration because it can’t connect to the project in VSS (the project was deleted from VSS).

    Before you can do anything with the project, you must recover the project in VSS using the Recover command.

    Use the following steps in the VSS Explorer:

    • Select the parent project that contained the deleted project.

    • On the File menu, click Properties.

    • Click on the Deleted Items tab.

    • Select the deleted project, then click Recover.


Project <project> was not found.

This error has the following cause and solution:

  • A project was renamed, moved, or deleted.

    Click Browse if you want to look through the source code control provider database for the project.


The project <Project name> was not found. Would you like to browse for the project?

VSS tried to open a project that could not be found in your VSS database. This error has the following cause and solution:

  • You moved or renamed the VSS project in VSS Explorer, then opened your Visual Basic or Visual C++ project that refers to the old VSS project name.

    Click Yes to browse for the project if you know the name of the new project.

    Click No if you don't want the project to be under source code control. If you click No, you must manually re-add the project to VSS in order to use source code control features in the future.


Properties could not be shown.

This message has the following cause and solution:

  • You encountered an internal error while trying to view properties.

Quit and restart Microsoft Access, and VSS if it is running.


Required supporting files could not be added to source code control, the Check In operation failed.

This message has the following cause and solution:

  • You tried an Add operation, but it failed when VSS tried to add supporting project files (for example, the .frx form file).

Add each file separately to source control.


Since you have not logged into <project>, source code control features are not enabled for this session.

Since you have not logged into <source control provider>, source code control features are not enabled for this session.

This message has the following cause and solution:

  • You did not log on to the source control provider.

Re-open your project, and log on to the source control provider to use source control features.


Some file(s) could not be saved. The project was not added to <provider>.

This message has the following cause and solution:

  • You are adding a project to source control without saving changes.

VSS was not able to save some of your changes. You may not have write permission on some files, or you may have a network error.


Some files could not be checked in.

This error has the following cause and solution:

  • An error occurred during a Check In command.

    Check for free disk space, or restart Windows.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


Some files could not be checked out.

This error has the following cause and solution:

  • An error occurred during a Check Out command.

    Check for free disk space, or restart Windows.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


Some files could not have their check out status undone.

This error has the following cause and solution:

  • An error occurred during an Undo Check Out command.

    Check for free disk space, or restart Windows.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


Some files have not been named yet.

This error has the following cause and solution:

  • You have not named all your files.

Name your files using the Visual Basic Save File command before proceeding with your operation.


Some old results have been removed to make space for newer results.

This message notifies you that old results have been removed; no action is required.


Source code control could not refresh some files.

This error has the following cause and solution:

  • An error occurred during a Get Latest Version command.

    Check for free disk space, or restart Windows.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


<source code control provider> does not support this operation.

This message has the following cause and solution:

  • Your source code control provider does not support the menu item you chose.

Contact your source code control vendor, or purchase Microsoft Visual SourceSafe.


<source code control provider> did not disconnect properly.

This message has the following cause and solution:

  • The source code control provider could not disconnect from your project.

Quit and restart Microsoft Access to clear this error.


Source Code Control Results Dialog Box

Places command results in a window.

To display the command result dialog box:

  1. Set the Results_Window variable to yes in the SRCSAFE.INI file.

  2. Perform a get or check out of a file.

When you carry out a command that generates a status or error message, VSS displays the results of the command in the Results window. This window remains displayed until you press the ENTER key, click Cancel (or Close), or click the VSS Explorer window.

If you'd like, you may instruct VSS not to display the Results window. Clear the Show Results Window box in the View tab of the SourceSafe Options dialog box (Tools menu). This automatically sets the Results_Windows initialization variable to No in your SS.INI file. Error messages, however, are still displayed.


SRCSAFE.INI file not found in folder <folder>.

This error has the following cause and solution:

  • You have chosen a folder path in the Connect to VSS dialog that does not contain a SRCSAFE.INI file.

You need to choose the folder where their database information exists. This is typically on the server where VSS is installed.


<string> contains an invalid character.

This error has the following cause and solution:

  • You have entered a data path value in the Connect to VSS dialog that contains an invalid character.

Data path names should not contain the ( )[ ] or blank characters.


That source code control project didn't contain the loaded Visual Basic project file. Try again?

This error has the following cause and solution:

  • You selected a source code control project that didn't contain the proper Visual Basic project file.

    Click Yes to resume browsing through the source code control database for the correct project.

    Click No to cancel the operation.


The <file> may have changed. Undo checkout and lose changes?

This message has the following cause and solution:

  • This confirmation message asks if you want to continue with your Undo Check out command, even though it may mean losing changes you have made to your local file.

Choose Yes to undo your check out, and No to cancel the operation.


The <project> project that you selected does not contain this IDE project.

This message has the following cause and solution:

  • This warning informs you that while trying to browse for a deleted project you picked the wrong project.

Re-try the browse operation.


The change you just made has changed the Visual Basic project file, but you have not checked the Visual Basic project out yet.

This error has the following cause and solution:

  • You made a change to your Visual Basic project file, but you did not check out the file from the source code control provider first.

    Click Yes to check out the project file so you can save your changes.

    Click No to keep the project file checked in. You will not be able to save your changes in the source code control provider.


The Check In operation failed.

This message has the following cause and solution:

  • You have unsaved objects that would be lost if the operation proceeded.

Save all objects in your project to a file, and then try again.


The Check Out operation failed.

This message has the following cause and solution:

  • You have unsaved objects that would be lost if the operation proceeded.

Save all objects in your project to a file, and then try again.


The copy of the Visual Basic project file in the version control database has changed, you can no longer save your current changes.

The copy of the Visual Basic project file in the version control database has changed, you can no longer save your current changes. You must check-out the project file and remake your changes.

This message has the following cause and solution:

  • This is a warning that another user changed the project file while you were working.

Check out the new version of the project file and redo your changes.


The file <file> already exists in the source code control project, but your local copy is different.

You (or another user) has added this project to the source code control provider. However, when you tried to add files to the project, a different file with the same name was already in the project. You should use the source code control provider's difference command to see what the differences are, and then check in the proper version.

Rather than using the Add Project command, you could also get the entire project to your local drive, then check out the files you need. Using this method, you would get back in synchronization with the project, but would lose any local changes you had made to the project files.


The file <file> already exists in the source code control project, but your local copy is different.

This message has the following cause and solution:

  • You tried to add a file to your project when a file by that name already existed in the project. The file was not added, and your local copy has not been changed.

Choose a different name for the file you want to add.


The file '<file>' is no longer connected to this source code control project.

This error has the following cause and solution:

  • You have selected a file that is no longer under source code control in this project.

The file has possibly been deleted from the source code control provider, or moved to a different project. Use the Add Files command to add the file to your source code control provider in the proper project, or search the source code control database for the file if it may be part of another.


The file <file> is no longer under source code control, the operation failed.

This message has the following cause and solution:

  • Some user deleted a file from your VSS database during your session, and you tried to use a context menu to get it.

Re-add the file to source control, check to find out who deleted it and why, etc.


The file <file> is not a normal file type for adding to a Visual Basic project.

This error has the following cause and solution:

  • The file you are adding to the source code control provider is of a type not generally recognized by Visual Basic.

    Click Yes to continue adding it to the source code control provider.

    Click No to cancel the add operation.


The file '<file>' is not under source code control.

This error has the following cause and solution:

  • You have selected a file that is not under source code control.

Use the Add Files command to add the file to your source code control provider before trying to check it out or use source code control provider functions on it.


The file <filename> could not be added to the Visual Basic project.

This error has the following cause and solution:

  • The file could not be added to Visual Basic.

    Try another filename.


The file <file> could not be mapped to the source code control provider project <project>.

The file <filename> could not be mapped to the source code control provider project <project>.

This error has the following cause and solution:

  • The source code control provider does not know which source code control provider project to place the file into, or get the file from.

    The source code control provider determines this based on which folder the file is in. Though the source code control provider can map projects to directories within a project/folder subfolder, files in subdirectories or on other drives create problems, unless there already is an association between the folder that the file is coming from and a source code control provider project.

    Add the specified file to a folder at the same level as, or under, the specified project. If the file is already in the source code control provider, share the file to the current project.


The file could not be automatically renamed inside the source code control provider.

This error has the following solution:

  • Open the source code control provider application and manually rename the file.


The file could not be reloaded into the host IDE.

This message has the following cause and solution:

  • This is usually caused by an internal application error.

Close the project and re-open it.


The file has been removed from the Visual Basic project. Would you also like to remove the file from source code control?

Click Yes to remove the file from the source code control project. (Deleted files can be recovered later if necessary.)

Click No to remove the file from your Visual Basic project, but keep it in the source code control project.


The file rename operation has been stopped, not all files were saved.

This error has the following cause and solution:

  • You choose not to allow your source code control provider to check out the project file you are renaming.

If you choose not to allow the source code control provider to check out the project file while renaming a file, the operation cannot proceed so that the file does not get renamed in the source code control provider.


The file that was renamed had a tagalong file which could not be automatically renamed in source control.

This message has the following cause and solution:

  • This is usually caused by an internal VSS error.

Manually rename the tagalong file.


The filename '<File>' contains illegal characters. The file will be ignored.

This error has the following cause and solution:

  • The filename you've specified contains one or more invalid characters.

    When adding files to VSS, they must meet the following requirements.

    • 255 characters or less in length.

    • The complete path cannot exceed 259 characters, including separators.

    • May not begin or end with a space.

    • May not begin with a $.

    • May contain 1 or more file extensions (e.g., MyFile.Ext1.Ext2.Ext3.Txt).

    • Legal characters from 32-255 characters in length, but not: ?”/\<>*|:


The Get operation failed.

This message has the following cause and solution:

  • You have unsaved objects that would be lost if the operation proceeded.

Save all objects in your project to a file, and then try again.


The Get operation failed.

The History operation failed.

This message has the following cause and solution:

  • You have unsaved objects that would be lost if the operation proceeded.

Save all objects in your project to a file, and then try again.


The item was not removed from the <provider> project.

This message has the following cause and solution:

  • This is usually caused by an internal VSS error.

Remove each file separately from source control.


The item was not renamed in the <provider> project.

This message has the following cause and solution:

  • This is usually caused by an internal VSS error.

Rename each file separately in source control.


The new name cannot be used because an object with that name already exists in <provider>.

This message has the following cause and solution:

  • You are attempting to rename a file/object, and the new name is the name of an object/file that already exists in source code control.

Choose a different name for the file/object, or rename/delete the existing object that has the desired name.


# The new name cannot be used because it is not a valid filename.

This message has the following cause and solution:

  • You are attempting to rename a file/object, and the new name is not a valid filename (typically because it contains invalid characters).

Choose a different name for the file/object.


The Open Project command from the source code control provider failed.

This error has the following solution:

  • Open the source code control provider application, and then manually get the project. Then, open the project in Visual Basic.


The operation failed because some file(s) could not be saved. Save your project and try again.

This message has the following cause and solution:

  • Some files could not be saved to disk.

Make sure that you have permission and space to save files on the destination disk. Try to save the files manually, then try the operation again.


The previously loaded project could not be properly closed.

This error has the following cause and solution:

  • While attempting to open a new project, the source code control provider could not properly close the last one.

    Exit and restart Visual Basic.


The project could not be properly closed in <source code control provider>.

This message has the following cause and solution:

  • The source code control provider could not close the source code control project.

Quitting and restarting Microsoft Access will usually clear this error.


The project <project> no longer exists in <provider>.

The project <project> no longer exists under <provider>.

This error has the following cause and solution:

  • The specified project has been deleted (or moved). You must recover (or select) the specified project before any source code control commands can be applied to it.

    If the project was moved, you receive a dialog box to help you search for the new project. If the project was deleted, you must run the source code control provider to reinstate the project.


The project <project> no longer exists under source code control. You must either recover or re-create the project before you can use this project with source code control.

This message has the following cause and solution:

  • Your project has been deleted (or moved) by another user.

Click OK if you want to try to find the project. If the project has been deleted, choose Cancel. Once you click Cancel, the database will be detached from source code control, and you can re-add the project to source control (but you will lose any historical information on this project).

If you can find out who deleted or moved your project, you may be able to recover the project and its history (for example, if your source control administrator has archived your project to a backup tape).


The project cannot be added to source code control because the path is too long.

This error has the following cause and solution:

  • The path name for this project is too long.

Use a shorter path name and try again.


The Results window is full; early entries will be removed from the Results window.

When performing an operation on multiple files, the Results window may quickly fill with status messages. This warning message has the following cause:

  • The Results window is full. You won't be able to view some of the earliest entries.


The Share operation failed.

This message has the following cause and solution:

  • You have tried to share a file that has the same name property as one in the target project.

There are several possible causes for this message. One is if you have not assigned the name property in one of your files, you could be conflicting with a file in the target project (where the name property also was not assigned or is identical). In this case, assign the name property of the file in your current project, and then try again.

Other possibilities are that the project file is checked out to someone else, or you were not able to check out the project file. Check the file check out status to determine if this is the case. Or, there could have been a VSS internal error.


The share operation succeeded, but the files could not be added to the current project.

This message has the following cause and solution:

  • The share operation succeeded, but trying to add the file to the project failed.

Check that the name property of the file does not conflict with the name property of an existing form, module, class module, or other Visual Basic file.


The source code control add in could not connect to Visual Basic

This error has the following cause and solution:

  • The source code control add in could not connect to Visual Basic.

    Please contact Product Support.


The source code control add-in did not disconnect from Visual Basic.

This error has the following solution:

  • Close Visual Basic and re-open it; this is most likely a temporary internal error.


The source code control project already has a makefile named the same as the one you are adding. Is this the same file?

The source code control project already has a makefile with the same name as the one you are adding. Is this the same file?

This message has the following cause and solution:

  • You are attempting to add a makefile with the same name as a file already in the source code control provider project.

    Check the filename, and rename if necessary.

    Click Yes to add the currently selected file, overwriting the old one with the same name.

    Click No to cancel the operation.


The source code control provider did not initialize properly.

This error has the following solution:

  • Your system is low on memory or system resources.

    Close some applications and try again.

    If that doesn't help, reinstall the source code control provider.


The source code control provider was not able to connect.

A Visual Basic OLE Automation method failed. This error has the following cause and solution:

  • There was an internal OLE, Visual Basic, or source code control provider error.

    Reinstall the source code control provider.


The source code control provider was not able to successfully install menus.

This error has the following cause and solution:

  • There was an internal OLE error.

    Reinstall Visual Basic first, the source code control provider next (if necessary), and then OLE (if necessary).


The source code control provider was unable to connect to Visual Basic.

This error has the following causes and solutions:

  • An internal error occurred with OLE and Visual Basic.

  • You are using an incorrect version of Visual Basic.

    Reinstall Visual Basic and the source code control provider.


The Get operation failed.

The Undo Check Out operation failed.

This message has the following cause and solution:

  • You have unsaved objects that would be lost if the operation proceeded.

Save all objects in your project to a file, and then try again.


The visual difference operation failed.

This error has the following solution:

  • Open the source code control provider application and manually use the differences command.


There is no makefile associated with this project, unable to create a Visual Basic project from this <project> project.

This message has the following cause and solution:

  • You tried to create a Visual Basic project from source control, but specified an invalid project.

Check the project name, and try again.


This is an integration only project. Checking out files is not allowed from the VSS Explorer.

This error has the following cause and solution:

  • Either you are attempting to Check Out a Microsoft Access object in the Microsoft VSS Explorer, or the Disable_UI entry has been manually added to the SRCSAFE.INI.

    The VSS Integration Component of Microsoft Access adds a setting to the SRCSAFE.INI file when you add a Microsoft Access database to the VSS server database. This entry flags the files in the VSS database as belonging to a Microsoft Access database integration project, and it looks similar to this:

      [$/Northwind]
      Disable_UI = Yes

This .INI file entry prevents you from using the VSS Explorer to check out the Microsoft Access database files. This is by design because the files are textual representations of Microsoft Access objects that you should only manipulate in the context of a Microsoft Access project.

In some cases, it may be necessary to perform operations on Microsoft Access objects or other files from within the VSS Explorer. If so, close VSS Explorer, remove or remark the Disable_UI line in the SRCSAFE.INI file, and then reopen VSS Explorer. Then you will be able to perform the desired operation from VSS Explorer.

Note that when you reopen the Microsoft Access database, the VSS Integration Component (ACCSCC) adds the Disable_UI = Yes line back to the SRCSAFE.INI file. You can also add the line back to the file yourself.


This operation is not supported by the source code control provider.

Some source code providers don’t support all possible source code control commands. This error has the following cause and solution:

  • You attempted to launch an unsupported operation.

    Exit and restart Windows, and report this error to Microsoft Technical Support Services.


This operation requires the Visual Basic project file to be checked out first.

Many operations, such as adding a new file, removing a file, renaming a file, and so forth, require that the Visual Basic project file be checked out first.

  • You performed an operation without first checking out the Visual Basic project file.

    Check out the Visual Basic project file before proceeding, and then try the command again.


This project is not under source code control.

This error has the following cause and solution:

  • VSS has determined that the current project is not stored in the VSS database.

    If you want to add this project to source code control now, save your project and on the Add-Ins source code control provider menu, click Add Project.


This project was named '<name>' but has been moved, copied, or renamed.

This message has the following cause and solution:

  • Once you place an Access database under source code control, you are not allowed to rename it or move it to a different directory, or to work with copies of it. When you open a database under source code control which has been moved, renamed, or copied, this message will be displayed and all source code control functions will be disabled for this database.

Do not work with a copy of an Access database which is under source code control. Use the Create Database from SCC command to make a new database in the desired location.

If the database has been moved, return it to its original location and reopen it. Source code control functions will return to normal. Likewise, if it has been renamed, restore its original name.


Unable to access file "<file>".

This message has the following cause and solution:

  • The source code control provider could not make a temporary file writable.

Check the read-write permissions on your files and directories, check your disk space, and ensure the database is on a drive that you have write permission for.


Unable to add the new project to source code control.

This error has the following cause and solution:

  • There are insufficient source code control provider access rights.

    Ask your source code control administrator to increase your access rights, and try again, or try to add the project to a different place in the project tree.

    Log on again to VSS with the proper password.

    (If you have had other errors just proceeding this one, review their causes for more possible causes.)


Unable to automatically remove the file from the source code control provider.

This error has the following solution:

  • Open the source code control provider application and manually remove the file.


Unable to check out the file <file> because it is already checked out.

This message has the following cause and solution:

  • The file you chose is already checked out.

Files stored in binary format cannot be checked out by more than one person at once, because VSS could not merge in conflicting changes made by multiple users.


Unable to connect Visual Basic to source control.

Unable to connect Visual Basic to source control. Please check the installation of the source code control add-in.

This message has the following cause and solution:

  • VSS could not connect properly to your development host.

Rerun the setup program for VSS.


Unable to determine the properties of this item.

This error has the following cause and solution:

  • Visual Basic was not able to find the properties of this item.

    Run the source code control provider and get the properties from there.


Unable to initialize the host application for source code control.

This message has the following cause and solution:

  • The source provider could not connect properly to the host development environment..

Rerun the setup programs for your host development environment and source control provider..


Unable to load the source code control provider.

This error has the following causes and solutions:

  • The registry strings used to find the source code control provider dynamic-link library [image] for example, SSSCC.DLL [image] aren’t correct, or you have the wrong version of Visual Basic, or the file SSSCC.DLL is missing.

  • You moved the source code control folder after setup without updating the registry.

  • The setup program failed.

    Check your source code provider's setup instructions.

    Rerun the VSS setup program.


Unable to load the source code control provider - you need a newer version.

This message has the following cause and solution:

  • You are using a version of the source code control provider older than the supported version.

Reinstall the latest version of your source code control provider.


Unable to obtain history for this item.

This error has the following cause and solution:

  • Visual Basic was not able to get the history for this file or project from the source code control provider.

    Run the source code control provider and get the history from there.


Unable to set up the source code control menus correctly for this project.

This error has the following cause and solution:

  • There was an internal error during set up of the source code control menu system.

    Exit and restart Visual Basic, or exit and restart Windows.


Unable to start the source code control provider.

This error has the following cause and solution:

  • Visual Basic is not able to start a component of the source code control provider.

    Run the source code control provider from the icon, Windows Explorer, or File Manager.


Unable to successfully share a file from the source code control provider.

This error has the following solution:

  • Run the source code control provider and share files from there.


Unable to use the selected source code control project.

This message has the following cause and solution:

  • When you add a host project to source code control, you must select a source code control project into which the files will be placed. The source code control provider checks the selected source code control project to make sure it is suitable for the operation. If a problem is found, this error occurs.

Follow the rules imposed by the source code control provider regarding suitable projects for the Add command.


Undo Check Out command failed. Check files to verify their version status.

This error has the following solution:

  • Open the source code control provider application and manually undo the check out of the files.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


The VSS Explorer could not be run

The VSS Explorer could not be run.

It's possible there is an incorrect pointer to the VSS program location. Please contact Product Support.


Would you like to add file <file> to the current source code control project?

In most cases, click Yes to keep the Visual Basic and source code control projects synchronized. You may want to click No if you are experimenting with a file that you may add at a later date, or a file that you do not want to add.

Click Yes to add the file to source code control.

Click No to add the file to your Visual Basic project without adding it to the source code control project.


Would you like to add the new file(s) to the current source code control project?

This message has the following cause and solution:

  • You are adding, either directly or indirectly through a wizard or other tool, several files to source control.

Choose Yes to add the file(s), or No to cancel the operation.


Would you like to check in all changed files now?

Click Yes to check in all files.

Click No to defer check in until a later time.


Would you like to check in all files which are checked out to you in project <project>?

This message has the following cause and solution:

  • You are closing the development environment leaving files checked out.

When you close your development environment, VSS reminds you that you have files checked out of the project and prompts you to check them back in. You do not have to check them back in, but leaving them checked out may prevent other users from checking them out.


Would you like to check out file '<file>'?

This error has the following cause and solution:

  • You tried to edit the Visual Basic file <file>, without having it checked out.

Choose Yes to check out the file, or No to cancel the operation.


Would you like to get the latest checked-in copy of the files in this project?

Click Yes to get the latest version of the file(s).

Click No to keep the file versions you already have.


Would you like to get the latest version of all files in project <project>?

This message has the following cause and solution:

  • This query is asking if you want to get all the latest file versions in your project’s working folder.

Choose Yes to get the latest versions of all files in the project. Choose No to cancel. You can use the Options command to turn this query message off.


Would you like to remove the file '<file> from source code control?

This message has the following cause and solution:

  • You have removed an object from the development project.

Choose Yes to remove the object from source control as well, or No to leave the object in the source control project.


Would you like to save your files before proceeding with this <provider> operation?

This error has the following cause and solution:

  • You did not save files before performing a source code control provider operation.

    Click Yes to save your files.

    Click No to allow VSS to overwrite changes made since the last save operation.


You can share another makefile into this source code control project, but the makefile has not been added to the VB project.

This error has the following cause and solution:

  • You tried to share a makefile from another project into the current project, but have not added the makefile into VSS.

Add the makefile into the proper project first.


You do not have any files checked out from source code control.

This message has the following cause and solution:

  • You chose the Add, Checkout, Get, Check In, Undo Check Out command, but after careful checking, no files were available for the operation.

This error sometimes occurs if someone deletes the file that you wanted to operate on (or deletes the whole project, for that matter)- make sure your project is still there. Next, make sure you have something checked out.


You do not have any files to check in.

This error has the following cause and solution:

  • You attempted to check in files, but there are none checked out.

If you have made changes to a file that you want to check in, run VSS Explorer, select the file, and on the VSS menu, click Check Out. Be sure to click the Don't Get Local Copy option in the Check Out dialog box so you don't lose your changes.


You don't have a source code control program (such as Microsoft Visual SourceSafe) installed on your machine.

This message has the following cause and solution:

  • You have not added source control programs to your computer.

The source code control commands are therefore not available. Choose Yes to display this warning the next time you try to use source control commands, or No to disable this warning message.

For VSS users, run NETSETUP.EXE from your VSS folder to get source control capabilities. For other source control providers, re-run Setup for your provider.


You have chosen not to check out the Visual Basic project file, all the changes you have made to the project during this session will be lost.

This message has the following cause and solution:

  • This is a warning that if you do not check out the project file, any changes you make in this editing session will not be saved in source control.

Check out the project file if you want to save your changes.


You have created a new project with a different name.

You have created a new project with a different name. The new project is no longer associated with source code control.

This message has the following cause and solution:

  • You have renamed a project and the renamed project is no longer in source control.

Add the new project to source control, if desired.


You have created a new project.

This error has the following cause and solution:

  • You choose to save your project to a different folder, but your source code control provider can't map the new folder name directly.

The old project is still under source code control, but the new one is not. Use the Add Project command to manually add the new project name to source code control.


You have not added enough files to source code control to have a complete project.

This message has the following cause and solution:

  • You tried to add some files to source control, but they are not enough to completely define a project. This project has not been connected to source code control.

VSS needs to maintain all the files in the project. Add the complete set to the VSS project.


You have not added the .ACB file to source code control to have a complete database.

This message has the following cause and solution:

  • You added an Access project, but chose not to add a .ACB file.

Re-add the project to source control, and include the .ACB file.


You have not added the makefile to source code control.

You have not added the makefile to source code control. This project has not been connected to source code control.

This error has the following cause and solution:

  • You added a new project to source control, but did not include the makefile.

Re-add the project and include the makefile.


You have tried to change the Visual Basic project file without checking it out first.

This message has the following cause and solution:

  • You need to check out the Visual Basic project file before you can make changes to it.

You must check out the project file and then make your changes.


You must check out the project file before you can perform this command.

This error has the following cause and solution:

  • You attempted to perform a command that requires check out of the Visual Basic project file before you can check out the project file.

    Check out the Visual Basic project file before proceeding, and then try the command again.


Your project file has not been saved. Save your project file before using source code control operations.

This error has the following cause and solution:

  • Source code control requires that you save your project file so that it has a true file to work with.


Your project has not been saved.

This error has the following cause and solution:

  • You have to save your project before using it with source code control.

    Save the project, then try your command again.


Your project has not been saved. Save your project before adding it to source code control.

This error has the following cause and solution:

  • Source code control requires that you save your project so that no project changes are lost.


Topic Not Found

No matching topic was found. Some possible reasons and remedies are as follows:

  • The file (.chm) that contains the destination topic is not in the expected location.

    Remedy: Rerun the MSDN Library Setup.

  • The file (.chm) that contains the current topic or destination topic is out-of-date and the link is no longer valid.

    Remedy: Install the latest version of the MSDN Library.

  • The MSDN Library CD is not in the CD-ROM drive.

    Remedy: Insert the MSDN Library CD into the CD-ROM drive.


Add this project to <project>?

This message has the following cause and solution:

  • You have not added this project to source control.

Choose Yes to add this project to source control. Choose No to leave this project out of source control (for instance, to debug code first).


The source code control provider did not initialize properly.

This message has the following cause and solution:

  • The source code control provider was loaded, but was unable to initialize.

Rerun the Setup program for your source code control provider.


An error occurred opening file '<file>' to check for changes.

An error occurred opening file "<file>" to check for changes.

This message has the following cause and solution:

  • You have encountered an internal source code control error.

Quit and restart VSS. If that doesn't solve the problem, reinstall VSS and then reboot your computer. If that doesn't solve the problem, check for adequate memory and disk space, check disk space on the server, and check the network connection to your computer.


This operation requires the Visual Basic project file to be checked out first.

This operation requires the Visual Basic project file to be checked out first. Would you like to check out the Visual Basic project file?

This message has the following cause and solution:

  • You need to check out the Visual Basic project file before you can make changes to it.

You must check out the project file and then make your changes.


(Untitled)

The <project> project that you selected does not contain this VB project.

This message has the following cause and solution:

  • This warning informs you that while trying to browse for a deleted project you picked the wrong project.

Re-try the browse operation.


<File> is an invalid or corrupted logfile

This error has the following cause and solution:

  • VSS cannot find or read your logfile.

    Run Analyze.exe with the -F option. If necessary, check with Technical Support for more assistance.


Corrupted history in file <File> after revision <number>

This error has the following cause and solution:

  • The VSS database has been corrupted.

    Ddconv.exe saves as much of the database as possible, but some information will be irretrievably lost (unless you have backed up the database and can recover the information from there).


Illegal file or project name(s): <File>

See Also

This error has the following cause and solution:

  • You have entered an illegal file or project name.

    Check to make sure that the name was entered correctly. If you are unsure which characters are allowed in a VSS name, check the VSS Naming Syntax and Conventions topic.


Illegal version syntax: <number>

This error has the following cause and solution:

  • The version number you entered uses illegal syntax.

    Check to make sure that the information was entered correctly.


The deploy path <path> is not a proper file system or FTP deploy path

This error has the following cause and solution:

  • One of the paths entered for deploying the project either is not a proper operating system file system path or is not a proper ftp URL.

    Ftp paths can look like one of the following.

    ftp://user:user@www.microsoft.com/ssafe
ftp://user@www.microsoft.com/ssafe
ftp://www.microsoft.com/ssafe

    They always start with "ftp://". They always end with the ftp address (server name and, optionally, directory path). In between, you may have nothing (as in the bottom example above). Or, you may have a username (as in the middle), or a username and password (as on the top).


The URL <URL> does not have proper HTTP URL syntax

This error has the following cause and solution:

  • The URL that you entered has bad URL syntax.

    Valid syntax for the URL is shown in these examples:

    http://www.microsoft.com/default.htm
http://www.microsoft.com


Binary files differ

This message has the following cause and solution:

  • The binary files you've selected differ.

    The Show Differences command does not display line-by-line differences for binary files. Therefore, VSS can only tell you whether or not the VSS master copy is different from your local copy.


Cannot difference the specified item <item>

At least one of the items you selected to compare with another item cannot be differentiated by VSS.


Unable to open a connection to the ftp host <host>

This error has the following cause and solution:

  • VSS was unable to open a connection to the specified ftp host.

    Check your network connections, and whether or not you entered the correct syntax for your ftp host. This error could be caused if your ftp host is not available at this time.


Unable to deploy <Project> to the ftp host <host>

This error has the following cause and solution:

  • VSS was unable to open a connection to the specified ftp host and deploy your project.

    Check your network connections, and check to be sure you entered the correct syntax for your ftp host. This error could also occur if your ftp host is not available at this time.


No application is associated with this file type

This error has the following cause and solution:

  • You have attempted to view a file for which no file association exists. Without this association, VSS doesn't know which editor to use to display the file.

    Use File Manager to add an association from this file to the appropriate editor, then try your command again.

    If you want to override the File Manager association for a specific file type, you can enter specific associations in your SS.INI file, for example:

    .C = C:\VC\VC.EXE
.FRM = C:\WINDOWS\NOTEPAD.EXE


You are using an old version of <File>, and cannot change it. Rollback to make that version the most recent if you need to change it

See Also

This error has the following cause and solution:

  • You tried to modify an old version of a file.

    If you want a project to always use a specific version, and not receive checked-in changes made in other projects, you can share a specific version of the file using the Pin command in the History of File dialog box.

    If you want to start modifying the file from an old version, you can roll back the file. The Rollback command only affects the current project; it performs an implicit separate operation. Both branching and rollbacks are available from the History of File dialog box.


Are you sure you want to remove all the files in <Project>?

This warning has the following cause and solution:

  • This action will remove all the files specified in your temp directory.

    Either cancel the operation or proceed to remove all the temporary files.


Local temporary files directory has been successfully cleaned

Your local temporary files directory has been successfully cleaned.


No items listed to operate on

This error has the following cause and solution:

  • You are attempting to perform an action without first selecting an item to operate on.

    Click an item to select it, and then try the action again.


Some conflicts have not been resolved. Would you like to save the file anyway?

This warning has the following cause and solution:

  • Not all conflicts in the merged file have been resolved.

    Click Yes to save the unresolved file, or No to discard your changes and exit.


<Database> is already in your database list

This error has the following cause and solution:

  • The database already exists in your list of Available Databases.

    Select the existing entry for the database as listed in the Available Databases.


The Database <database> does not exist. Would you like to search for it?

This error has the following cause and solution:

  • You are trying to find a database that does not exist.

    Click Yes to browse for the correct VSS database, or No to cancel the operation.


This Database does not have a name. Please ask your Administrator to name it first.

This error has the following cause and solution:

  • The database does not have a name. The entry for Database_Name in the SRCSAFE.INI file is missing.

    Ask your VSS Administrator to name the database.


VSS cannot find a default database. Would you like to select one?

This error has the following cause and solution:

  • VSS is trying to find a default database that does not exist.

    Click Yes to browse for the correct VSS database, or No to cancel the operation.


The Database <database> does not exist. Please select another

This error has the following cause and solution:

  • You are trying to find a database that does not exist.

    Click the Browse button to look for the correct VSS database, or No to cancel the operation.


The VSS database path <path> does not exist. Please select another database.

This error has the following cause and solution:

  • The VSS database path does not exist. The entry for Data_Path in the SRCSAFE.INI file is invalid.

    Ask your VSS Administrator to check the VSS database path in the SRCSAFE.INI file.


Remove <database> from your Database list?

This warning has the following cause and solution:

  • You are deleting a VSS database entry from your Open SourceSafe Database list.

    Click Yes to delete the specified entry, or No to leave the database entry on the list.


<Database> is already in your database list. Would you like to rename it?

This error has the following cause and solution:

  • You are renaming a VSS database entry in your Open SourceSafe Database list.

    Click Yes to rename the specified entry, or No to leave the database entry as it is on the list.


<File> is checked out by <user>; deleting it will cancel the check out. Continue?

This warning has the following cause and solution:

  • You are attempting to delete a checked out file.

    This warning provides the opportunity to avoid deleting the wrong file. If the file name is correct, click Yes to proceed. Click No to cancel the delete operation.


You have <File> checked out; deleting it will cancel the check out

This warning has the following cause and solution:

  • You are attempting to delete a file checked out to you.

    If the file name is correct, click Yes to proceed. To cancel the delete operation, click No.


Folder not found

This error has the following cause and solution:

  • You specified an operating system folder that could not be found.

    Check to make sure the folder specification is correct. Check capitalization on case-sensitive operating systems.


Invalid date string

VSS cannot use the date syntax entered. This error has the following cause and solution:

  • The date you entered is invalid.

    Proper date syntax is Month/Day/Year, with each number separated by a slash: for example, 2/29/64 or 11/5/1992.


Invalid time or date string.

VSS cannot use the date or time syntax entered. This error has the following causes and solutions:

  • The date you entered is invalid.

    Proper date syntax is Month/Day/Year, with each number separated by a slash: for example, 2/29/64 or 11/5/1992.

  • The time you entered is invalid.

    Proper time syntax is Hour:Minute, followed by a one-letter a.m. or p.m. indicator: for example, 9:30A or 5:00p. (The indicator is not case-sensitive.) Or, you can use a 24-hour syntax such as 13:45.


Too many file handles open

This error has the following cause and solution:

  • You have too many files open at once.

    Close some open files.


Access to file <File> denied

Under certain conditions, VSS denies a user access to a file. This error has the following causes and solutions:

  • You were denied access (read or write privileges) to a file that VSS was attempting to open.

    It is possible that another user has the file momentarily locked; try again.

  • You may not have sufficient network privileges to take the action you are attempting.

    See your VSS Administrator for more information on your VSS access rights. Also see the Administration chapter of the Microsoft Visual SourceSafe User's Guide for a description of the network access rights required for various users in different directories.


Invalid drive: <drive>

This error has the following cause and solution:

  • The drive you are attempting to access is invalid. You may have mistyped the drive specification, either in VSS Explorer or in an initialization file.

    Check to make sure that you've entered the correct drive specification.


Invalid filename: <File>

This error has the following cause and solution:

  • You typed a file name with invalid syntax.

    Check your typing, or select a different name with valid characters. You may also get this error if you have multiple files selected and try to use a command meant for a single file, such as View.


Disk full

This error has the following cause and solution:

  • You tried to save data to a full disk.

    Free some disk space by deleting or moving unneeded files.


File <File> already exists

This error has the following cause and solution:

  • You tried to create a file or folder with a name that already exists.

    You can give VSS files the same name as many times as you want in different directories, but only once in a given folder. Select a different name or rename the conflicting file or project.


File <File> is locked

This error has the following cause and solution:

  • The file you are trying to access is already being used.

    Wait and try your operation again later.


File <File> not found

VSS could not find the file it was looking for. This error has the following causes and solution:

  • You may have mistyped a file name in VSS Explorer or in an initialization file variable.

  • The file may not exist.

    Make sure that you've correctly entered the name of the file.


Error reading from file

VSS cannot read from a file it has opened. This error has the following cause and solution:

  • You may have lost your network connection.

    Exit VSS, and then check all network connections before restarting.


Too many file handles open

This error has the following cause and solution:

  • There are too many files open on your system.

    You may want to check whether any of the files can be closed, or you may want to increase the Files count in your operating system's initialization file.


Error writing to file

VSS cannot write data into a file that it has opened. This error has the following cause and solution:

  • You may have a full disk.

    Exit VSS, and then free disk space by deleting unnecessary files.


File version not found in local cache

There is no Help for this topic.


Could not login to <ftp site>

This error has the following cause and solution:

  • You cannot log in to the specified ftp site.

    You may be using an invalid address, invalid username, invalid password, or perhaps the site is just not responding. Make sure you have the right ftp address.


Could not Deploy <Project> to <host>

This error has the following cause and solution:

  • VSS was unable to open a connection to the specified ftp host and deploy your project.

    Check your network connections, and check that you've entered the correct syntax for your ftp host. This error can also occur if your ftp host is not available at this time.

    This message can also mean that you are out of disk space. It can also mean that you don't have permission to write to the location although you may have read permission.


Get the entire project at this label?

This message has the following cause and solution:

  • You've done a get of a file at a label from the Project History dialog box.

    Click yes to get the whole project at that label. Click no to get only the file at that label.


Get the entire project containing this file version?

See Also

This message has the following cause and solution:

  • You have selected a file in the History of File dialog box list and then clicked Get.

    Click Yes, and VSS gets the entire project as it existed immediately after the selected file was checked in.

    Click No, and VSS gets only the file version you selected; it doesn't get any other files in the project.


There are no items in the list

This error has the following cause and solution:

  • You specified a history operation where no items met the specified criteria.

    Examine the check boxes in the History Options dialog box, and make sure they are set correctly.


Label comment is invalid when no label specified

This error has the following cause and solution:

  • You specified a comment for a label but no label was supplied.

    If you want to label a file or project, and wish to include a comment, you must specify the label as well as the comment.


Rollback is not allowed before a pinned version

This warning has the following cause and solution:

  • You tried to roll back a file to a version before the one it is pinned to.

    A pinned file cannot be rolled back to a version previous to the version it is pinned to. To roll back the file, unpin it first, then do the rollback.


Cannot find Help file <File>

This error has the following cause and solution:

  • The Help file isn't available.

    Try reinstalling VSS to get a copy of the Help file. If the file is still missing, call Technical Support.


The default working folder of the current project as inherited from its parent cannot be used because the path is too long

This error has the following cause and solution:

  • VSS creates working directories for projects by inheriting them from parent projects, then appending on the names of any VSS projects following it. However, if the name inherited from is a long name, the limit of 260 characters may be exceeded.

    Either set a new working directory for the project in use, or edit and shorten the working directory for the project inherited from.


Initialization variable <variable> must be set to "Yes" or "No"

This error has the following cause and solution:

  • An initialization variable that should be set to Yes or No is not.

    Change the variable so that it is set to Yes (or True) or No (or False).

Note You can use any text editor to change or delete the invalid value.


Invalid syntax on line <line> of file <File>

This error has the following cause and solution:

  • The syntax of one or more lines in the initialization file is invalid.

    Search Help for information on the proper syntax of the initialization variable.

Note You can use any text editor to change or delete the invalid line.


Initialization variable <variable> set to invalid number

The specified initialization variable has been set incorrectly. This error has the following cause and solution:

  • An initialization variable that should be set with an Arabic number is not. For example, it may be set to "two" when it should be set to "2".

    Search Help for information on the proper syntax of the initialization files.

Note You can use any text editor to change or delete the invalid number.


Initialization variable <variable> set to invalid folder path

An initialization variable that should be set to a valid folder path is set to an invalid path. This error has the following cause and solution:

  • The path syntax may be incorrect or the path may not exist.

    Verify that the path exists or that the syntax is correct and change it as necessary.

Note You can use any text editor to change or delete the invalid path.


Initialization variable <variable> set to invalid value

This error has the following cause and solution:

  • An initialization variable is set to an invalid value.

    Search Help for information on the proper syntax.

Note You can use any text editor to change or delete the invalid value.


Cannot find initialization variable <variable>

VSS cannot find an initialization variable it needs to perform an operation. This error has the following cause and solution:

  • The specified initialization variable is missing and is required to complete the operation.

    Search Help or the Microsoft Visual SourceSafe User's Guide for information on the variable, determine a proper value for it, and add it to your initialization file.


Initialization variable <variable> must be between <number> and <number>

An initialization number is out of the valid range. This error has the following cause and solution:

  • An initialization variable has been set to an invalid number.

    Search Help for information on valid settings.

Note You can use any text editor to change or delete the invalid number.


Cannot find SS.INI file

VSS cannot find your SS.INI file. This error has the following causes and solution:

  • The SS.INI file is not where VSS expects to find it. (See your VSS Administrator if you have moved this file.)

  • You have inadvertently deleted your SS.INI file.

    You can copy an SS.INI file from another user into your VSS folder, then modify it to customize VSS. Your VSS Administrator must then set VSS to look in the proper place.


Invalid value <value> on File Types tab

This error has the following cause and solution:

  • You have attempted to create a file type using invalid characters.

    File Type names cannot contain the following characters: [ ] ( ) , ;. The value for a file type is a search pattern, and cannot contain invalid characters. Also, you cannot leave the File type included in this group text box blank. Consequently, some file types must be entered.


The address <address> is not a valid ftp address

This error has the following cause and solution:

  • You specified an invalid ftp address.

    Type the address again; check the spelling and whether the address is legitimate.


<Type> is not a valid mask

This error has the following cause and solution:

  • You specified an invalid mask in the File Types tab in the Options dialog box on the Tools menu.

    You must specify a * or ? character in your file mask, and you cannot have any illegal characters such as (, ), [, or ] in the mask.

    Retype the file mask using legal characters.


The labels.ini file could not be properly updated. Have your VSS Administrator run the Analyze utility to recreate it.

This error has the following cause and solution:

  • While trying to keep the labels.ini file up to date, VSS was unable to write to the file. Any attempts to perform a get by label will not see the label until your VSS Admin runs Analyze.

    Ask your VSS Administrator to run the Analyze utility.


Unable to launch the Web browser for page <File>

This error has the following cause and solution:

  • VSS was unable to start your Web browser.

    Check that your Web browser is functioning normally. You may need to install the browser again to verify your registry settings.


Current database does not match request

This error has the following cause and solution:

  • A VSS internal error has occurred. VSS assumes that the database you are logged into should be in a new format.

    Call your VSS Administrator to run DDUPD –redo, or to contact tech support.


Error locating local temporary files directory

This error has the following cause and solution:

  • The entry for Temp_Path in the SRCSAFE.INI file is missing.

    Ask your VSS Administrator to fix the Temp_Path entry in the SRCSAFE.INI file


Local temporary files directory is not found at location <path>

This error has the following cause and solution:

  • The local temporary files directory is missing or was accidentally deleted.

    Create the local temporary files directory as specified, or ask your VSS Administrator to fix the problem.


Login failed. The supplied login information is not valid and should be changed to valid login information for this database.

This error has the following cause and solution:

  • Your attempt to login to VSS was unsuccessful.

    Please try logging in again to the correct database, with the proper user information. Make sure Caps Lock is turned off.


A merge of <File> produced a 0 byte file. Data may have been lost. Would you like to undo the merge? (recommended)

This error has the following cause and solution:

  • A zero length file indicates a possible internal VSS error resulting in loss of data during the merge operation.

    Recommended: undo the merge by clicking Yes. If you are certain, however, that you've performed an action that resulted in a valid zero length file, you can click No to save the zero length merge file.


Failure writing merge file for <File>.

An internal error has occurred and the merge operation has been undone.


The label cache file <File> could not be found. Have your VSS Administrator run the Analyze program to recreate it.

This error has the following cause and solution:

  • Either someone intentionally deleted this file, or a machine may have crashed while trying to write it.

    Run Analyze on the database as soon as possible. Do not label any more files or projects, or attempt a get on a label until Analyze is complete.


<Path> is not a complete VSS spec or a fully qualified pathname.

This message appears in the Project Differences dialog box when an invalid file name or VSS project name is specified.


Network not found

This error has the following cause and solution:

  • No network is installed, or VSS cannot find a valid network.

    Perhaps there is no network installed, or one or more network connections have failed. Check your network hardware, and make sure that all the necessary network drivers are running. Check with your VSS Administrator for additional assistance.


The file <File name> is not branched in <Project name>

This error has the following cause and solution:

  • The file you are trying to merge is not branched.

    When a file is branched, and you want to merge the different versions of the file into one combined file, you can use the Merge Branches command. In this case, the file is not branched, so Merge Branches has no effect.


No deployment path has been setup for <File or Project name>.

This error has the following cause and solution:

  • You tried to Deploy a project without specifying a deployment path for the project in the Administrator program.

    Ask your VSS Administrator to set up a deployment path for your Web project.


The files are identical

This message has the following cause and solution:

  • The files you have selected, the VSS master copy and the local copy, are identical. You may have selected a file in the file list and tried to run the Show Differences command only on that file, in which case the file is being compared to itself and is by definition identical.

    In this case, before applying the Show Differences command again, specify two distinct files.


Warning: If you do not use a password, others will be able to log into this VSS account. Proceed with no password?

This warning has the following cause and solution:

  • You attempted to log on without specifying a password.

    This is an informational warning to make sure you want to proceed without setting a password on your account. Click Yes to log on, or No to cancel.


The <File> file could not be found. Have your VSS Administrator run the Analyze utility to recreate it.

This error has the following cause and solution:

  • The labels.ini file was missing from the VSS database.

    Ask your VSS Administrator to run either the Analyze utility, or ddupd -redo.


The local cache file (vss.ver) does not exist

This error has the following cause and solution:

  • Some features such as checkout local version cannot work if there is no vssver.scc file.

    The next get of any file will create a vssver.scc file.


Cannot check out <File>. It is binary and is already checked out.

This error has the following causes and solution:

  • The file you specified is binary and is already checked out. VSS does not allow multiple checkouts of binary files, because their changes cannot be merged.

    Wait to check out the file until after the other user has checked it back in.


File <File> was checked out to <folder>, not to <folder>

This warning has the following cause and solution:

  • The file you are checking in was checked out in a different folder.

    When dragging a file to check in, you must check it in from the folder where it was checked out. The file you dragged will not be checked in. If you want to check the file in from this folder, use the VSS Check In command from the SourceSafe menu.


Could not display this URL

This error has the following cause and solution:

  • You tried to check an external Web link, but there was no Web browser present in the register to handle an http path; or, the link syntax was incorrect for ShellExecute (this could happen if you tried to check a virtual root by double-clicking on it instead of setting the virtual root).

    Install Internet Explorer version 3.0 or later.


This command requires Internet components which are not installed on your machine

This error has the following causes and solution:

  • You tried to use the Check Web Links command on a RISC platform, but there wasn't a WinINET.dll to distribute when we shipped VSS. You can get this required DLL when a RISC version of the browser exists.

  • You are missing the correct version of WinINET.dll on your Intel or Alpha computer. Check to see if the file has been moved or renamed.

    To make sure you have the latest Internet components, go to http://www.microsoft.com/ie/ and download Microsoft Internet Explorer version 3.0 or later. Then restart VSS to enable this command.


Please enter a number between 0 and 32767

This message has the following cause and solution:

  • You have not entered a number of context lines between 0 and 32767.

    Context lines are the lines immediately preceding and following a difference. Showing these lines in a difference display helps you understand the context of the change or difference. If you have checked the Show Context box in the Advanced options of the Show Difference command, you need to specify the number of preceding and following lines to show.


The editor '<editor>' was not found

This message has the following cause and solution:

  • You have attempted to view or edit a file for which the specified editor could not be found. (Editor associations to file extensions are set on the General Options tab that is accessed by clicking Options on the Tools menu.)

    Click Yes if you would like to specify a different editor. Click No to cancel the editing operation.


Editor path is a required field when prompting by editor is selected

This message has the following cause and solution:

  • When you check the Use Editor to Prompt for Comments check box, you must specify the appropriate editor.

    Set the path in the Editor field of the Command-Line Options tab in the Tools Options dialog box on the Tools menu.


No differences were found for project <Project>

This message has the following cause and solution:

  • You compared two items with no differences.

    This is an informational message to tell you that no differences were found between the compared items.


The passwords don't match

This error has the following cause and solution:

  • The password you typed in the Password box does not match the one typed in the Verify box.

    If the passwords you type are identical, VSS assumes you typed them correctly, and changes your password. If you type two different passwords, VSS assumes that you entered an incorrect password.


Cannot rename to <File>; that name already exists

See Also

The file name specified already exists in the project. This error has the following cause and solution:

  • When you rename a file that is shared by many different projects, the name of the file changes in all the projects that are sharing it. If any one of these projects already has a file with the same name, you create an ambiguous and invalid situation: two files in the same project with the same name. The Rename operation then fails.

    To correct this, select another name for the file.


You must specify a new name

This error has the following cause and solution:

  • You are attempting to rename a file or project without specifying a new name for it.

    Either specify a new name and then click OK, or press the ESC to cancel the rename operation.


Could not find the file referred to by shortcut <File>

This error has the following cause and solution:

  • The file referred to by this .lnk file could not be found.

    Check that the file has not been moved or deleted. Click OK to accept and retry.


<File> is an Explorer link file

This message has the following cause and solution:

  • You dragged a .lnk file into VSS.

    When you drag a .lnk file into VSS, you need to tell VSS whether to add the .lnk file itself to the database, or add the file that the .lnk file points to. If you want to add the file referred to by the .lnk file, click Yes. Otherwise, click No.


All conflicts have been resolved, would you like to save the file?

This message has the following cause and solution:

  • You have successfully resolved all merge conflicts.

    Click Yes to save the file, or No to discard your changes.


No matches were found

This error has the following cause and solution:

  • VSS has searched all the selected files, and has found no occurrences of the string you are trying to find.

    Check to make sure that you've entered the string correctly.


The database is unavailable. Would you like to disable source control integration?

This message has the following cause and solution:

  • The VSS database is unavailable. Click yes to disable source control integration.

    Once the connection to the VSS database is restored, restart the program you were using integration with (for example, Visual C, Visual Basic, or Visual J) to use source control.


Source control has been disabled for this application. Please restart the application to use source control.

This message has the following cause and solution:

  • The server connection has been lost, so source control was disabled.

    Once the connection to the VSS database is restored, restart the program you were using integration with (for example, Visual C, Visual Basic, or Visual J) to use source control.


Always share the latest version of <File>?

See Also

Generally, every project sharing a file always has the latest version of the file. When you check in the file in any project, all the projects are automatically updated. However, you can use the Pin button in the History of File dialog box to share an explicit version of a file. This message has the following cause and solution:

  • By clicking the Pin button in the History of File dialog box, you've chosen to share the most recent version of the file.

    If you click No, the project shares the pinned version explicitly, and does not receive checked-in changes from other projects.

    If you click Yes, the project returns to a sharing state in which it is always using the latest version of the file.


You must enter a filename with no path for the Site map

This error has the following cause and solution:

  • You specified a file path for the Site map file, which is not allowed. The Site map file specification does not accept a path.

    Enter just the file name, such as Sitemap.htm.


<File> is a VSS local cache file and cannot be added

This error has the following cause and solution:

  • You attempted to add an existing VSS file to VSS.

    Stop the operation.


Error creating <File> while attempting to lock database. Database is not locked.

This error has the following cause and solution:

  • A file needs to be created in the following directory, however the creation process failed: <vss install directory>\data\loggedin

    You may have run out of disk space, or you don't have write access to the folder.

    Check to make sure you have write access to the VSS folder.


Error deleting <File> while attempting to unlock database. Database is not unlocked.

This error has the following cause and solution:

  • A file needs to be deleted in the following directory, however, the deletion process failed: <vss install directory>\data\loggedin

    You do not have delete permissions to the folder.

    Check to make sure you have delete permissions to the VSS folder.


Folder <path> not found. Create?

The specified working folder does not exist. This error has the following cause and solution:

  • The folder may have been deleted, or you may have entered its specification incorrectly. Your network connection to a networked location may also have gone down.

    Reset the working folder for this project (using the Set Working Folder command on the File menu), or click Yes to create the folder. This tells VSS that this is the local working folder. When you open the project again, VSS automatically goes to this working folder.

    If your working folder seems fine, check to see if this project is shadowed to another location, and that your connection to that location is still OK.


Have the conflicts in <File> been properly resolved?

This message has the following cause and solution:

  • You have attempted to check in a file changed from the current version stored in VSS.

    This warning message often is displayed when you have checked out the same file to more than one user or computer. It is displayed so you can be sure that any merge conflicts have been resolved. In some cases, this warning may be displayed even if no merge conflicts occurred. If this occurs, click Yes and continue with your work.

    If there were conflicts, and you did not open the source file to resolve them, click No. When finished, try your Check In operation again.


Cannot check out an old version of a file

See Also

The Check Out command always uses the most recent version of a file. This error has the following cause and solution:

  • You are trying to check out an old version of a file.

To use and modify a previous version

  1. Check out the most recent version of the file.

  2. Delete it from your working folder (not the VSS database).

  3. Get the old version that you want to modify.

  4. Make your changes to the old version. (This may require removing its read-only flag manually.)

  5. Check the modified file into VSS.

Note You can also use the Rollback button in the History of File dialog box (on the Tools menu, click Show History). If you roll back to a certain version, all versions subsequent to that version are deleted. You can then check out the file and start modifying it. The disadvantage of this method, however, is that you lose all the subsequent versions, and cannot retrieve them.


File <File> was checked out to folder <path>

When you check out a file, VSS keeps track of the working folder you checked it out to. In general, you make your modifications in that folder, and then check in the file or undo the check out from the same folder when you are finished. This warning has the following cause and solution:

  • You are attempting to check in or undo a check out of the file from a folder different from the one you checked it out to.

    Your working folder for a project is displayed just above the file pane in VSS Explorer, and can be changed with the Set Working Folder command from the File menu (ctrl+d). The checkout folder of a file is displayed in the file list. (The checkout folder may be different from your working folder assigned to the project, if someone else has the file checked out, for example.) Although you can check a file in from a folder other than the one you checked it out to, make sure that this is what you intend.


File <File> is checked out to project <Project>, and you are in <Project>

When a file is shared among multiple projects, a file in one project is linked to all other projects that share it. Therefore, when you check out the file from one project, it is also checked out from all the projects that share it. This warning has the following cause and solution:

  • You checked out a file from one project, and you are attempting to check the file in or undo the check out from another project that shares the same file.

    This is a valid action. VSS is simply alerting you in case this is not what you intend. To proceed, click Yes; to cancel the operation, click No.

Note You can check in a file or undo a check out from any project that shares a file.


File <File> is currently checked out by <user>

See Also

This warning has the following cause and solutions:

  • When someone other than you has a file checked out, there are some things you cannot do to the file. For instance, you cannot delete or rename a file that is checked out.

    Click Yes to check out the file anyway. (Yes All checks out all selected files even if they are already checked out by another user.) If you click Yes, there may be conflicts between your changes and those of another user, which will have to be resolved and merged later.

    Click No to cancel the Check Out command. (No All cancels the command for all selected files.)

If you want to work on a checked-out file, it's best to check the User column of VSS Explorer for the name of the user who has it checked out and ask that user to check it in as soon as possible. If the user is unavailable, the VSS Administrator can undo the check out for you.


An automatic merge has occurred and there are conflicts. Edit <File> to resolve them

See Also

Changes you made to the file since you checked it out conflict with other changes made (and checked in) to the source file by another user. This error has the following cause and solution:

  • You have to resolve the conflicts between your changes to a file and another user's changes before you can check in the file.

    Open the file in your working folder and search for six consecutive equal signs (======). VSS uses these to mark the location of a conflict.

You may prefer to use the Visual Merge feature to make conflict resolution easier. To avoid this situation, your VSS Administrator can disable multiple check outs in your project.


A deleted link to <File> already exists

See Also

A deleted file remains part of a project, but it doesn't appear in the file list. This error has the following cause and solution:

  • You are attempting to share a file from another project with the current project. However, the file already exists in the current project. It doesn't appear in the file list because it has been deleted.

    To make the file appear in the file list, don't share it from another project; rather, recover it in this project using the Recover button on the Deleted Items tab in the Properties dialog box on the File menu.


An item named <item> was already deleted from this project

See Also

In VSS, you can delete only one instance of a file or project with a given name in a given project. This error has the following cause and solution:

  • You deleted a file, created a new file with the same name, and then attempted to delete that file as well.

    You can click Yes to purge the old file, or No to cancel the delete operation. If you purge the original file, you will lose all historical information in it, but you can then continue with the current delete operation. If you want to keep the history of the old file, you can click No and then rename the new file before deleting it.


This version of <name> already has a label: overwrite?

Any version of a VSS file or project can have a label, which is used to identify that version. This error has the following cause and solution:

  • One version of a file or project cannot have more than one label. Therefore, when you attempt to label a version that already has a label, VSS displays this message.

    Click Yes to apply the new label and replace the old label. Click No to cancel the action and leave the old label in place.


This label <label> is already used. Remove the old label?

A VSS label is used to identify a particular version of a file or project. This error has the following cause and solution:

  • You are attempting to assign a label to a file or project, and another version of that file or project has the same label.

    Click Yes to apply the new label and delete the old label. Click No to leave the old label unchanged. Click Cancel to cancel the labeling operation.


A writable copy of <File> already exists

When you get a VSS file, the file is tagged as read-only. You cannot modify the file. When you check out the file for modification, the read-only flag is deleted. When you check it in, the file is flagged read-only again. This error has the following cause and solution:

  • You attempted to use the Get Latest Version command on a file that already exists on your hard disk in read/write form. If the local copy is read/write, you probably have it checked out; VSS does not replace the file, and displays this error message.

    Click Yes or Yes All to replace the file or files with the current version in the VSS database.

    Click No or No All to not replace the file(s).

    Click Cancel to cancel the Get Latest Version command.


Project <Project> does not exist

This error has the following cause and solution:

  • You are attempting to move a project to a parent project that does not exist.

    Check the path of the parent project and try again. If you are unsure of VSS project syntax, try selecting the parent from the project list in VSS Explorer, and then note the project path displayed above the file list.

Note To move a file or subproject to a new parent, you must have already created the new parent project. Use the Create Project command to create a new project.


Cannot roll back to the most recent version of <File>

See Also

The Rollback command returns a file to a previous version of itself. This error has the following cause and solution:

  • You have attempted to roll back a file to its most recent version or have not specified a version to roll back to.

    You cannot roll back a file to the current version in VSS. If you meant to specify an earlier version, retry the command with the earlier version specified.


You do not have destroy rights to <item>

This error has the following cause and solution:

  • You've tried to destroy something without the proper permissions (destroy rights).

    Ask your VSS Administrator to set you up with destroy rights, or abandon the attempt to destroy.


File <File> is not shared with any other projects

The Branch command is used to break a share link. This error has the following cause and solution:

  • The file you've chosen to apply the Branch command to has no link to other projects.

    Select another command, or select a shared file to apply the Branch command to.


Path <path> too long

See Also

The path specified is too long. This error has the following cause and solution:

  • You typed a VSS path that is too long.

    VSS project names are limited to 64 characters. Full project path names can be no longer than 255 characters.


Rename does not move an item to another project

See Also

The Rename and Move Project commands cannot be implemented at the same time. This error has the following cause and solution:

  • The VSS Rename command and Move command are separate, distinct operations; you cannot do both in one step.

    First perform one action and then do the other.


Cannot delete, rename, or move the root project

This error has the following cause and solution:

  • The Delete, Rename, and Move Project commands cannot be applied to the root project ($/), which is analogous to the root folder of your hard disk (C:\).

    Since the root project cannot be changed in any way, consider restructuring your project.


Your working folder contains a writable copy of <File>

This error has the following cause and solution:

  • You have a writeable file on your disk not checked out to you, and you've done a Get.

    Select one of the options presented. Either leave the file, replace the file, check out while keeping the changes, or cancel the get.


Your working folder contains a writable copy of an old version of <File>

This error has the following cause and solution:

  • You have a writeable file on your disk not checked out to you, and you've done a Get.

    Select one of the options presented. Either leave the file, replace it, check out the old version while keeping the changes, check out the old version while merging the changes, or cancel the get.


A deleted link of file <File> already exists in the destination project

Do you want to recover the linked file?


File <File> is already shared with this project

See Also

This error has the following cause and solution:

  • You are attempting to share a file with the current project, and that file already exists in the current project.

    If you want to share a different version of the file, specify a version in the History of File dialog box and click Pin. If you want to share this file with another project, select that project in VSS Explorer and click Share on the SourceSafe menu. Then, select the file to share from the Share dialog box.


File <File> is already checked out by another user. Continue?

This warning has the following cause and solution:

  • The file you selected for check out is already checked out by another user.

    Either cancel the check out or continue.


You already have file <File> checked out to another location. Do you want to continue?

This warning has the following cause and solution:

  • The file you selected for check out is already checked out by you in a different location.

    Either cancel the check out, or check out the file to a new location.


<File> is already checked out by <user>. Continue?

See Also

This warning has the following cause and solution:

  • You attempted an operation on a VSS file that is checked out by another user.

    VSS gives you the option to continue, which means any differences between the changes you make to the file and the changes made by the other user will need to be merged in the future. Click Yes to continue your operation and create a multiple-check out situation; click No to cancel the check out action.


Invalid VSS path <path>

See Also

This error has the following cause and solution:

  • You have entered an invalid VSS project or file name.

    Check to make sure that you typed the path correctly, or use VSS Explorer to select the item from the project list or file list.

    If you chose the item from VSS Explorer, it is possible that another user has deleted or renamed the item since you last used VSS. Collapse the root project and expand it again to refresh the project pane.


<File> is not a text file

Although most VSS commands work on either text or binary files, this command does not. This error has the following cause and solution:

  • You attempted to execute a command that operates only on text files, such as View File on the Edit menu or Find In Files on the Tools menu.

    Binary file types are set either automatically by VSS or manually using the File Types tab in the SourceSafe Options dialog box on the Tools menu.


<Item> has been deleted

See Also

This error has the following cause and solution:

  • You are trying to act on a file or project that has been deleted in the current project.

    Before you can do anything to the file, you must recover it using the Recover command.

    If you want to delete the file from the VSS database permanently, on the File menu, click Properties, and then on the Deleted Items tab, click Purge.


This command operates only on projects, not on files (like <File>)

This command operates only on projects. This error has the following cause and solution:

  • You attempted to execute the command on a file.

    In the VSS Explorer, select a project in the project list, then try the command again.


This command operates only on files, not on projects (like <Project>)

This command operates only on files. This error has the following cause and solution:

  • You attempted to execute the command on a project.

    In the VSS Explorer, select a file in the file list, then try the command again.


<Item> is not a deleted file or project

See Also

The Recover and Purge commands operate only on items that have been deleted. This error has the following cause and solution:

  • You attempted to use the Recover or Purge command on an item that has not been deleted.

    If you are trying to recover a file or project, the file or project already exists in VSS. To view the file, use the View File command.


This command operates on only one item

For many VSS dialog box lists, you can select more than one item at once, and then act on all the items together. However, some actions cannot operate on more than one item at a time. This error has the following cause and solution:

  • You selected more than one item and then applied a command that operates on only one item at a time. For example, you may have tried to use the View command, which works with one file at a time.

    Press the space bar on an item to make it the only item selected in the list.


<Item> specifies a version number, which is illegal for this command

This command operates only on the most recent version of a file. This error has the following cause and solution:

  • You attempted to execute the command on an older version of the file.

    Select another command, or apply the command you've chosen to the most recent version of the file.


Invalid VSS syntax: <syntax>

See Also

The syntax you entered is invalid in VSS. This error has the following cause and solution:

  • You have entered a VSS file or project path that does not use valid syntax.

    In VSS syntax, every path starts with a dollar sign followed by a series of project names, which are separated by slashes and optionally followed by a file name. For example:

    • $/ is the root project.

    • $/Code is a subproject of $/.

    • $/Code/Win/Test.C is a file in the $/Code/Win project.

    Many parts of this syntax are optional. You can omit the dollar sign in most circumstances. You can also shorten the path by basing it on your current project; for example, if you are in $/Code, you can type WIN as a shorthand for $/Code/Win, Test.C for $/Code/Test.C, and ".." for the root.

File names can be any valid operating system file name, except for the following restriction that is specific to VSS. File names in VSS must not begin with a dollar sign ($), a semicolon (;), or a period (.), regardless of whether the operating system permits one or more of those characters.

Project names can include spaces and can be up to 256 characters long. Project names are not case-sensitive (for example, to VSS, Code and CODE are the same project).


Bad username syntax: <syntax>

This error has the following cause and solution:

  • You have entered a username with invalid VSS user syntax.

    Ask your VSS Administrator for your correct VSS username.


Invalid password

This error has the following cause and solution:

  • Your username/password combination is invalid.

    Re-enter the password. Because it does not appear on the screen, it is very easy to type it incorrectly. Note that the VSS password is case-insensitive. If you believe you have typed the password correctly and VSS doesn't recognize it, ask your VSS Administrator to change your username and password. If you have forgotten your password, the VSS Administrator can use Administrator to assign you a new one.


Cannot delete/rename/edit the Admin user

This error has the following cause and solution:

  • You attempted to delete, rename, or change the Admin user. The VSS Administrator must always exist in your VSS Administrator user list, although you should not use Admin as an actual user.

    However, you can change the Admin user's password used to log on to VSS Administrator.


Permission denied

This error has the following cause and solution:

  • You are attempting to take an action that you do not have the proper privileges to execute.

    Talk to your VSS Administrator. If you are the VSS Administrator, run VSS Administrator to check on or change your username, password, and access rights.


User <user> already exists

This error has the following cause and solution:

  • You attempted to add a user with a username that already exists. You may want to select another name; for instance, if there is already a Joyce, add JoyceF.

    Note that names are not case-sensitive, so if you already have a Joyce, adding JOYCE generates this error.


User <user> not found

This error has the following cause and solution:

  • Your username was not found.

    Talk to your VSS Administrator. If you are the VSS Administrator, run VSS Administrator to add your username.


File <File> has not been changed

This error has the following cause and solution:

  • You are attempting to check in a checked-out file that you have not changed.

    Click Yes, and VSS checks it in anyway. (Clicking Yes All checks in all selected files.) A checkin creates a new version of the file, with an optional comment.

    Click No, and VSS undoes the check out of the file. (Clicking No All undoes the check out for all selected files.) No new version of the file is created in this case.

Note To avoid this message on future occasions, disable this notification on the General tab that is accessed by selecting Options from the Tools menu.


The base URL for this Web project, '<Project>', has bad URL syntax

This error has the following cause and solution:

  • The URL that you entered for the base URL for a VSS Web project has bad URL syntax.

    Valid syntax for the URL is shown in these examples:

    http://www.microsoft.com/default.htm
http://www.microsoft.com

    You can change the URL in the Web Projects tab that is accessed by selecting Options from the Tools menu, or edit the URL in the SRCSAFE.INI file.


The URL for project <Project> was not set properly

This error has the following cause and solution:

  • You set a bad URL path for a Web project, or the URL uses a syntax that VSS does not understand (for instance, it might use www.microsoft.com/... instead of http://www.microsoft.com/...).

    Use the Administrator program to set a proper URL.


A link in <File> was ignored because it was too long

This error has the following cause and solution:

  • The URL is too long for the internal buffer.

    Use a shorter URL.


An error occurred while checking hyperlinks for <File>

This error has the following cause and solution:

  • The working folder path, VSS specification, or URL was too long.

    Check that you aren't exceeding path limits for folder, specification, or URL. Check that Htmlfilt.dll is still present on your system and registered properly (running the client installation again should fix this problem).


No HTML files were available in this project to check hyperlinks

This message has the following cause and solution:

  • This informational message tells you that no files were checked for Web hyperlinks because no HTML files were found.

    If you expected HTML files in this project, check that they were added properly and that you entered the correct project name.


Unable to load the HTML parser

This error has the following cause and solution:

  • You have a corrupted VSS installation. Either the DLL is gone or the registry isn't set to the right DLL.

    Install VSS again.


No VSS Database (SRCSAFE.INI) found. Use the SSDIR environment variable or run NETSETUP.

See Also

This error has the following cause and solution:

  • The SRCSAFE.INI file is missing. This may be the result of performing a client install, rather than a NETSETUP.

    Either do a NETSETUP or set the SSDIR environment variable.

Setting the SSDIR environment variable tells VSS where to find the SRCSAFE.INI file for the VSS server installation to which you want to connect. Do this by typing the following at the MS-DOS prompt:

set ssdir=\\server\share\vss

Where \\server\share\vss is the folder where the srcsafe.ini file is located.

Note Do not put a space between the equal sign and the location of the VSS server installation. The following will not work: set ssdir= \\server\share\vss.


Warning: the Rollback command will branch this file, breaking its link to other projects that share it

This warning has the following cause and solution:

  • This warning occurs when you roll back a file that has been branched or is pinned in another project.

    Click Yes to continue, or No to cancel.


Your free VSS trial expired 30+ days ago

Some VSS functionality has been disabled.

To comply with your license agreement and restore full VSS functionality, you must order a license.

To order Microsoft VSS or to receive a reseller referral in the United States or Canada, call 1-800-621-7930. Outside the United States and Canada, please contact your local Microsoft subsidiary.

If you choose not to order a licensed version of VSS, you must completely de-install VSS as you are in violation of your evaluation license agreement.


Your free VSS trial has expired!

To continue using Microsoft VSS, you must order a licensed copy. To order VSS or to receive a reseller referral, in the United States or Canada, call 1-800-621-7930. Outside the United States and Canada, please contact your local Microsoft subsidiary.

If you choose not to order a licensed version of VSS, you must completely de-install VSS as you are in violation of your evaluation license agreement.


You have <number> days remaining in your free VSS trial

To order Microsoft VSS or obtain a reseller referral in the United States or Canada, call 1-800-621-7930. Outside the United States and Canada, please contact your local Microsoft subsidiary.


An item with the name <name> already exists

See Also

Each item in a VSS project must have a unique name. This error has the following cause and solution:

  • You have attempted to name a file or an immediate child project with the same name as the project. (An item with that name can exist in other projects in the database, including subprojects.)

    To resolve this error, give the new item a different, unique file name. Or, you can delete or rename the existing item.

Note File and project names in VSS are not case-sensitive. For example, if you have a file named Test.C, you cannot create a subproject or file named "Test.c" or "test.c" in the same project.


Cannot move a project under itself

See Also

A project cannot be a project of itself. This error has the following cause and solution:

  • You attempted to create an invalid loop in your project hierarchy, for example, moving the project $/Word under the project $/Word, or, more subtly, moving $/Word under $/Word/Apps. This creates an endless recursive loop, which causes this error.

    Restructure your project hierarchy so that there is no invalid loop.


File <File> does not retain old versions of itself

See Also

This message has the following cause and solution:

  • When you check in a file, VSS retains both the current version of the file and the information required to rebuild past versions. You have turned off the historical version storage for this file.

    If you explicitly turn off this change information in the Properties dialog box or when using the Add Files command, VSS can give you the most recent version, but it cannot rebuild old versions.


An older version of File <File> cannot be shared because only its latest version is stored

This error has the following cause and solution:

  • You've tried to share an old version of a file. VSS only stores the latest version of a file.

    You can share only the most recent version of a file.


File not checked out by you

See Also

Some VSS operations can only be performed on a file that is checked out. This error has the following causes and solutions:

  • You attempted to check in or undo a check out on a file that you did not have checked out.

    Check out the file before checking it in. If you have made changes to a file, see the Advanced options in the Check Out dialog box, and then under Replace Writable, select Skip to check out the file to you without replacing the changes in your working folder.

  • You attempted to perform an operation that can only be performed on a file that is checked out.

    Check out the file.


File or project not found

See Also

VSS is looking for a file or project that does not exist. This error has the following causes and solution:

  • You mistyped the file or project name, or specified a file or project that does not exist.

  • The VSS database is corrupted.

    Try retyping the name or select the name from the list in VSS Explorer. If you suspect database corruption, run the Analyze.exe utility.


Parent not found

This error has the following cause and solution:

  • Database corruption is indicated.

    Ask your VSS Administrator to run Analyze.exe to find and correct the problem. If that fails, call Microsoft Technical Support for help with recovering the database.


File <File> has been destroyed, and cannot be rebuilt

See Also

VSS may not be able to reproduce the file you requested. This error has the following cause and solution:

  • You permanently destroyed a file or moved the file to another location. For example, there may have been a file in a project that you deleted or purged. Later, you attempt to go back to an earlier version of the project. VSS attempts to reconstruct the project exactly as it was in the past, but it cannot, because the file cannot be recovered.

    Click Yes, and VSS tries to restore the old file, but restoration is not guaranteed.

    Click No, and the attempt to restore an old file is halted.

    Click Yes All, and VSS does not notify you that other selected files may also be unrecoverable, but continues with the best possible reconstruction.


Project <Project> has been destroyed, and cannot be rebuilt

See Also

VSS may not be able to reproduce the project version you requested. This error has the following cause and solution:

  • You permanently destroyed a subproject or moved the subproject to another location. For example, there may have been a subproject that you deleted or purged. Later, you attempt to go back to an earlier version of the project. VSS attempts to reconstruct the project exactly as it was in the past, but it cannot, because the subproject cannot be recovered.

    Click Yes, and VSS tries to restore the old project version, but restoration is not guaranteed.

    Click No, and the attempt to restore an old project version is halted.

    Click Yes All, and VSS does not notify you that other selected subprojects may also be unrecoverable, but continues with the best possible reconstruction.


Version not found

See Also

The version specified cannot be found. This error has the following causes and solutions:

  • You specified a version that does not exist.

    In VSS, click the Show History command on the Tools menu, and then select a version from within the History of File dialog box.

  • If you are using VSS from the command line, you may not be using the -V switch properly.

    Search online Help for more information on using the parameter correctly (click the Contents button).


This command only works on files

This command can operate only on files. This error has the following cause and solution:

  • You are attempting to perform a file operation (such as using the View command) on a project.

    Select the proper command, or select a file that works with the command you've chosen.


This command only works on projects

This command can operate only on projects. This error has the following cause and solution:

  • You are attempting to perform a project operation (such as the Move Project command) on a file.

    Select the proper command, or select a project that works with the command you've chosen.


Destroy cannot be undone; information will be lost permanently!

See Also

This warning has the following cause and solution:

  • When you use the Destroy command on a file or project, the action is not reversible.

    Click Yes to continue with the Destroy operation. Click No to cancel the operation.

Note If you do not want to receive this message every time you destroy a file or project, you can disable it on the Warnings tab in the SourceSafe Options dialog box on the Tools menu.


Purge cannot be undone; information will be lost permanently!

See Also

This warning has the following cause and solution:

  • When you purge a file or project, the action is not reversible.

    Click Yes to continue with the Purge operation. Click No to cancel the operation.

    If you do not want to lose the file or project permanently, use the Delete command instead.

Note If you do not want to receive this message every time you delete a file or project, you can disable it on the Warnings tab in the SourceSafe Options dialog box on the Tools menu.


Delete all specified items?

See Also

This warning has the following cause and solution:

  • You are about to delete a file or project.

    Click Yes, and VSS deletes the file or project.

    Click No, and VSS does not.

    Use the Recover command to undo Delete.

Note If you do not want to receive this message every time you delete a file or project, you can disable it on the Warnings tab in the SourceSafe Options dialog box on the Tools menu.


Rollback cannot be undone; some versions will be lost irretrievably!

See Also

This warning has the following cause and solution:

  • You are about to roll back a file to an earlier version. The Rollback command is not reversible.

To make the old version the most recent version without losing all the versions in between

  1. Check out the file.

  2. Delete the local copy.

  3. Get the version you want to roll back to.

  4. Check that version into VSS.

Note If you do not want to receive this message every time you roll back a file, you can disable it on the Warnings tab in the SourceSafe Options dialog box on the Tools menu.


<File> has changed. Undo check out and lose changes?

See Also

This warning has the following cause and solution:

  • You are about to undo the check out of a file. If you do so, you discard all the changes made since you checked out the file.

    If you want to put your changes into VSS instead of losing them, use the Check-In command instead.

Note If you do not want to receive this message every time you undo a file check out, you can disable it on the Warnings tab in the SourceSafe Options dialog box on the Tools menu.


<File name> has been automatically renamed to <file name> in project <Project> to match the current file name in the database.

This message is informational only. It was caused by an archive command.


Checkouts for <path> (<user>) deleted

This is an informational message by archive that some check outs have been removed. You can re-check out any files at any time.


Version <number> to <number> of <item> are in <archive file>. No action taken.

This error has the following cause and solution:

  • You are attempting to remove a version range which VSS cannot locate (perhaps it has already been archived).

    Determine the valid version range, then archive that.


<File> already exists in project <Project name>, and is not the same as the archived file. No restore possible.

This message has the following cause and solution:

  • You're attempting to restore a file into a database different from the database you archived it from, and there is already a file of the same name present.

    Either keep the existing file, delete, or rename it, and then run SSRESTOR.


Name information for offset <number> not found in archive file. Name will be truncated to <name>.

This message has the following cause and solution:

  • For maintenance reasons, VSS crops long file names to shorter file names. The long file name information was lost for this particular file or project, so VSS will now refer to it by its short name.

    To remedy this, rename the file or project to its original long name.


Parent <Project> for file <File> (<VSS Database File>) does not exist. The file might be corrupted. This parent will be skipped.

This message has the following cause and solution:

  • While Analyze was processing this file, a record of one of the projects it was shared into, or files it was branched from, could not be found.

    This is an informational message only. No action is necessary.


<VSS File> (<database file>) is a branch parent for a file which is not being archived. No versions deleted.

This message has the following cause and solution:

  • This is an informational message only, generated while performing an Archive. Archive did not delete a file you asked it to, because it contains a portion of history for a file which is branched elsewhere and still active.

    If you need to delete the file, you'll need to track down all branches of the file (via the Paths tab on the Properties dialog box), then tell Archive to delete all branches of the file, too.


Not all options could be set correctly.

This error has the following solution:

  • In most cases, options cannot be set correctly due to low memory or disk space. Free some memory or disk space and try again.


Out of memory; could not complete operation.

You do not have sufficient computer memory to perform the desired operation. This error has the following causes and solutions:

  • You have too many applications, documents, or source files open.

    Close any unnecessary applications, documents, or source files that are open.

  • You are running Microsoft Windows in standard mode.

    Restart Microsoft Windows in enhanced mode.

  • You are running Microsoft Windows in enhanced mode, but have run out of virtual memory.

    Increase virtual memory by freeing some disk space, or ensure that some space is available.

  • You have terminate-and-stay-resident programs running.

    Eliminate terminate-and-stay-resident programs.

  • You have many device drivers loaded.

    Eliminate unnecessary device drivers.


Lock SourceSafe Database Command (Tools Menu)

See Also

Allows you to lock all users out of the VSS database while you run a utility, upgrade the executables, or back up the database.

Access Rights

You must have Administrator permission to use this command.

Remarks

Use this command if you need to archive, back up, or run a VSS utility on the database. Note that the act of selecting the check box in the Lock SourceSafe Database dialog box is what actually locks users out. After this box is checked, no one will be allowed to log into the database. The users listed, who are already logged in, will be unaffected [image] you will need to notify them manually to log out.


Options Command (Tools Menu)

See Also

Enables you to customize the VSS environment for all users.

Remarks

Click the tab with the information you want. Each tab contains groups of options you can set to alter VSS's behavior in certain situations. The tabs in the SourceSafe Options dialog box change the behavior for all users in VSS Administrator's user list. (Individual users can override some settings by using the Options command on VSS Explorer's Tools menu.)

Dialog Box Tabs

General

Sets general options applicable to a number of commands in VSS.

Project Security

Sets security options, such as whether project security is enabled, and the default user rights assignment.

Web Projects

Designates a project as a Web project.

Web

Sets how certain Internet information is transmitted for Web projects.

File Types

Sets how file type information is determined for all users.


Exit Command (File Menu)

Exits VSS.

Access Rights

Any VSS user can use this command.


Edit File Command (Edit Menu)

See Also

Allows you to edit a source-controlled file by ensuring that it is checked out and then opening the file in the associated editor.

Access Rights

You must have Write permission to use this command.

Remarks

When you select Edit File, VSS first checks to be sure you have the file checked out. If you do not, the file is checked out to you unless something prevents this, such as the file being already checked out by another user (when your VSS administrator has not enabled multiple check outs for that project).

After the file is checked out to you, VSS opens the file. You can select an editor by clicking the Advanced button on the File dialog box.

The default editor is selected by one of the following means, in the following order:

  1. VSS looks in its initialization files for a line with the extension of the file being viewed.

  2. VSS uses Microsoft Windows Explorer (the registration database and Win.ini) to associate an application with the file extension.

  3. VSS looks for your entry in the File Viewer option on the General tab in the SourceSafe Options dialog box.

  4. If VSS cannot determine a file association after using these methods, it displays the file using its own editor.

Note If no editor can be found for a specific file type, the file will remain checked out to you in your working directory, so you can open the file normally with the editor of your choice.

You can also set the double-click behavior of VSS on the General tab of the Tools Options dialog box. Setting the Double-click on a file option to Edit File will allow you to double-click on a file in VSS to edit it; however, setting the option to Ask is recommended (so you don't accidentally write over a local file during the check out operation).


Invert Selection Command (Edit Menu)

Selects all files not currently selected, and deselects currently selected files.

Access Rights

Any VSS user can use this command.

Remarks

The Invert Selection command reverses the selection status of each file currently displayed in the VSS Explorer file list. The command can be useful when you have performed one operation on all the selected files, and want to perform another operation on the remaining files.


Select Command (Edit Menu)

See Also

Selects one or more files to perform operations on. The file pane of VSS Explorer must be active for this command to be available.

Access Rights

Any VSS user can use this command.

Remarks

The Select command opens a dialog box into which you can type the name of a single file, multiple file names separated by semicolons (;), or the names of multiple files using wildcard characters.

Dialog Box Options

Item

Type the name of a single file or the names of multiple files. To select all files in the file list, type *.*; to select all files with the .rtf extension, type *.rtf, and so on. Use the semicolon (;) as a delimiter between file types you want included in the selection, for example "*.rtf; *.exe".

Select

Selects the file.

Deselect

Clears the selection of a file.

OK

Confirms the selection.

Cancel

Cancels the operation, closes the dialog box, and returns to VSS Explorer.


Select All Command (Edit Menu)

See Also

Selects all files currently displayed in the file pane of VSS Explorer so that you can perform a group operation on all the files.

Access Rights

Any VSS user can use this command.


View File Command (Edit Menu)

See Also

Shows the text of the master copy of the file in VSS. To view an earlier version of a file, click the View button in the History of File dialog box on the Tools menu. To view a file before sharing it to your current project, click the View button in the Share dialog box.

Access Rights

You must have the Read access right to use this command.

Remarks

The View File command opens and displays a VSS master copy of a file using the editor associated with that file. You can also select an editor by clicking the Advanced button on the File dialog box. Viewing a file does not change anything in either the VSS database or your working folder.

The associated editor is selected by one of the following means, in the following order:

  1. VSS looks in its initialization files for a line with the extension of the file being viewed.

  2. VSS uses Microsoft Windows Explorer (the registration database and Win.ini) to associate an application with the file extension.

  3. VSS looks for your entry in the File Viewer option on the General tab in the SourceSafe Options dialog box.

  4. If VSS cannot determine a file association after using these methods, VSS displays the file using its own editor.


Options Command (Tools Menu)

See Also

Enables you to customize your VSS environment.

Access Rights

Any VSS user can use this command.

Remarks

Click the tab with the information you want. Each tab contains groups of options you can set to customize VSS.

Dialog Box Tabs

General

Enables you to set general options applicable to a number of commands in VSS.

Local Files

Configures working folder files and how they are treated during the operation of different commands.

View

Sets viewing options, such as whether or not to show the toolbar or status bar, and file list options.

Difference

Allows you to specify options for viewing differences between files and projects. These options are used in other VSS dialog boxes such as the Project Difference dialog box and the Visual Merge dialog box.

Command Dialogs

Configures the display of intermediate dialog boxes related to several VSS commands. These intermediate dialog boxes usually present you with additional options.

Warnings

Determines when warning messages are displayed.

File Types

Sets how file type information is determined.

Command Line

Customizes how some command-line commands work.


Open SourceSafe Database Command (File Menu)

See Also

Allows you to switch between VSS databases.

Access Rights

You must have the Read access right to use this command.

Remarks

Use this command if you regularly need to access different VSS databases. You need access permissions both on the server storing the database and in the database you are trying to access. When you use this command, the current VSS database is closed and the newly specified one is opened.

You can give each database an easy-to-remember name, and each time you connect to a new database it is added to the list in the Open SourceSafe Database dialog box.

Note If you used Visual SourceSafe version 4.0 with multiple databases, you may have used the old initialization variable method of switching between databases. In most cases, each separate database will have its own SRCSAFE.INI file, and you can use the Browse button once to find each database and add it to your database list, and then use the Open SourceSafe Database command from then on.

If you don't have a SRCSAFE.INI for one database, create a SRCSAFE.INI file for that database. Put this SRCSAFE.INI file in the directory immediately above the DATA directory.


Help Menu Commands

The Help menu commands provide Help on using VSS and Help on specific VSS commands. In addition, you can press F1 at any time to view Help on the currently selected menu item or dialog box.

Help command | Action
Contents | Runs Help and displays the VSS Table of Contents.
Search For Help On | Displays the Help Search dialog box so you can quickly find the information you want.
Technical Support | Displays information about Microsoft Product Support Services.
About Microsoft Visual SourceSafe | Displays a dialog box with information about your copy of Microsoft VSS, including the version number and the copyright, legal, and licensing notices.

Access Rights

Any VSS user can use these commands.

Remarks

A quick way to find information is to use Search, an automated index with hundreds of index entries and extensive cross-referencing.

You can also look for Help topics in the VSS Table of Contents.

As you read a topic in VSS Help, you can scroll through the topic with the scroll bar, the arrow keys, or the PAGE UP and PAGE DOWN keys.


Technical Support

Getting Help from Microsoft Technical Support

If you can’t find the answers you need in the product Help file or manual, you can resolve problems quickly through one of several options.

Note The services and prices listed here are available in the United States and Canada only and are subject to change without notice. Support outside the United States and Canada may vary. Contact the Microsoft subsidiary nearest you, using the Worldwide Subsidiary list in this product Help file.

Support Online

Standard No-Charge Support

Pay-Per-Incident Support

Web Response

Additional Support

Support Outside the United States and Canada


Show Differences (File) Command (Tools Menu)

See Also

Compares two files, then shows you the differences, if any.

Note If you want to show differences among projects, select a project in the project pane of VSS Explorer, then click Show Differences.

Access Rights

You must have the Read access right to use this command. You should have a working folder set before using this command.

Remarks

Most commonly, the Show Differences command is used before checking in a file to compare your copy of the file to the master copy in VSS. This gives you a list of the changes you have made, which can be helpful for generating your comment.

When you use the Show Differences command on an ASCII text file, VSS displays a color-coded list of line differences between the respective files.

For binary files, VSS identifies differences, however, it cannot display the differences.

Note It is also possible to compare two earlier versions of a file to each other or to compare an earlier version to the current version. To do so, select the two versions in the History of File dialog box, and then click Diff.

Dialog Box Options

Note Enable the display of the Show Differences dialog box on the Tools menu, SourceSafe Options dialog box, Command Dialogs tab.

By default VSS uses the Visual Difference dialog box. If you specify a UNIX display, VSS uses the VSS display options for Ignore Case and Ignore White Space. The VSS display option has line widths calculated to fit on your screen, and no context lines.

Compare / To

If you are performing a routine file difference, by default the Compare field will contain the file in VSS and the To field will contain its counterpart in the working folder. You can edit the Compare field, or you can click the Browse button to specify your selection. Using the Browse buttons, you can also compare two files in VSS (in the same project or other projects), two local files (in the same directory or different directories), or a file in VSS and a local file.

Visual

Shows the entire file, with annotations for the changes.

SourceSafe

Shows a simple list of lines that were added, deleted, and changed, optimized for readability.

UNIX

Shows differences in the format used by the UNIX Diff utility.

Ignore White Space

Shows differences without regard for spacing characters, such as tabs.

Ignore Case

Shows differences without regard for upper- and lowercase.

Only show this dialog when the shift key is down

If this box is checked, the Show Differences dialog will only be displayed if you hold down the Shift key while executing the Show Differences command.

OK

Executes the Show Differences command.

Cancel

Cancels the Show Differences command.

Report

Sends a report to the clipboard, a text file, or to a printer.

Advanced Options

Ignore OS Differences

Specifies that VSS ignore operating system line-break character differences. This is useful if you are comparing files across a network where one computer is a Macintosh, for example, and the other is operating using Microsoft Windows NT.

Show Context Lines

Includes the specified number of context lines in the difference display. Context lines are the lines in your file surrounding the line identified as different by VSS. For example, setting Show Context Lines to three means you'll see three context lines above and three context lines below the difference line.

Note This option will be ignored if you're using Visual Difference.

Save Settings

Saves your selected settings for future use.


Show History Command (Tools Menu)

See Also

Shows the history of a file or project in VSS.

Access Rights

You must have the Read access right to use this command.

Remarks

Every time you check in a file or project to VSS, the file or project is considered a new version. Use the Show History command to display a list of the past versions of a file or project.

The versions are listed starting with the most recent and going back to the creation of the file or project. VSS provides information about the version number, which can be used with other commands (such as Get Latest Version ) to indicate a specific version.

By default, the history of a project includes the histories of all its files, but does not include subprojects.

You can compare one version of a file with another by selecting the two versions simultaneously (hold down the CTRL key and click each version), then clicking Diff.

Dialog Box Options

Note Enable the display of this dialog box on the Command Dialogs tab in the SourceSafe Options dialog box on the Tools menu.

Include files (project history only)

Includes files in project history.

Recursive (project history only)

Includes subprojects and all files within them.

Labels Only

Includes only labels in project history.

From

Type a time, date, version, or label. Use the prefix D to indicate a date and/or time, and the prefix L to indicate a label. For example "D02/29/95;12:15" or "Lbeta1". Dates can be entered in 08.15.97, 08-15-97, or 08/15/97 format, but not as August 15, 1997. Note that if you have a project selected to see the history on, you cannot search for file labels [image] you must select the file and use the Show History command to find a specific label.

To

Type time, date, version, or label. Use the prefix D to indicate a date and/or time, and the prefix L to indicate a label. For example "D02/29/95;12:15" or "LBeta1". Dates can be entered in 08.15.95, 08-15-95, or 08/15/95 format, but not as August 15, 1995.

User

Shows a history of files worked on by the specified user.

OK

Displays the History of Project or History of File dialog box, depending on whether a file or project is selected in VSS Explorer. In these dialog boxes, click any of the items in the list, and then click Details to display the History Details dialog box. From within the History Details dialog box, you can click the Next and Previous buttons to move up and down in the history display. You can also edit the comment and label associated with the version you are viewing.

Skip This Dialog

Skips this dialog box during future Show History operations, and uses the settings you've entered as the default. To restore the dialog box, select the appropriate check box on the Command Dialogs tab of the Options dialog box.


Properties Command (File Menu)

See Also

Displays the Properties dialog box, which contains basic information about a VSS file or project, including the size, name, and type.

Access Rights

You must have the Read access right to view the Properties dialog box.

You must have the Add access right to change the type of a file.

You must have the Destroy access right to change the Store Only Latest Version state of a file.

Remarks

Click the tab with the information you want. Tab content differs according to whether a file or project is currently selected in VSS Explorer.

Note Click the Report button on any of the tabs to create a report to send to the clipboard, a text file, or a printer.

File Properties Dialog Box Tabs

General

Shows the file name, type, size, latest version number, last modification date, comment, and whether the entire file history is stored in the VSS database (or just the latest version). You can change the comment and set whether or not to store only the latest version of the file to save disk space. You can also change the file type here.

Check Out Status

Shows the file's name, who it is checked out by (if anyone), whether it is exclusively checked out, when it was checked out, the version that is checked out, the computer it's checked out to, the check out path, the project the file is in, and the check out comment. You can change the check out comment.

Links

Shows the current share links a file has to other projects.

Paths

Shows which projects have branched versions of this file in the past.

Project Properties Dialog Box Tabs

General

Shows the name of the current project, the number of files and subprojects it contains, the latest version number, when it was last changed, whether the project is cloaked, and the comment for the project. You can change the comment.

Deleted Items

Shows the files that have been deleted from the project since it was added to VSS. Use this dialog box to recover or purge a deleted file.


Show Differences (Project) Command (Tools Menu)

See Also

Compares a VSS project with another VSS project, a VSS project with a Windows folder, or two Windows folders, then shows the differences, if any. You can also see individual line differences in differing files, and reconcile differences between the projects.

Note If you want to show differences between a file in your project and that file in another VSS project or a Windows folder, select a file in the file pane of VSS Explorer, and then click Show Differences.

Access Rights

You must have the Read access right to use this command.

Remarks

The Show Differences command on a project generates a two-paned dialog box that lists the differences between a VSS project and another VSS project, a VSS project and a Windows folder, or two Windows folders. Before the lists of files are displayed, a command dialog box comes up that allows you to filter the file list if you'd like, so you can limit reporting to the files that interest you.

A common use of this command is to find the files another user has deleted from the project, so you can delete them from your working folder. It can also be useful if you take a project home for a while, to see if any project-level changes have been made.

If you are comparing a VSS project and a Windows folder, you can reconcile differences between the two projects in several ways. For example, you can get or check in all files that are different in each respective project, or you can also add missing files.

Project Difference Dialog Box Options

Note Enable the display of the Show Differences dialog box on the Tools menu, SourceSafe Options dialog box, Command Dialogs tab.

The options in this dialog box are not mutually exclusive [image] they can be combined to filter the file lists in each pane. Each one of the check boxes below potentially adds more files to the lists in each pane.

Compare / To

If you are performing a routine project difference, by default the Compare field will contain the project in VSS and the To field will contain its counterpart in the working folder. You can edit the Compare field, or you can click the Browse button to specify your selection. Using the Browse buttons, you can compare two projects in VSS (in the same project or other projects), two local projects (in the same directory or different directories), or a project in VSS and a local project.

Show files that are only in the project

Includes, in the left pane, project files that are not currently in the working folder. This option is selected by default.

Show files that are only in the working folder

Includes working folder files that are not currently in the VSS project. This option is selected by default.

Show files that are different in both places

Includes all files that are in both the working folder and VSS project, but are different from each other. Most often for these files, you need to get the file to update the version in your working folder. This option is selected by default.

Show files that are the same in both places

Includes files in both projects that are the same in both places. This option is selected by default.

Recursive

Scans the contents of either the current project or Windows folder and all its subprojects; shows all differences between the two respective projects or Windows folders.

Only show this dialog when the shift key is down

If this box is checked, the Show Differences dialog will only be displayed if you hold down the Shift key while executing the Show Differences command.

OK

Executes the Show Differences command.

Cancel

Cancels the Show Differences command.


Search Command (View Menu)

See Also

Filters the file list in VSS Explorer to search for checked-out files whose names match a specified pattern or string. Search finds one or more specified files in your project list and limits the file list display to those files.

Access Rights

You must have the Read access right to use this command.

Remarks

A status search can be used to find only the files checked out by a specific user. When a file is shared among multiple projects, the Search command shows you which projects the file is checked out to.

Tip Press SHIFT+CTRL+S to search for all checked-out files in the current project. The Search dialog box is not displayed.

Search for Status Dialog Box Options

Display all checked out files

Shows all checked-out files, no matter who has them checked out.

Display files checked out to

Click this button and type a username if you want to see files checked out only by that user, instead of all checked-out files. You can also select usernames from the drop-down list. To see all checked-out files, select <All Users>.

Search Area

Specify which projects/subprojects you want to be included in the search. You can search the current project only, the current project and all its subprojects, or all projects in the database.

Search for Wildcard Dialog Box Options

Wildcard

Type a file name or string with wildcard characters; for example, file.*.

Search Area

Specify which projects/subprojects you want to be included in the search. You can search the current project only, the current project and all its subprojects, or all projects in the database.

Note If you clear the Wildcard boxes simultaneously, the search is cancelled. Also, if you enter * or *.* in the Wildcard box, and the Search in all Projects box is clear, the search is cancelled.

Remember that the VSS wildcard search is really a filtering operation. You are searching for those files in the current project that match specified criteria. Entering *.* in the Wildcard box effectively removes any filtering criteria; therefore the search is cancelled.


Font Command (Tools Menu)

Changes the font used in either the VSS Explorer or VSS Administrator.

Remarks

You set the font name, style, and size for VSS in the Font dialog box. The Sample box displays a preview of the currently selected font.

The font setting does not affect the font used in the file difference viewer. To set those options, use the Difference Options tab.


Set Working Folder Command (File Menu)

See Also

Sets your working folder.

Rights

Any VSS user can use this command.

Remarks

After creating a new project, it is important for you to designate a working folder in which to work on the project's files. If you do not, VSS prompts you for a working folder whenever you use a command that requires one to be set.

You can use an existing folder on your computer's hard disk as your working folder. You can also create a new folder from within VSS or Windows.

If you just click OK, this command temporarily sets the working folder for the project. The setting is saved after you close VSS. If you clear the Save as Default for Project check box, the folder is not saved as your default working folder for the current project.

Dialog Box Options

Name

Name and path of working folder.

Folder

Your current working folder.

Folders

Specifies a folder for the working folder.

Drives

Selects the drive that contains the working folder.

OK

Confirms selection.

Cancel

Cancels the selection, closes the dialog box, and returns to VSS Explorer.

Create Folder

Creates a new folder for the working folder. Type a new folder name in the Name box, then click Create Dir to create the folder.

Save as Default for Project

Saves the folder you specify as your default working folder for the project.


Sort Command (View Menu)

Sorts the file list in VSS Explorer. Sort order options are by file name, type, user, date, or check out folder.

Access Rights

Any VSS user can use this command.

Remarks

The file list in VSS Explorer is usually sorted by file name. You can change the sort order:

  • Name (file name)

  • Type (file type extension)

  • User (usernames of users who have files checked out)

  • Date [image] Time

  • Check Out Folder

Type, Name, User, and Check Out Folder sort in ascending order; Date [image] Time sorts in descending order, so that the most recent files are on top. The current sort order is always displayed in the status bar.


Cancel Search Command (View Menu)

See Also

Restores the full file list in VSS Explorer for the current project. This command is used after a search operation, which usually filters the file list to a smaller subset.

Access Rights

Any VSS user can use this command.

Remarks

When you execute the Search command, VSS displays the word Search in the status bar. Click the Cancel Search command to return to the full VSS Explorer file display. The word Search disappears from the status bar.


Refresh File List Command (View Menu)

See Also

Refreshes the file list in VSS Explorer.

Access Rights

Any VSS user can use this command.

Remarks

Refreshes the file list only, not the project list. To refresh both lists, collapse the project list to a parent project, then double-click that project to expand the project list.

You can refresh the file list automatically. Set the timing with the Automatically Refresh File List option on the View tab in the SourceSafe Options dialog box on the Tools menu.


Check Web Links (Web Menu)

Check Hyperlinks (Web Menu)

See Also

Allows you to check Web links in your HTML files.

Access Rights

You must have the Write access right to use this command.

Remarks

You can use this command to check Web links in your HTML files, either the files in your working folder or in a VSS project. VSS only checks the links that jump to other files in your project [image] links to external pages are not checked.

Links checked are those referred to with HTML <A HREF>, <IMG SRC>, and <OPTION VALUE> tags. Links to other Web addresses created using code, such as VBScript or Java, are not checked.

When the link check is complete, VSS displays a dialog box with three list boxes. The top box lists all files in which errors were found. The middle box lists the internal links (jumps to other files within the Web project) which appear to be invalid in the selected file in the top box, and the bottom box lists the external links that were found but not checked.


Create Site Map (Web Menu)

See Also

Allows you to automatically create a map of the HTML files in a Web project.

Access Rights

You must have the Write access right to use this command.

Remarks

Site maps are becoming more popular as methods of navigating through a Web site. This command lets you easily generate a list of the HTML files in your Web project, and creates the list as an HTML file with links to each file. With some minor customization, you can then add the resulting file to your Web site and provide your users with a classic method of navigation.

Each time you run this command, a totally new file is created. That is, this command does not compare new material to old and just make the changes. So, if there is some customization you have added to the resulting site map file, you should be prepared to add it again each time you run this command, or to use technology such as server-side include files to store it in a separate place. Also, the HTML generated by this command is fairly rudimentary [image] HTML 2.0 tags. If you want a more customized page, you can cut and paste from the HTML provided by this command, or add HTML tags to the file to make it fit into your Web site better.

The Create Site Map command works by getting the titles of your HTML files from their <TITLE> tag. If you have an HTML file without a <TITLE> tag, VSS will use its file name. To build a good site map, you should use descriptive, unique strings in the <TITLE> tags of your files. Category names in the site map file come from the VSS project name. Therefore, it is important for you to use good, descriptive project names in Web site projects.

Once the HTML site map file is created, you can add it into your project by using the Add Files command. If you add the file to your Web site project, be sure to check it out before running the Create Site Map command.

As an example, consider an external Web project that looks like this:

Running Create Site Map on the external Web project creates an HTML file that displays like this in a Web browser:

Using this HTML:

Of course, at this point, you can customize the HTML to make your site map look like anything you want [image] use a different background color or pattern, change indentation levels, delete or add items, and so on. One way you can customize the site map is to change the graphics files used for the folder and file icon. For more information on doing this, see the IMG_Folder and IMG_File initialization variables.


Deploy Command (Web Menu)

See Also

Allows you to deploy a set of Web files to a Web server, or multiple Web servers. This command works only on projects, not files.

Access Rights

You must have the Destroy access right to use this command.

Remarks

When you have completed development and testing of your Web pages, the Deploy command is used to copy your files to the live Web server. The location of this server is a folder or FTP site specified by your VSS administrator. When you choose the Deploy command, the contents of your current project are copied to that location.

In many respects, Deploy acts like the Get command: it copies files from a VSS project, to a local folder. However, Get makes a copy for your personal use; Deploy makes the project public, potentially to the entire world. For this reason, the Deploy command requires Destroy-level privileges in the selected project.

Your VSS administrator must set a deployment path in the Web Sites tab of the Administrator Tools Options menu to enable this command. You can deploy only an entire project marked as a Web site project, not single files. The deployment folder can be a comma-delimited set of places you want your files copied to.

When used, the Deploy command overwrites existing files with the same name in the deployment folder, even if you have the Replace Writable files check box of the Tools Options Local Files tab set to Skip.

Note that this command is useful in many instances other than Web site deployment; for example, if you have a set of product specification .doc files that you want to publish to a public server.


About Visual SourceSafe Command (Help Menu)

About VSS (Help Menu)

Displays a dialog box with information about your copy of Microsoft VSS, including the version number, the platform type, and the copyright, legal, and licensing notices.

Click OK to close the dialog box.


Add File Group Dialog Box

See Also

Adds a new file group to the File Types tab in the SourceSafe Options dialog box (Tools menu).

To display the Add File Group dialog box:

  • On the Tools menu, click Options, and then click File Types. Click the Add button.

Dialog Box Options

Name

Type the name of the file group as you would like to identify it in the file group list on the File Types tab.

OK

Adds the file group.

Cancel

Cancels the Add File Group command.


Add Files Command (File Menu)

See Also

Copies a file, or group of files, into the current VSS project. In the Add Files dialog box, you can specify a file on any drive and folder, and that file is copied into the current VSS project.

Access Rights

You must have the Add access right to use this command.

Remarks

You can use the Purge command to undo an Add Files operation, but it is not recommended because it does not retain a recoverable copy of the file in the VSS database. Instead, consider using the Delete command, because it retains a recoverable copy of the file.

Dialog Box Options

File Name

Select or type the name of a file you want to open. This box lists items with the file name extension selected in the List Files of Type box.

List Files of Type

Lists the file type, or tells VSS how to classify a file.

The list of file types available is determined by the File Types Included In File Group filter and the File Groups filter set on the File Types tab in the SourceSafe Options dialog box. All Files (*.*) lists all files in the current folder.

Folders

Specifies the folder that contains the file you want to add.

Drives

Selects the drive that contains the file you want to add.

Close

Closes the dialog box without adding the file to the project.

Add

Opens the Advanced Comment dialog box allowing you to add the selected file(s) or folder to the selected project. The Advanced Comment dialog box displays a comment box in which you can enter comments (optional). Select the Apply same comment for all box to use the same comment for all the files you are adding. Click Advanced from the Advanced Comment dialog box for more options.

View

Displays the selected file with the View File command.

Apply same comment for all

Uses the same comment for all files involved in the Add Files operation. If this check box is cleared, you can enter a separate comment for each file. The default is selected (your comment is applied to all files selected for this operation).

Recursive

Indicates you want files in all subfolders added when you select an entire folder to add. Available only when you select a folder and then click Add.

Advanced Options

Store Only Latest Version

Indicates you do not want to save old versions of the file(s) being added to the VSS database. VSS keeps a file history of change records with comments. However, the older versions of the file are not stored, and you cannot recover them.

Note To increase performance and save disk space, use this option when storing executable programs in VSS.

Check Out Immediately

Checks out the file to you immediately after adding it to VSS.

Remove Local Copy

Deletes the file from your working folder after adding it to VSS.

File Type

Select an option from the list box:

  • AutoDetect [image] VSS determines the file type.

  • Binary [image] VSS treats the file as a binary file.

  • Text [image] VSS treats the file as a text file.

Note When you are adding a folder, the File Types field is ignored. However, the files added during a folder Add Files operation are filtered by the Relevant_Masks setting on the File Types tab in the SourceSafe Options dialog box.


Add Assignment for User Dialog Box

See Also

Changes access rights for the user selected in the user list.

To display the Add Assignment for User dialog box:

  1. On the Tools menu, click Rights Assignments for User.

  2. In the Rights Assignments for User dialog box, click Add Assignment.

Remarks

To assign or change access rights for the selected user, under Project, select a project in the project list, and then click the User Rights check box with the level of access rights you want to assign.

Note To use the Add Assignment for User dialog box, you must first select Enable Project Security on the Project Security tab in the SourceSafe Options dialog box on the Tools menu.

Dialog Box Options

Project

Project list for the current VSS database.

User Rights

Specifies the level of access rights [image] Read, Check Out, Add, or Destroy [image] held by the user in the selected project.

OK

Confirms selections.

Cancel

Cancels selections and returns to the Rights Assignments for User dialog box.


Add Users Command (Users Menu)

Add User Command (Users Menu)

See Also

Adds a new user to VSS Administrator's user list.

Remarks

The username and read-only access rights can be changed later with the Edit Users command, and the password can be changed with VSS Administrator's Change Password command. Users can also change their own passwords using VSS Explorer's Change Password command.

Dialog Box Options

User Name

Type the valid username of the user you want to add to the system.

Password

Type an optional VSS password. As you type, the characters are displayed as asterisks.

Read Only

Assigns the Read access right. Select if you don't want the user to have Read/Write access rights.

OK

Adds the user.

Cancel

Cancels the Add Users command and returns to VSS Administrator.


Rights Assignments for User Command (Tools Menu)

See Also

Displays and changes project access rights to the VSS database explicitly assigned to the user selected in the user list.

Remarks

Default user access rights are assigned to each new user under default security or on the Project Security tab in the SourceSafe Options dialog box on the Tools menu.

Note To use the Rights Assignments for User command, you must first select the Enable Project Security check box on the Project Security tab in the SourceSafe Options dialog box on the Tools menu.

The Rights Assignments for User dialog box displays only those access rights assignments that were explicitly changed; the effect of rights propagation is not shown. To see the propagation of access rights, use the Rights by Project command on the Tools menu.

Dialog Box Options

User Rights

Specifies the level of access rights [image] Read, Check Out, Add, or Destroy [image] held by the user in the project selected under Projects. To change these assignments, click the project you want and then select the appropriate access right check box.

Rights

Level of access rights assigned to the selected user for each project. You can change the column size of this column by dragging the column separator after the word "Rights."

Project

Projects in which the selected user has been explicitly assigned access rights.

Close

Closes dialog box and returns to VSS Administrator.

Add Assignment

Displays the Add Assignments for User dialog box. To add projects and assign or change access rights for the selected user, select a project in the project list, click the level of access rights you want to assign, and then click OK.

Delete Assignment

Deletes a user's access rights in the selected project(s).


Change Password Command (Users Menu)

See Also

Sets the password for users, including the Admin user.

Remarks

Changing a user's password is something the administrator rarely has to do, because users can change their own passwords in VSS Explorer (Change Password command on the Tools menu). When users forget their passwords, however, they can't run VSS. It is not possible to find out what the user's password is. You can, without knowing the password, use the Change Password command to change it.

Note When you run VSS Administrator, you are prompted for the Admin user's password. If you want to provide a password for the Admin user, use the Change Password command to give the Admin user a password. After you have done this, make sure not to forget the Admin user's password, as there is no way to discover it; you must call Microsoft Technical Support Services for assistance.

Dialog Box Options

User Name

Name of the user selected in VSS Administrator.

New Password

Type the new password. A password can consist of any combination of one to 15 characters. As you type, the characters are displayed as asterisks. VSS passwords are not case-sensitive.

Verify

Retype the new password to verify it.

OK

Confirms the new password.

Cancel

Cancels the Change Password command.


Copy User Rights Command (Tools Menu)

See Also

Acts as a template and copies one user's access rights to another user.

Remarks

Instead of adding a user's access rights to every project a user is working on, you can simply copy all access rights from another similar user.

To copy user rights

  1. In the user list, click the user whose access rights you want to modify.

  2. On the Tools menu, click Copy User Rights. The Copy Rights Assignments to User dialog box is displayed, providing a list of all VSS users.

  3. Click a user to use as an access rights template, and then click Copy.

After you copy rights, the two users have identical access rights in every project. You can, however, individually change their access rights in specific projects. Future changes to one user are not duplicated for the other, unless you use this command to copy user rights again.

Dialog Box Options

Copy From

User whose access rights you want to copy.

Copy

Copies access rights from the user selected under Copy From to the user selected in VSS Administrator.

Cancel

Cancels the Copy User Rights command.


Delete Users Command (Users Menu)

Delete User Command (Users Menu)

Deletes a user from VSS Administrator's user list.

Remarks

To delete a user

  • Click the user you want to delete in VSS Administrator's user list, and then on the Users menu, click Delete. Click OK to confirm the deletion.

The user is deleted from the list, and is no longer able to run VSS.

If the deleted user has files checked out, a warning is not generated. To unlock those files, run VSS as the Admin user and use the Undo Check Out command.


Edit Users Command (Users Menu)

Edit User Command (Users Menu)

See Also

Changes the username and access rights of the user selected in VSS Administrator.

Remarks

Use the Change Password command on the Users menu to change a user's password.

Note A shortcut for displaying the Edit User dialog box is to select the username in VSS Administrator's user list, and then press enter.

Dialog Box Options

User Name

Type a new name to change the name of the user selected in VSS Administrator.

Read Only

Assigns the Read access right. Select if you don't want the user to have Read/Write access rights.

OK

Confirms your changes.

Cancel

Cancels the Edit Users command.


Add Users for Project Dialog Box

Add User for Project Dialog Box

See Also

Adds users to the project selected under Projects in the Project Rights dialog box.

Remarks

The users displayed in this dialog box are users in the VSS database who do not have access rights in the project selected in the Project Rights dialog box.

To display the Add Users for Project dialog box:

  • On the Tools menu, click Rights by Project, and then in the Project Rights dialog box, click Add User.

Note To use the Add User for Project dialog box, you must first select Enable Project Security on the Project Security tab in the SourceSafe Options dialog box on the Tools menu.

Dialog Box Options

Rights

Access rights assigned to the user.

Users

Users who don't have access rights in the selected project.

User Rights

Specifies the level of access rights [image] Read, Check Out, Add, or Destroy [image] that you want to assign to the user selected in the Users column. After you select a check box, the access rights are displayed under Rights.

Note If the user you want to add to the project has the read-only access right and you want to assign additional access rights, on the Users menu, click Edit User, and then clear the read-only check box.

OK

Confirms selections.

Cancel

Cancels selections and returns to the Project Rights dialog box.


Rights By Project Command (Tools Menu)

See Also

Displays and changes access rights for selected users in selected projects.

Remarks

Default user access rights are assigned to each new user under default security or on the Project Security tab in the SourceSafe Options dialog box on the Tools menu.

This command shows the effect of rights propagation in the Project Rights dialog box. For example, if a user has the Destroy access right in the root project, then under Projects, you see that the user has the Destroy access right in all subprojects [image] unless you explicitly change the access rights. Explicit changes are displayed in the Rights Assignments for Users dialog box, available from the Tools menu.

Note To use the Rights by Project command, you must first select the Enable Project Security check box on the Project Security tab in the Visual SourceSafe Options dialog box on the Tools menu.

Dialog Box Options

Projects

Project list of the current VSS database. Select the project for which you want to view or change users' rights.

Rights

Access rights assigned to the user.

Users

Users who have access rights in the selected project.

User Rights

Specifies the level of access rights [image] Read, Check Out, Add, or Destroy [image] that you want to assign the user selected in the User column. To change the selected user's access rights for the selected project, select the appropriate check box.

Close

Closes this dialog box and returns to VSS Administrator.

Add Users

Displays the Add Users for Project dialog box, which adds users to the project selected under Projects.

Delete Users

Deletes the selected user's access rights to the selected project, after a warning message.


Set Shadow For Dialog Box

Lets you browse for a project to set a shadow folder for in your VSS database.

Dialog Box Options

Project

Select the project for which you want to set up a shadow folder.

OK

Accepts the project you have selected.

Cancel

Cancels the shadow project selection.


General Options Tab (Tools Menu)

Sets general user options.

Remarks

Settings affect all users in VSS Administrator's user list.

To display the General Tab:

  • On the Tools menu, click Options, and then click the General Tab.

Dialog Box Options

Allow Multiple Check Outs

Controls whether many people can check out one file simultaneously. Under ordinary circumstances, only one person can have a file checked out of VSS at one time. If you select this box, however, VSS allows many people to check out the same file. When the first user checks in the file, VSS updates the file; thereafter, VSS merges in all subsequent changes.

Use Network Name For Automatic User Log In

Sets whether VSS reads users' logon names from the operating system. If you select this box, VSS automatically attempts to get usernames from the operating system. Clear this box if you want users to use logon names different from their network logon names [image] VSS displays a Login dialog box unless users supply a username in some other way (with an environment variable, for example).

Database Name

Sets the name of the current VSS database as displayed in the VSS Explorer title bar. If undefined, the VSS Explorer title bar reads "Visual SourceSafe Explorer," with no database name.

Tip If you have a lot of different VSS databases, you can often end up running VSS without knowing which one you're connected to. You can use the Database Name option to uniquely identify the database, and if you want to know what folder the copy of VSS is in, you can include the folder or share name in the database name. There is a 31-character limit for the database name.

Note If you want to use Database Name, either do so before anyone runs VSS or have users delete the listing from their registry HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\SourceSafe\Databases, then start a new session of VSS.

Expand Keywords In Files Of Type

Indicates on which files to use keyword expansion. By default, VSS does not scan files for keyword expansion when it performs Check In or Add Files commands.

Log All Actions In Journal File

Sets the file where all VSS commands that change stored data are logged. (Commands that don't change data in the VSS database are not logged.) If you select this option, the specified file is a text file listing all VSS actions used by users.

OK

Confirms selections.

Cancel

Cancels selections.


Project Security Options Tab

See Also

Controls VSS project security. Use this tab to turn security on and off; if security is enabled, you can set default access rights for users.

Remarks

Your first decision is whether to enable project security. If the Enable Project Security check box is clear, project-level security is disabled (VSS's default security is always operating). If the Enable Project Security check box is selected, you can set default access rights for new users added to the VSS Administrator user list. The Add Users command on the Users menu adds users to the user list.

For instance, if the Read, Check Out, Check In, Add, Rename, or Delete check box is selected, new users are given the Add access right in the root project (and therefore in all projects) by default. You can then change these rights in any project using the Rights by Project or Rights Assignments for User command.

To display the Project Security tab:

  • On the Tools menu, click Options, and then click the Project Security tab.

Tab Options

Enable Project Security

Enables the project security system, which provides the four levels of access rights shown below.

Read

Permits a user to view read-only copies of files.

Check Out/Check In

Permits a user to use the Check Out and Check In commands, but does not permit renaming, adding and deleting of files or projects, and so on.

Add/Rename/Remove

Permits a user to use the Add, Rename, Delete, Check Out, and Check In commands, but does not permit actions that permanently destroy files or projects.

Destroy

Permits a user to use all VSS commands. Equal to read/write access rights under the default security system.


Shadow Folders Options Tab

See Also

Sets shadow folders.

Remarks

Use the Set Shadow Folder for Project option to specify a project. After it is specified, all other options on the tab apply only to the specified project.

To display the Shadow Folders tab:

  • On the Tools menu, click Options, and then click the Shadow Folders tab.

Dialog Box Options

Set Shadow Folder For Project

Specifies the project for which you want to set up the shadow folder. Click Browse to browse through the VSS database for the project you want. After you have entered a project name, any existing shadow information for that project is displayed in the remaining fields of the tab. Remember that shadow settings for a particular project may be set explicitly for that project or inherited from parent projects.

Set Shadow Folder To

Specifies the shadow folder. This folder can be anywhere on the network, but in most cases is on the server with the VSS database. Click Browse to search the file system for a suitable location.

Set Another

Applies the shadow folder specified in the other fields of this dialog box, and clears the dialog box so you can set another shadow folder. This button is not enabled unless you have specified a valid project and folder in the next two fields.

Set Read-Only Flags For All Files

Controls whether files in the shadow folder are read-only.

End-Of-Line Character For Files

Sets the end-of-line character used in the shadow folder. When VSS copies a file into the shadow folder, it uses the end-of-line character used by its own operating system. For example, VSS on Windows uses a carriage-return/line-feed pair. In a multi-platform environment, the files in the shadow folder are a mixture of end-of-line characters, based on which operating system each file was updated from most recently.

This setting overrides that mechanism, forcing all versions of VSS to use the specified end-of-line character. Set this field to LF for line feed (the UNIX default), CR for carriage return, or CR/LF for carriage-return/line-feed pairs (the Intel default). Note that Macintosh compilers can generally accept carriage-return/line-feed pairs, so CR/LF is a good setting for Intel [image] Macintosh installations.

File Date/Time

Sets the date/time stamp given to files in the shadow folder.

By default, whenever VSS places a file in the shadow folder, its sets the date/time of the file to the current date/time.

However, if you set this variable to Modification or Check In, VSS sets the shadow folder file to the date/time that the file was last modified or checked in, respectively.

OK

Confirms selections, and saves the shadow settings to the SRCSAFE.INI file.

Cancel

Cancels selections and returns to VSS Administrator.


Web Options Tab

See Also

There are three general settings that apply to all your Web projects in your VSS database at once. Two apply to Web projects that are deployed through a File Transfer Protocol (FTP) firewall, and one applies to the Check Hyperlinks command. Set these with the Web tab. Don't confuse the Web tab with the Web Projects tab, which sets options for a specific Web project rather than for all Web projects at once.

Proxy for deploying over FTP

If you need to deploy remotely through a firewall, use this field to specify a proxy. Sets the Deploy_Proxy initialization variable in SRCSAFE.INI.

Do not use the proxy for these local servers

Use this field to specify local servers for which the proxy is not appropriate because they are inside the firewall. Sets the Deploy_Host_Local initialization variable in SRCSAFE.INI.

Default filename for Web pages

Use this field to specify the file name that VSS appends to a URL that ends in a folder name, during a Check Hyperlinks run. Defaults to "Default.htm"; you only need to specify this if you want something different. Sets the Web_Default_Filename initialization variable in SRCSAFE.INI.

OK

Confirms selections, and saves the Web settings to the SRCSAFE.INI file.

Cancel

Cancels selections and returns to VSS Administrator.


Web Projects Options Tab

See Also

Sets information applicable to Web projects; that is, projects that contain files meant for HTML browsers. Don't confuse the Web Projects tab with the Web tab, which sets options for all Web projects at once rather than for one individual Web project.

Remarks

Use the top list box to specify an existing VSS project as a Web project. After it is specified, all other options on the tab (except proxy information, which is global) apply only to the specified project.

To remove the Web project designation from a project, simply clear the URL field and click OK.

To display the Web Projects tab:

  • On the Tools menu, click Options, and then click the Web Projects tab.

Dialog Box Options

This tab contains five text fields. The first field and either or both of the URL and Virtual Root fields must be filled in before you can designate a project as a Web project. The remaining two fields are optional.

This project represents a Web project

Type the name of the project into this field, or use the Browse button to locate the project. The other settings apply to this project.

URL

Type the Uniform Resource Locator address for the Web project into this field.

Virtual Root

Some Web server software supports this; if you have specified a virtual root in your server software, you should specify it here, without an initial slash. Entering a value in this field sets a Virtual_Root variable in SRCSAFE.INI. Note that lookups check through the SRCSAFE.INI file for any project with the specified virtual root.

Site map filename

Fill this field with the name of the file you want VSS to use when it creates a site map. (If you don’t specify a value, Sitemap.htm is used by default.)

After you fill in the fields in the tab, have the clients involved in the Web project exit from VSS and restart. VSS Explorer displays the designated project with a special icon to indicate that it is a Web project.

Note You must designate a URL and/or a virtual root for the project. The other fields are optional at the time the project is being designated as a Web project.

Deployment path

A deployment location can be on a hard drive on your computer or elsewhere on a local area network. If a deployment location is local, you specify it with a drive letter or in UNC format. Click the Browse button to search for servers on your network. Entering a value in this field sets a Deploy_Path initialization variable in SRCSAFE.INI.

Alternatively, the location can be remote, in which case it is reached through File Transfer Protocol (FTP). Use URL format to specify an FTP path. The path must include the protocol specification ("ftp://") and the location. To these you can add a username or a username and a password, and (if necessary) a folder path. Separate username and password with a colon (:). You can specify more than one path in this field; separate the paths with commas.

For example:

ftp://www.trassi.com/

ftp://SamBal@www.trassi.com/ssafe

ftp://SamBal:baDJak@www.trassi.com/ssafe

ftp://www.trassi.com/ssafe,\\my\server\ssafe

VSS stores the entire FTP path in the Deploy_Path variable.

Note You can deploy any project that has been designated as a Web project, regardless of the types of files it contains. A single command then sends the entire project to the remote location or locations you’ve specified.

You can enter several deployment paths in this box, separated by commas. For instance, you could set it up so that whenever a user deploys this Web site, it will go to your FTP location and also to a folder on your local server.

When defining a path for an FTP site, the folder information works from the FTP server's root. When using typical FTP commands on Intel or UNIX, you normally log on to the FTP server and begin at a home path that's typically not the server root. You may think of this as a "home" root.

For example, if you wanted to drop a file into your Web site at North Carolina State University, you would perform the following steps:

  1. ftp://ftp.eos.ncsu.edu

  2. Enter your username and password.

  3. Change folder to temp (a subfolder).

  4. Use the FTP "put" command to write the file.

To specify that location in the Deploy dialog box, type:

ftp://username:password@ftp.eos.ncsu.edu/usr/name/temp

Note the necessity of specifying /usr/name/ [image] because the deployment to FTP works from the server root and not the current folder. Also note that many systems use a tilde (~) to specify the user's home folder. So you may have to enter the following (where the UNIX server supports this common syntax):

ftp://username:password@ftp.eos.ncsu.edu/~/temp

Also, you should be careful where you enter the "/". For example "cd ~/temp" is a valid FTP command, but "cd /~/temp" is not.

Set Another

Applies the Web site information specified in the other fields of this dialog box, and clears the dialog box so you can set another Web site project. This button is not enabled unless you have specified a valid project and URL in the top field.

OK

Confirms selections, and saves the Web site settings to the SRCSAFE.INI file.

Cancel

Cancels selections and returns to VSS Administrator.

To Remove Web Project Designation

Clear the URL and virtual root fields on this tab; then click OK.


Check Out Command (SourceSafe Menu)

See Also

Copies the latest version of one or more selected files from the current project into your current working folder.

Access Rights

You must have the Check Out access right to use this command. You should have a working folder set before using this command.

Remarks

The Check Out command retrieves writable files from VSS and places them in your working folder, so that you can modify them. VSS lists the file as checked out in VSS Explorer.

Note There is an important difference between the Check Out and Get Latest Version commands. The Get Latest Version command places a read-only local copy of a file in your working folder. Check Out places a writable copy of the file in your working folder.

To return the file to VSS, you can use the Check In command to confirm your changes and copy your local, modified file into the VSS database.

Note You can also use the Undo Check Out command. Undo Check Out does not update VSS. Instead, it copies the most recent version of the file in VSS over your local copy, so all the changes made to the local copy since you last checked out the file are lost. In addition, the Undo Check Out command cancels your check out and removes the writable version of the file from your working folder. To display a dialog box when you use the Undo Check Out command, use the Command Dialogs tab in the SourceSafe Options dialog box on the Tools menu.

Generally, only one user can have a file checked out for modification at one time. However, if your VSS administrator allows multiple check outs, many users can check out the same file at the same time. When the first user checks the file into VSS, that file becomes the current version. When subsequent users check in their local copies, their changes are merged into the file and a new VSS version is created. Binary format files cannot be checked out by more than one person at a time.

You can also check items out exclusively [image] that is, check them out so that no one else can check them out while you have the file or project checked out. Your VSS administrator can set an administrative option to disable multiple check outs for an entire project all the time, or you can clear the Allow Multiple Checkouts advanced option check box from the Check Out command dialog box to exclusively check the file out on a file-by-file and session-by-session basis.

Dialog Box Options

If you have the file-level Check Out check box selected on the Command Dialogs tab in the Options dialog box on the Tools menu, the Check Out command displays the Check Out dialog box, which has the following options. There is an additional Recursive option if the project-level Check Out check box is selected as well:

Comment

Type a brief description of the reason for the check out. While the file is checked out, the Check Out Status tab displays the comment. The limit for check out comments is 63 characters.

To

Shows the working folder to which VSS copies the file. By default, VSS copies the file with its own file name into your working folder. However, you can enter a different folder and file name, or click Browse to select a different location in your folder tree.

Recursive (project-level Check Out only)

Checks out the project and all its subprojects.

Build Tree Override Working Folders (project-level Check Out only)

Overrides the working folder set for the subprojects involved in a recursive operation, and builds a project tree that mirrors the project organization on your local computer. Working folder settings for individual subprojects are ignored. Available only when you select the Recursive check box.

Don't Get Local Copy

Tells VSS not to copy the file to your working folder. VSS records that the file is checked out, but does not write a new copy to your working folder.

Advanced Options

You can also set the defaults for the first three of these on the Local Files tab in the SourceSafe Options dialog box on the Tools menu.

Allow Multiple Checkouts

Allows multiple users to check out this file/project simultaneously. If another user already has this file checked out, the check box is selected and unavailable. If multiple check outs are disabled for this project, the check box is cleared and disabled. When a file or project is exclusively checked out, the VSS Explorer icon for that item has a red box around it.

Replace Writable

Determines how VSS behaves when you try to check out a file that is already marked as writable in your working folder. Select one of the following in the list box:

  • Ask. Asks you what to do when a writable version of a file is found.

  • Replace. Replaces the writable file with a read-only version.

  • Skip. Skips the check out operation for the writable file. An error is displayed in the Results window if it is open.

  • Merge. Merges the changes between the writable file and the one you are now checking out. If the file cannot be merged (for example, it is a binary file), the check out operation is skipped for that file, and an error is displayed in the Results window if it is open.

  • Default. Uses defaults set on the Local Files tab or inherited from a parent project. You cannot set this option; it is used automatically when you have explicitly (in the file list) or implicitly (by checking Recursive) selected multiple files.

Set File Time

Changes the time assigned to the check out operation. Select one of the following in the list box: current time, last file modification time, last file check-in time, or the default time (set on the Local Files tab).

Skip This Dialog

Skips this dialog box during future check out operations and, by default, uses the settings you've entered. To restore the dialog box, clear the appropriate box on the Command Dialogs tab in the SourceSafe Options dialog box. Pressing the SHIFT key when clicking the Check Out command displays this dialog box, overriding the setting on the Command Dialogs tab.


Check Out Status Properties Tab

See Also

Displays check out information on a VSS file.

To display the Check Out Status tab:

  1. Select a file in the file pane of VSS Explorer.

  2. On the File menu, click Properties, and then click the Check Out Status tab.

Access Rights

You must have the Read access right to use this tab.

Remarks

If more than one user has a file checked out, clicking Check Out Status first displays a list of all check outs. Double-click a particular check out to see details on that check out. You can also check in a file, or undo the check out of a file.

If the selected file has not been checked out, when you click Check Out Status VSS tells you the file has not been checked out, and does not display the tab options.

Tab Options

Name

Name of the selected file.

By

User who checked out the selected file.

Date

Date and time the selected file was checked out.

Version

Version number of the selected file.

Computer

Name of the computer from which this file was checked out.

Folder

Working folder the checked out file is in.

Project

Name of the project the file is in.

Exclusively Checked Out

If checked, this box indicates that the file or project is checked out exclusively to one user.

Comment

Comment that was entered for the file. You can edit or add a new comment in this box, up to 64 characters.

Close

Closes the Properties dialog box and returns to VSS Explorer.

Report

Sends a report to the Clipboard, a file or a printer.


Checkouts Dialog Box

Shows the various locations to which you have a file checked out.

To display the Checkouts dialog box:

  • On the SourceSafe menu, click File Properties and select the Check Out Status tab.

Dialog Box Options

Check Outs

Lists the locations that the file is checked out to.

Details

Shows check out status for the selected file.

Check In

Checks in the selected file.

Undo Check Out

Undoes the check out of the selected file.

Close

Closes the dialog box, and cancels the command.


Create Project Command (File Menu)

See Also

Creates a new subproject under the currently selected project.

Access Rights

You must have the Add access right in the parent project to use this command.

Remarks

Use the Create Project command to create a subproject under the current VSS project. The subproject is empty until you place files or other subprojects in it. All access rights that you have in the parent project propagate to the newly created project.

Dialog Box Options

Project

Type a name for the new project.

Comment

Type a brief description of the project.


Get on Checked Out File Dialog

This message has the following cause and solution:

  • You chose to get a file when it was already checked out.

    When you get a file, a new copy is written to your working folder. If you already have the file checked out, you may have made changes that will be overwritten. In this situation, VSS gives you some options:

    • Click Replace to overwrite the working folder file.

    • Click Merge to merge changes from the working folder file into the VSS database file.

    • Click Leave to leave the working folder file alone (the Get command will be ignored for that file).

    • Click Cancel to cancel the Get operation.

    • Click Apply to all items to have your choices in this dialog box apply to all other files you currently have checked out.


Browse for VSS Database Dialog Box

See Also

Allows you to name a VSS database.

Dialog Box Options

Database path

Specifies the path to the selected database. You cannot change this value here.

Database name

Specifies the friendly name you want to give this database. This name is displayed in the Open SourceSafe Database dialog box.

OK

Confirms your selections.

Cancel

Cancels your selections.


File Types Options Tab

File Types Options Tabs

There are two Files Types Options Tabs available, one for the VSS user, the other for the VSS Administrator.

Select from one of the following:

  • VSS Administrator - Files Types Options Tab

  • VSS User - File Types Options Tab


File Types Options Tab

File Types Options Tab - VSS Administrator

See Also

Sets options relating to the types of files that users store in VSS.

Remarks

Many of the VSS dialog boxes contain file lists that enable users to select multiple files for a specific operation. Use this tab to filter these file lists so that they are more meaningful to the type of work your users do. For example, if your users are Microsoft Visual C++ developers, they may want to store .c, .h, .obj, and .exe files in VSS. If they are Microsoft Visual Basic developers, on the other hand, they may prefer .mak and .frm files.

To display the File Types tab:

  • On the Tools menu, click Options, and then click the File Types tab.

Dialog Box Options

Binary Files

Overrides VSS's automatic detection of text and binary files, and indicates that certain file types are always binary. For example, you could enter *.obj, *.xls, *.frx in this box to specify that all object files, Microsoft Excel worksheets, and Microsoft Visual Basic .frx files should be treated as binary files.

File Groups

Groups file types for your users' type of work, together with the File Types Included in the File Group option. These groups are displayed under List Files of Type in many VSS dialog boxes, so you can specify groups that filter the file list efficiently for your users.

Add

Adds a new group of file types to the list. In the Add File Group dialog box, type a name for the new file group you want to add, like "VC" or "VB."

Delete

Deletes the currently selected group.

File Types Included In File Group

Shows the list of file types included in the currently selected file group under File Groups. To modify a specific group, select the group under File Groups, and then add or delete extensions in this box.

OK

Confirms selections.

Cancel

Cancels selections.


File Types Options Tab

File Types Options Tab - VSS User

See Also

Sets options relating to the types of files you store in VSS.

To display the File Types tab:

  • On the Tools menu, click Options, and then click File Types.

Access Rights

Any VSS user can use this tab.

Remarks

Many of the VSS dialog boxes contain file lists to let you select multiple files for a specific operation. Use this tab to filter these file lists so that they are more meaningful to the type of work you do. For example, if you are a C++ developer, you may want to store .CPP, .H, .RC, and .BMP files in VSS. If you are a Visual Basic developer, on the other hand, you may want to store .VBP and .FRM files instead. You can use this tab to restrict the file lists to display just these file types rather than all the files in a specific folder.

Tab Options

Binary Files

Overrides VSS's automatic detection of text and binary files, so that you can indicate that certain file types are always binary. For example, you can enter *.OBJ, *.XLS, *.FRX in this box to specify that all object files, Microsoft Excel worksheets, and Visual Basic .FRX files should always be treated as binary files.

Create SCC File

This box is useful only for Visual Basic users. When you work with a Visual Basic project in VSS, a special file is created in your working folder called MSSCCPRJ.SCC. This file can never be added to VSS: it stays in your working folder and stores important information used by the VSS integration in Visual Basic.

Create SCC File dictates when VSS creates this file. Its default setting (*.VBP, *.MAK) means that whenever you get or add a file with an extension of .VBP (Visual Basic 4.0 project file) or .MAK (used by older versions of Visual Basic), VSS creates the MSSCCPRJ.SCC file. This file is very important because without it, VSS integration inside Visual Basic will not function properly.

On the other hand, Visual C++ and other development environments do not use this file at all. You may not want this useless file appearing in your Visual C++ folder. To prevent the appearance of the MSSCCPRJ.SCC file in your Visual C++ folder, remove the *.MAK from this field. (You should make this change only if you do not use Visual Basic 3.0 .MAK files!)

File Groups

Together with the "File types included in file group" option, this option groups file types into logical groups. These groups are displayed in the List Files of Type options in many VSS dialog boxes, so you can specify groups that filter the file list efficiently for your work.

Use the Add button to add a new group of file extensions to the list, and the Delete button to delete the currently selected group. The following example would create file groups including .FRM files, .BAS files, but explicitly not the HELP.FRM file:

*.frm; *.bas; !HELP.FRM

The <Relevant Masks> file group is a special case. This group cannot be deleted, and indicates which files you would typically place into a project. This does not prevent you from placing other files into the project; however, it does have several potentially useful effects.

  1. If you add an entire folder into VSS in one command (by typing ss add * on the VSS command line, or dragging a folder from File Manager into VSS), only files matching the relevant masks are added. Other files can then be added individually.

  2. When you perform the VSS Show Differences command on a project level to compare the current project to your working folder, files that do not match the relevant masks are not displayed as differences.

  3. The relevant masks are used as the default option under Add Files of Type in the Add Files dialog box; therefore, by default, only these files are displayed.

File Types Included In File Group

Shows the list of file types (extensions) included in the currently selected file group under File Groups. To modify a specific group, select the group under File Groups, and then add or delete extensions.

Add

Adds a new group of file extensions to the File Groups list.

Delete

Deletes the currently selected File Group.


Undo Check Out Command (SourceSafe Menu)

See Also

Cancels a Check Out operation, undoing all changes. You must have a working folder set for this command to work properly.

Access Rights

You must have the Check Out access right to use this command.

Remarks

The Undo Check Out command undoes all your changes [image] the file is no longer checked out by you, but instead of updating VSS with your edited copy, Undo Check Out retains the version VSS previously had and copies it over the file in your working folder.

You can use the Undo Check Out command only on files that you currently have checked out, not on files checked out by other users.

Note Your VSS administrator can undo the check out of another user. See Chapter 8, "Administration," of the Visual SourceSafe User's Guide for more information.

Dialog Box Options

Important The following are VSS-only options. Access and other integrated products may have different options.

Note Enable the display of this dialog box on the Command Dialogs tab in the SourceSafe Options dialog box on the Tools menu.

Local Copy

  • Replace [image] Replaces the file in your working folder [image] VSS performs the Get Latest Version command on the file. This keeps your working folder synchronized with the contents of the project, because all your changes are ignored.

  • Delete [image] Deletes the file in your working folder.

  • Leave [image] Leaves the file alone.

    By default, Local Copy uses defaults set on the Local Files tab (accessible from the Options command on the Tools menu) or inherited from a parent project. This option is used automatically when you explicitly (in the file list) or implicitly (by checking Recursive) select multiple files.

Skip This Dialog

Skips this dialog box during future Undo Check Out operations, and uses the settings you've entered as the default. To restore the dialog box, select the appropriate check box on the Command Dialogs tab of the Options dialog box.

Recursive (project-level Undo Check Out only)

Undoes the check out on all files in the selected project, and all files in all subprojects of the selected project.

Override Working Folders (project-level Undo Check Out only)

Overrides the working folder set for the subprojects involved in a recursive operation. This is useful if you have files checked out in more than one project, and want to undo the check out of all of them at the same time. Available only when you select the Recursive check box.


Files Report Command (Tools Menu)

Creates a formatted report of current project and file information that you can send to the clipboard, a file, or a printer.

Access Rights

You must have the Read access right to use this command.

Remarks

You can prepare a report containing a list of all files in the current project. (The report includes only files and subprojects currently in the project, not deleted files or subprojects.) The Files Report command is useful for large projects for which the VSS Explorer may not be able to display all file names on the screen at once.

Note Dialog box options vary depending on whether you have a file or project selected in VSS Explorer.

Dialog Box Options

All Displayed Files (available only when a file is selected)

Includes all files shown in the file pane of VSS Explorer.

Selected Files (available only when a file is selected)

Creates a report for selected files only.

Recursive (available only when a project is selected)

Creates a report that includes information on the subprojects in the current project.

Include Files (available only when a project is selected)

Creates a report that includes file names within a project.

Filenames Only

Creates a report that includes file names only. If this box is not selected, the file report includes four columns instead of just one for file name. The four columns are Filename, Username, Date-Time, and Check Out Folder (as in the VSS Explorer). The Filename column supports long file names, which will wrap in the column as necessary.

Report To

  • Printer [image] Sends report to printer.

  • File [image] Sends report to File dialog box.

  • Clipboard [image] Places report on Clipboard.

OK

Confirms selection.

Cancel

Cancels the report.

Preview

Previews the report.


Get Command (SourceSafe Menu)

Get Latest Version Command (SourceSafe Menu)

See Also

Retrieves a read-only copy of the selected VSS items. To get the most recent version, click Get Latest Version on the VSS menu. To get an older version, click Get in the History of File or History of Project dialog box.

Access Rights

You must have the Read access right to use this command. You should have a working folder set before using this command.

Remarks

The Get Latest Version command retrieves the most recent version of a file, a group of files, or an entire project from VSS and creates read-only copies for viewing or compiling in your working folder.

Note You can choose a different working folder for the current Get operation by typing a new path in the Get Latest Version dialog box. Click Browse to navigate your folders.

Getting a file does not replace the file that you currently have checked out in your working folder, unless you set the Replace advanced option.

Results of a Get Operation

Using the Get Latest Version command has four possible outcomes:

  • When the file you are retrieving is not already in your working folder, VSS simply gets the file.

  • When the file in your working folder is identical to the file you are retrieving, VSS does not retrieve or modify the file in any way.

  • When the file in your working folder is different from the VSS master copy, and your local copy is read-only, VSS replaces your local copy.

  • When the file in your working folder is not read-only, VSS assumes that you have the file checked out, and doesn't replace the file. You can change the way VSS behaves in this case with the Replace Writable option in the Local Files tab of the Options dialog box.

Merging with the Get Latest Version Command

In a multiple checkout situation, you can use the Get Latest Version command to retrieve other users' changes before checking in your version of the file. You can tell VSS to merge the changes into your local copy of the file, or you can specify that you want to verify each change before permitting the merge. To do this, set the Replace Checked Out Files option to Merge on the Local Files tab in the SourceSafe Options dialog box.

Dialog Box Options

If you enable the Get Latest Version command dialog box on the Command Dialogs tab in the SourceSafe Options dialog box on the Tools menu, or hold down the SHIFT key when you click the Get Latest Version command, you have the following options:

To

Type the path where you want VSS to place the files.

Recursive (project-level Get only)

Gets a project, all the files in the project, and its subprojects. Each file in a subproject is copied into its own working folder, which can be a folder anywhere on your computer or an accessible remote computer. To override the working folder settings, and create a file structure that mirrors the VSS project structure, use the Build Tree option.

Build Tree Override Working Folders (project-level Get only)

Overrides the working folder set for the subprojects involved in a recursive operation, and builds a project tree on your local computer that mirrors the project organization. Working folder settings for individual subprojects are ignored. Available only when you select the Recursive check box.

Make Writable

Sets the read/write flag so the file is writable. This is not the default behavior, but may be useful if you want to try a temporary change in the file, or want to rename the file after getting it.

Advanced Options

You can also set the defaults for the first three advanced options on the Local Files tab in the SourceSafe Options dialog box on the Tools menu.

Set File Time

Changes the time assigned to the get operation. Select one of the following in the list box: current time, last file modification time, last file check-in time, or the default time (set on the Local Files tab).

Replace Writable

Determines how VSS behaves when you try to get a file that is already marked as writable in your working folder. Select one of the following in the list box:

  • Ask. Asks you what to do when a writable version of a file is found.

  • Replace. Replaces the writable file with a read-only version.

  • Skip. Skips the get operation for the writable file. An error is displayed in the Results window if it is open.

  • Merge. Merges the changes between the checked-out file and the one you are now getting. If the file cannot be merged (for example, it is a binary file), the get operation is skipped for that file, and an error is displayed in the Results window if it is open.

  • Default. Uses defaults set on the Local Files tab or inherited from a parent project.

Skip This Dialog

Skips this dialog box during future get operations, and uses the settings you've entered as the default. To restore the dialog box, clear the appropriate box on the Command Dialogs tab in the SourceSafe Options dialog box. Pressing the SHIFT key when clicking the Get Latest Version command displays this dialog box, overriding the setting on the Command Dialogs tab.


GoTo Dialog Box

Jumps to a specified position in a file.

To display the GoTo dialog box:

  1. Select a file in the file pane of VSS Explorer.

  2. On the Tools menu, click Show Differences, and in the File Difference dialog box click OK.

    Note Enable the display of the File Difference dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

  3. In the Difference for File dialog box, click Report.

  4. In the File Difference Report dialog box, click Preview.

  5. Press ALT+G.

Dialog Box Options

Go to what

Select the type of item you want to go to. Different options are available depending on the operation you are performing, for example, you can go to a bookmark, conflict, difference, line or offset (the number of bytes from the beginning of the file). You may want to use File Offset if you are receiving an error during loading after a certain byte, or if you have a file with a fixed byte length and need to find a specific byte in the file.

Enter position number

Type the position to which you want to go. (Position is relative to the type specified under Go to What.)

Go To

Goes to the specified location.

Previous

Goes to the previous item of type specified in the Go to What field.

Close

Cancels the GoTo command.


File/Project History Options Dialog Box

Allows you to specify options for presenting the project history.

Dialog Box Options

Include file checkins (project history only)

Includes files in project history.

Recursive (project history only)

Includes subprojects and all files within them.

Labels only

Includes only labels in project history if you have selected the Include file checkins option.. You can use this checkbox with the From and To fields to find all projects with the designated label, but it will not search through the files in those projects for designated labels.

From

Restricts the history report to begin at the date specified. Type a date, date;time, version, or label. Use the prefix D to indicate a date and/or time, and the prefix L to indicate a label. For example "D02/29/95;12:15" or "Lbeta1". Dates can be entered in 08.15.95, 08-15-95, or 08/15/95 format, but not as August 15, 1995.

To

Restricts the history report to end at the date specified. Type a date, date;time, version, or label. Use the prefix D to indicate a date and/or time, and the prefix L to indicate a label. For example "D02/29/95;12:15" or "LBeta1". Dates can be entered in 08.15.95, 08-15-95, or 08/15/95 format, but not as August 15, 1995.

User

Shows a history of files worked on by the specified user.

OK

Displays History of Project dialog box. In this dialog box, select any of the items in the list, and then click Details to display the History Details dialog box. From within the History Details dialog box, you can click the Next and Previous buttons to move up and down in history display. You can also edit the comment and label associated with the version you are viewing.

Skip This Dialog

Skips this dialog box during future Show History operations, and uses the settings you've entered as the default. To restore the dialog box, click the appropriate check box on the Command Dialogs tab of the SourceSafe Options dialog box.


History Report Dialog Box

See Also

Sends a report of historical information on a file or project to a printer, a file, or the Clipboard.

To display the History Report dialog box:

  1. Select a file or project in VSS Explorer, and on the Tools menu, click Show History.

  2. Make selections in the File History Options or Project History Options dialog box (if enabled), and click OK.

    Note Enable the display of the File History Options dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

  3. In the History of File or History of Project dialog box, click Report.

Dialog Box Options

Include Details

Includes all historical details of the selected file(s) in the report. Details include creation date, user who modified the file for each check in, comments applied to the file, and time/date information for each event.

Include Differences

This option is useful when you are comparing two different versions of a file or project. The report includes differences between the selected files or projects in the report.

Report To

Sends the history report to a printer, a file, or the Clipboard.

OK

Prepares the specified report.

Cancel

Cancels the report.

Preview

Shows a preview of the specified report, so that you can determine if it is what you wanted before committing it to the printer queue or a file.


Label Command (File Menu)

See Also

Assigns a label to the specified version or current version of a file or project.

Access Rights

You must have the Add access right to use this command.

Remarks

Every version of a file has a version number and a date and time, and can be retrieved by a reference to either. To make a version easier to identify, you can assign it a label [image] any string up to 31 characters in length [image] and refer to the version by its label.

With the Label command, a new version of the selected file(s) or project is created, and the label is associated with that version.

Note To change the label of an earlier version, when a file is selected in the file pane of VSS Explorer, on the Tools menu, click Show History, and then click Details.

When you edit a label in the History Details dialog box, you are assigning a label to an existing version of the specified item.

If you want to identify a certain version of a project so you can come back to it, do not assign a label to every file in the project, but rather assign the label to the project itself. Even if you add, delete, and rename files in the future, VSS can accurately restore that version of the project based on the project label.

Dialog Box Options

Item

The name of the file or project.

Label

Type a label up to 31 characters in length.

Comment

Type an optional comment.


Merge Branches Command (SourceSafe Menu)

See Also

Copies all the changes made in one branch of a file to another branch. Works for files only, not projects.

Access Rights

You must have the Check Out access right in the project being merged into, and the Read access right in the project being merged from, to use this command. You should have a working folder set before using this command.

Remarks

Merge copies the changes made in one file into another file (on a separate development path) in VSS. If the merge creates conflicts, VSS checks out the file to your working folder if it wasn't already checked out. You can then modify the file and resolve any conflicts before checking the file back into VSS.

For example, project $/Newapp is currently shipping version 5. The development team has started working on version 6, when suddenly a big customer calls with a serious bug in version 5. The Newapp project is branched at that point so that the development team can continue working on version 6 while a crack bug team works on fixing the version 5 bug (perhaps their project is named $/Bugfix). Up to the branch point, the projects are identical, but after the branch the code in each project differs.

Just before version 6 ships, the Bugfix team announces they have corrected the bug. You decide to merge their code into the Newapp project so version 6 of your product has the fix. You select one file at a time in the Newapp project and choose the Merge Branches command.

After the merge operation, you still have two independent development paths, but the changes made in $/Bugfix have been copied to $/Newapp. Before you choose the Merge Branches command, be sure you have the file selected that you want to merge changes into. (The file you are merging changes from will be unchanged.)

Note You cannot merge binary files.

Dialog Box Options

Projects

Select the project into which you want to merge your file. The Versions column shows you the version numbers you will be merging.

Merge

Merges branches.

Cancel

Cancels merge of branches.

Links

Shows all of the projects with which the file has share links.


Move Projects Command (File Menu)

Move Project Command (File Menu)

See Also

Relocates a subproject from one parent project to another.

Access Rights

You must have the Add access right in the parent project being moved to, and the Destroy access right in the parent project being moved from, to use this command.

Remarks

The Move Project command redefines the path to a subproject. For instance, if the project TOOLMANAGER exists under $/JOE, and you move it to $/APPS, its new full name is $/APPS/TOOLMANAGER.

This command does not rename a project, and it does not change its contents or history. It does affect the histories of the old and new parent projects.

After you move a project, you cannot reconstruct an old version of its original parent project. In the preceding example, any attempt to use the Get Latest Version command recursively to retrieve a version of $/JOE that existed before you moved the TOOLMANAGER project generates a warning that TOOLMANAGER has been moved, and is unavailable.

Note You cannot move individual files with the Move Project command. Instead, to move a file, share the file with the new parent project, and then delete or destroy the file in the original project. The history of the file is retained.

Dialog Box Options

To move a project, first select that project in the VSS Explorer. Then select the new project location from this dialog box and choose OK.

To

Select the path of the project to which the subproject is to be moved.

OK

Moves the selected project to the new location.

Cancel

Cancels the Move operation.


Difference for File Dialog Box

Differences For File Dialog Box

See Also

Shows differences between a working folder version of the selected file and the VSS database version of the file.

To display the Differences For File dialog box:

  1. Make sure that you have the SourceSafe or Unix button selected in the Difference Options dialog box.

  2. Select a file in the file pane of VSS Explorer.

  3. On the Tools menu, click Show Differences.

  4. If the files compared are the same, a message tells you the files are identical. VSS cannot display differences for binary files; it can only tell you whether or not binary files differ. If text files differ, VSS displays the File Difference dialog box.

  5. Make selections in the File Difference dialog box (if it's enabled), then click OK.

Note Enable the display of the Difference Options dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

Remarks

This dialog box is used only when you have not selected the visual difference comparison. (For visual differences, make sure you select the Visual option from the Difference Options dialog box.) By default, VSS uses the Visual Difference dialog box. The visual difference option shows each file side by side, and lets you easily make changes from one to the other. The SourceSafe Difference shows a simple list of lines that were added, deleted, and changed, optimized for readability. The Unix option shows differences in the format used by the UNIX Diff utility.

If you specify a UNIX display, VSS uses the SourceSafe display options for Ignore Case and Ignore White Space. The SourceSafe display option has line widths calculated to fit on your screen, and no context lines.

Note To compare a current VSS file to an older version of the same file, select the file in the file pane of VSS Explorer, and on the Tools menu, click Show History. Then click Diff.


Open SourceSafe Database Dialog Box

See Also

Allows you to open different VSS databases and store their locations.

Dialog Box Options

Available databases

Specifies the databases you have already visited, giving friendly name and path information for each. If the database you want is not shown in the list, you can click the Browse button to look for it. After you find it, and click OK in the Browse dialog box with a specific SRCSAFE.INI file selected, you have the opportunity to give the database a familiar name for future reference.

Username

Specifies the username with which you want to log on to the new database. If you change this to a new username with a different password, you will be prompted to enter the new password. You cannot change this option in the Administrator program.

Open this database next time I run Visual SourceSafe

Select this box to designate this database as your startup database.

Remove

Removes a selected database from the list. You cannot remove the current database from the list.

OK

Confirms your selections.

Cancel

Cancels your selections.


Change Password Command (Tools Menu)

See Also

Sets the password for the current user.

Access Rights

Any VSS user can use this command.

Remarks

Use the Change Password command to set your password. After you change it, your old password no longer works, and you have to type the new one each time you log on to VSS.

To change your password, you must first know what it is. If you forget your password, ask your VSS administrator to change it for you.

Note Keep in mind that the VSS password is not meant to replace or augment your operating system or network operating system password. Only when the operating system does not allow VSS to determine user identity does VSS ask for the VSS password when you log on. Your VSS password can be the same as or different from your operating system password.

Dialog Box Options

Old Password

Type the current password, or leave blank if the password is blank (a zero-length string).

New Password

Type the new password.

A password can consist of any combination of 1 to 15 valid characters. As you type, the characters are displayed as asterisks. Microsoft VSS passwords are not case-sensitive.

Verify

Retype the new password to verify it.


Paths Properties Tab

See Also

Shows all branches of the specified file.

To display the Paths tab:

  1. Select a file in the file pane of VSS Explorer.

  2. On the File menu, click Properties, and then click the Paths tab.

    Note To display this tab from within Visual Basic, after adding a Visual Basic project to VSS, on the Visual Basic Add-Ins menu, click SourceSafe, and then click SourceSafe Properties.

Access Rights

You must have the Read access right to use this tab.

Remarks

When you use the Branch command to branch a file, the share link is broken and an independent file branch is created. Once a file is branched, modifications made to that file in one project are not reflected in the other projects. Nonetheless, it is sometimes valuable to track these relationships.

For example, suppose you find a bug in a file, and fix it. All the projects sharing that file are immediately updated with the new version. However, projects that used to share that file, and then branched from it, are not updated; use the Paths tab to find those projects and then manually update them.

When you view paths, you view the entire branch history of the file, including all the times the Branch command was used to move it to different projects on different development paths. Changes made to the file, however, are not shown [image] use the Show History command to view these.

Using the Paths command might result in a display like the following.

Projects with independent branches
$/A         1->5
--$/B         6->7
--$/D         4->4

This display means that there are 3 branches of this file (because there are 3 lines); the first branch has moved from version 1 of the file to version 5, the second branch has the first as its parent (meaning that versions 1 through 5 of the file are the same in this branch), began its life at version 6 and was checked in once since then, moving it to version 7 currently. The third branch began its life at version 4 and has not changed since then.

You can select each branch and click the Links button to see where that particular file is shared. So, how do you use this information? Assume a bug was introduced in this file at version 5 of the first branch. You know, from looking at this display, that the third branch is unaffected by this bug (because it is still at version 4), but that the second branch needs to have the fix manually inserted, because that branch came from the first (its parent), but began at version 6. Of course, once you have fixed the file in each of these branches, any other projects that share the file will automatically include the fix.

Tab Options

Projects with independent branches

Lists the projects the selected file has been shared in.

Versions

Lists the file version number that was branched in the corresponding project.

Links

Displays the Links tab of the Files Properties dialog box.

Close

Closes the Properties dialog box and returns to VSS Explorer.

Report

Sends a report to the Clipboard, a text file, or a printer.


Preview Dialog Box

Shows a preview of the specified report, so that you can determine if it is what you wanted before committing it to the printer queue or a file. You can use the viewer accelerator keys in this dialog box to navigate in the file.

Dialog Box Options

Close

Closes the report preview.


Print Dialog Box

See Also

Sets printing options.

To display the Print dialog box:

  1. Select a file or project in VSS Explorer, and on the Tools menu, click Show History.

  2. Make selections in the File History Options or Project History Options dialog box if it is enabled, and click OK.

    Note Enable the display of the History Options dialog boxes on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

  3. In the History of File or History of Project dialog box, click Report.

  4. Under Report To, click Printer, and then click OK.

Dialog Box Options

Printer

Printer selected in the Print Setup dialog box. To display the Print Setup dialog box, click Setup.

Copies

Type the number of report copies to print.

Print To File

Sends the report to a PostScript file, and prints the report.

Setup

Displays the Windows Print Setup dialog box.


Difference for Project Dialog Box

Shows the differences between files in the selected VSS database project and the working folder set for that project. You can also see what is different within a file, and reconcile differences if desired.

To display the Differences For Project dialog box:

  1. Select a project in the project pane of VSS Explorer.

  2. On the Tools menu, click Show Differences. Select options in the Project Difference dialog box (if it's enabled), then click OK.

Note To enable the display of the Project Difference dialog box, check the Difference checkbox in the Project column on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

Dialog Box Options

This powerful dialog is composed of two panes, one showing the files in your current project (on the left) and the other showing files in the working folder assigned to the current project (on the right). This dialog also has its own toolbar, with buttons for adding files, deleting files, getting files, checking files out and in, undoing file check outs, viewing files, reconciling the differences between the project and working folder, and more.

Files in both panes are sorted alphabetically, by file name or folder name (if there are subfolders). Remember that the list of files in the right and left panes is filtered by the choices you made in the Show Differences command dialog. For example, if you choose to show only files that are different in both places, you will not see files that are the same in both your working folder and your current project. You can size the columns in the left pane by dragging the column bar with your left mouse button. Pressing F5 will refresh your dialog box with current information (but may be slow for large projects).

There are four types of files which may appear in the lists.

  • Files that are the same in project and your working folder appear in black letters against a white background by default. There is no action you need to take for these files.

  • Files that are in the project, but not in your working folder, appear in blue against a gray background by default. Such a file generally represents a file that another user added to the project (in which case you may wish to Get it), or a file that you deleted from your working folder (in which case you may wish to delete it from VSS).

  • Files that are in your working folder, but not in the project, appear in green against a gray background by default. Such a file generally represents a file that you created (in which case you may wish to Add it to VSS), or which another user deleted from the project (in which case you may wish to delete your local copy).

  • Files that are in both places, but different, appear in red against a gray background by default. Such a file generally represents a file which you have checked out (which you may wish to check in), or a file which another user has checked in (which you may wish to Get).

Note You can set your default colors for added, changed, and deleted text by using the Difference tab of the Tools Options dialog box.

The above is a complete list of the four types of files, but not a complete list of the possibilities. For instance, if another user renames a file in VSS you will see a file you do not actually have, in the File List for that project in VSS Explorer; and in your working folder for the project there will be a file that is not present in the VSS database. So you would want to get VSS's file, and delete your local one, to reconcile the differences.

File icons in the left pane of the dialog box represent the same things they do in the main Explorer window [image] a checkmark next to a file means the file is checked out, etc. File icons in the right pane represent conditions specific to you [image] for example, a checkmark in the right pane means the file is checked out to you specifically, in your working folder. Double-clicking a file views it. Double-clicking a folder does nothing.

Toolbar commands in this dialog generally work in the same way as the standard VSS commands, but some work slightly different, as follows:

  • The Add command moves a file or directory from the right pane to the left pane. In other words, it adds a file that is in your working folder to the VSS project. The keyboard shortcut for this command is the Windows95 application key + A.

  • The Delete command works normally if a file in the left pane is selected. If a file in the right pane is selected, you can use the Delete command to delete the local file or directory from your working folder. The keyboard shortcut for this command is the Delete key.

  • The Get Latest Version command works normally, getting a file or project from the left pane to the right pane. The keyboard shortcut for this command is the Windows95 application key + G.

  • The Check Out command works normally, reconciling the differences between a file that is different between panes and is not checked out in the right pane, by checking out the file and overwriting the file in your local working folder. The keyboard shortcut for this command is the Windows95 application key + O.

  • The Check In command works normally, reconciling a file that is in both panes, but different, and is checked out in both panes. With this command, you save the latest changes to the file in your working folder. The keyboard shortcut for this command is the Windows95 application key + I.

  • The Undo Check Out command works normally, reconciling a file that is different between panes and is checked out in both panes by undoing the check out on the file. With this command, you lose the latest changes to the file in your working folder. The keyboard shortcut for this command is the Windows95 application key + U.

  • The View command works on a file selected in the left pane just like the Explorer's View command [image] it displays the file in the VSS database. The View command works on a file selected in the right pane by opening the appropriate viewer directly on the file in the folder. The keyboard shortcut for this command is the Windows95 application key + V.

  • The Difference command compares two selected files. If only one file is selected, Difference compares it between the VSS project and the folder. The keyboard shortcut for this command is the Windows95 application key + S.

  • The Refresh File List command brings the file list up to date.

  • The Reconcile All command reconciles differences found in the compared projects. Reconciliation can mean several different things, depending on the settings you choose in the dialog boxes that are displayed after you choose this command.

  • The Report command generates the standard Report dialog box. The keyboard shortcut for this command is the F5 key.

Note If you use a mouse, you can access many of the preceding commands with the right mouse button


History of Project Dialog Box

See Also

Shows historical information for the selected project.

To display the History of Project dialog box:

  1. Select a project in the project pane of VSS Explorer.

  2. On the Tools menu, click Show History.

    Make selections in the Project History Options dialog box if it is enabled, and click OK.

    Note Enable the display of the Project History Options dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu). The dialog box gives you the option to restrict the history to labels only, to include files in the project history list, to make the history list recursive down the project hierarchy, or to restrict the history list to a specified user, or to a range of dates.

  3. Click OK.

Access Rights

You must have the Read access right to use this dialog box.

Remarks

The History of Project dialog box displays the history of a selected project, including all significant events, such as the deletion of files or subprojects, addition of files or subprojects, labeling and renaming of items, and check ins. For each significant event, the dialog box shows the affected file or subproject, the user who performed the action, the date and time of the event, and the description of the event. Events are listed with the most current event at the top of the display.

Several commands are available from this dialog box. You can perform a command on a file or subproject by first selecting an event and then clicking a command button.

Dialog Box Options

Close

Closes the dialog box and returns to VSS Explorer.

View

Displays a dialog box containing a list of all files (with their version numbers) as the project existed at the selected point in the project's history.

Details

Shows the comments associated with an event, along with more detailed event information, such as label information, version information, and so forth.

Get

Performs the Get command on the selected file or subproject version. If you select a file, VSS displays a dialog box asking you to clarify whether you want to get just the selected file, or to get (that is, re-create) the entire project as it existed at the point in time the selected file version existed.

Check Out

Performs the Checkout command on the selected file or subproject version. If you select a file, VSS displays a dialog box asking you to clarify whether you want to checkout just the selected file, or to checkout (that is, re-create) the entire project as it existed at the point in time the selected file version existed. You may get an error message if the file has been destroyed since the point in history from which you attempt to checkout.

Share

Performs the Share command on the selected file or project. With this command, you can share the current or an old version of the project files with another project. This lets you create a branch from an old version of your project. You may want to do this if you need to fix some bugs for a customer while continuing development on the next version of your product.

Report

Sends the project history information to the Clipboard, a file, or a printer.


Share Dialog Box

See Also

Allows you to specify a project to share with the current project.

To display the Share dialog box:

  1. In the project pane of VSS Explorer, select a project into which you want to share another project.

  2. On the SourceSafe menu, click Share.

  3. In the Share with Project dialog box, select a project to share and click Share.

Dialog Box Options

New Name

Enter the name of the project you are sharing with the current project.

Recursive

Check to make the Share operation recursive (include all subprojects and their files).

Comment

Enter a comment for this operation.

OK

Returns to the Share with Project dialog box, which shows the selected project to share with the selected files.

Cancel

Cancels the Share command.


Browse Folder Dialog Box

For more information on the Set Working Folder dialog, see the Set Working Folder Command (File Menu)topic.

Dialog Box Options

Name

Name and path of folder.

Folder

Your current folder.

Folders

Specifies a folder.

Drives

Selects the drive that contains the folder.

OK

Confirms the folder selection.

Cancel

Cancels the selection, closes the dialog box, and returns to VSS Administrator.

Create Folder

Creates a new folder as specified. Type a new folder name in the Name box, then click Create Folder to create the folder.


Delete Command (File Menu)

See Also

Deletes a file or project.

Note In earlier versions of VSS, this command was called Remove.

Access Rights

You must have the Add access right to use this command.

Remarks

If you don't select the Destroy Permanently check box in the Delete dialog box, the Delete command is reversible [image] to make recovery possible, VSS stores a deleted file or subproject.

To recover the file, use the Recover command. Another way to retrieve the file (if it hasn't been purged or destroyed) is to return to an earlier version of the project that contains the file.

Note When you delete a project, all its subprojects and the files contained within them are deleted as well. When you recover the project, its subprojects (and the files therein) are recovered.

A deleted file or subproject can be purged or destroyed, which permanently removes the item.

Dialog Box Options

Item

The name of the file or subproject to be deleted.

Destroy Permanently

Selecting this check box permanently removes the file or subproject, which you cannot thereafter recover. This is the same as performing the Purge command on the items. You must have the Destroy access right to enable this check box.

Caution The Destroy command should be used with extreme caution. Before using it, you must be confident that you will never want the file or project, or any of its earlier versions, for any reason.

If there's any chance that you might want to retrieve earlier versions of the project that contained the file, delete the file without destroying it [image] you can then recover the file later with the Recover command.


Deleted Items Properties Tab

See Also

Displays a list of files and subprojects that have been removed from the current project.

To display the Deleted Items tab:

  1. Select a project in the project pane of VSS Explorer.

  2. On the File menu, click Properties, and then click the Deleted Items tab.

Access Rights

You must have the Read access right to use this tab.

Remarks

When you use the Delete command to delete a file or project from VSS, the deleted item is removed from VSS Explorer. However, VSS continues to store the item, so that you can retrieve it if you want to build an earlier version of the project. After you recover or purge an item, however, it no longer appears in the list in the Deleted Items tab.

Tab Options

Items

The list of all removed files and subprojects in the current project.

Recover

Recovers (undeletes) an item, and places it in the file list or project list.

Purge

Permanently deletes an item, so that it can no longer be recovered.

Close

Closes the Deleted Items tab and returns to VSS Explorer.

Report

Sends a report to the Clipboard, a text file, or a printer.


Rename Command

Rename Command (File Menu)

See Also

Renames a file or project.

Access Rights

You must have the Add access right to use this command.

Remarks

To use the Rename command, select the file or project you want to rename, then choose the command. You will be able to edit the item name directly in the VSS Explorer window.

When you use the Rename command on a file or project, the item's file history is retained. If multiple projects share a file and the file is renamed, it is renamed in all projects that share it. However, if any share links have been broken by the Branch command, the branched files are not renamed. The Paths tab in the Properties dialog box shows how the name has changed in different branches of the file.


Find In Files Command (Tools Menu)

See Also

Finds all instances of a specified character string within one or more files.

Access Rights

You must have the Read access right to use this command.

Remarks

Use the Find In Files command to display a list of all occurrences of a character string in the VSS files you specify. You can use the command on a single file or on an entire project.

There are three wildcard characters you can use in a find string, unless Literal Matches is selected:

  • A question mark matches any character.

  • An asterisk matches any string.

  • A backslash makes the character after it literal: \*, \?, and \\. This is necessary if you want to search for asterisks, question marks, or backslashes.

Ordinarily, VSS is case-sensitive, that is, A does not equal a. To make the Find In Files command case-insensitive, click Ignore Case.

The results of the search are shown in a Results window. On top, VSS lists all the files that contained matches. On the bottom, VSS displays the matching strings in the currently selected file. As you scroll through the top list, the bottom display changes to reflect the changing file selection.

Dialog Box Options

Item

Type the file name(s) you want VSS to find.

String

Type the character string you want VSS to search for.

Match Case

Finds exact matches only. The string you enter cannot contain wildcards.

Use Regular Expressions

Select this box if you're using an asterisk in your text string as part of a wildcard search. Clear this box if you're using an asterisk as an ordinary text character.

Recursive (project level only)

Searches through all files in the project and its subprojects.

List All Shared Files Separately (project level only)

In project searches, notes each match found in a shared file as a separate item. (By default, a match in a shared file is listed only for one of the projects that the file exists in.)


Find In Files Results Dialog Box

This dialog box shows the results of the Find in Files command.

Dialog Box Options

File

Shows the name of the file(s) containing matching strings.

Matches

Shows the number of matches found in the file.

Matches

Lists the matches found, in context.

Close

Closes the Find in Files results dialog box.

Report

Allows you to print a report of the match information to the Clipboard, a printer, or to a file.

Links

Shows any links the file has to other projects.


Check Out File(s) from Dialog Box

Checks out a copy of the selected file(s) from your source code control provider and places a writable copy in the corresponding development environment working directory.

To use the Check Out command:

  • On the Visual Basic Tools menu, click Check Out.

Dialog Box Options

Files to be Checked Out

Lists the files available for check out. Click the files you want to check out, or click Select All to select all files listed.

Comment

Type a brief description of the reason for the check out.

Advanced

Displays the Advanced Checkout dialog box.

OK

Confirms Check Out.

Cancel

Cancels the Check Out command.

Select All

Selects all files listed.


Get From <Project Name> Dialog Box

Gets the selected files from your source code control provider and places a read-only file in the development environment project.

To use the Get command:

  • On the Visual Basic Tools menu, click Get.

Dialog Box Options

Files to Get/Check In

Selects the file or files you want to get or check in.

Advanced

Displays the Advanced Options dialog box.

OK

Confirms your selections.

Cancel

Cancels your selections.

Select All

Selects all files listed.


Undo Check Out from <Project Name> Dialog Box

Overwrites your changes to a file, and copies the latest checked in version to your development environment working directory.

To use the Undo Check Out command:

  • On the Visual Basic Tools menu, click Undo Check Out.

Dialog Box Options

Files to Un-Check Out

Lists the currently checked out files. Click the files whose check out you want to undo, or click Select All to select all the listed files.

Advanced

Displays the Undo Checkout Advanced Options.

OK

Confirms the selection.

Cancel

Cancels the selection.

Select All

Selects all files listed.


Find Dialog Box

Allows you to enter a string to search for in the current file.

To display the Find dialog box:

  • In the SourceSafe file viewer, press ALT+S or click on the Find toolbar button. (You use the SourceSafe file viewer when you view a file for which you have not established another file association.)

Dialog Box Options

Find What

Enter the string you want to find.

Match Whole Word Only

Check this box to match the specified string only if the string is a whole word, not just part of a word.

Match Case

Check this box to make the search case-sensitive.

Regular Expression

If this box is not checked, the * and ? characters are interpreted literally. Therefore, A*B matches only one string, A*B.

If this box is checked, the * and ? characters are interpreted as wildcards. Therefore, A?B matches ABB or AQB, and A*B matches ADSFFDFDSB, within a line.

Set Bookmarks on All

Sets bookmarks on all matches in the file.

Direction

Specifies whether the search continues up or down in the file.

Find Next

Confirms the search selection.

Cancel

Cancels the search.


Branch Command (SourceSafe Menu)

See Also

Breaks a share link while retaining a copy of the file.

Note In earlier versions of VSS, this command was called Separate.

Access Rights

You must have the Add access right to use this command.

Remarks

A single file can be shared by multiple projects. Any change made to that file is reflected in all the projects that share it so that, for example, the propagation of bug fixes is handled by VSS.

After you apply the Branch command to the file, two separate branches of the file exist in different projects. You can track the different branches on the Paths tab in the Properties dialog box, and bring them back together with the Merge Branches command.

Dialog Box Options

Comment

Type a comment describing the branching.

OK

Confirms the Branch command.

Cancel

Cancels the Branch command.


Share Command (SourceSafe Menu)

See Also

Makes a file a member of the current project, or creates a new branch project.

To share a specific version of a file to your current project, use the Share command on the SourceSafe menu to get the file into the proper project. Then, use the Show History command on the Tools menu on the file and click Pin on the version you want.

Access Rights

You must have the Check Out access right in the project you are sharing from, and the Add access right in the project you are sharing to, to use this command.

Remarks

To share a file, you create a share link between two projects. The file is then in two (or more) projects at the same time. When you check in the file to any one of the projects, your changes are automatically checked in to all of them. To display a list of all the projects that share a specific file, use the Links tab in the Properties dialog box.

If you create a branch, changes made in the branched file no longer propagate to the originating project, and vice versa. The Links command no longer shows a relationship, but you can use the Paths tab in the Properties dialog box to see the path of the file branch you created.

When you share a project, you create an entirely new project under the current project that is an exact duplicate of the project you specified. All the files in the new project are shared with the corresponding files in the originating project and changes in one are reflected in the other during check in.

Dialog Box Options

File To Share

Type the name of file(s) to share or click a file name displayed. Files listed are those that can be shared with your current project: Some files cannot be shared, such as files with the same name as a file already in your project.

Projects

The name of the project being shared from.

List Files of Type

Lists the file type, or tells VSS how to classify a file.

The list of file types available is determined by the File Types Included In File Group filter and the File Groups filter set on the File Types tab in the SourceSafe Options dialog box. All Files (*.*) lists all files in the current folder.

Close

Closes dialog box.

Share

Shares selected file or project.

View

Displays the file with the text editor associated with the file extension of the file. The editor is set with the File Viewer option on the General tab in the SourceSafe Options dialog box.

Branch After Share

Shares the file, then immediately branches it to create separate copies of the file.


Customize Toolbar Command (Tools Menu)

See Also

Adds or deletes buttons on your VSS toolbar.

Rights

Any VSS user can use this command.

Remarks

To add a button to the toolbar, on the Tools menu, click Customize Toolbar. From the Customize Toolbar dialog box, select the toolbar button you want from the Available buttons area, then click Add to move it to the Toolbar buttons area. To delete a button, select the toolbar button you want from the Toolbar buttons area, then click Remove to move it to the Available buttons area.

After a button is on the Toolbar, you can drag it to a new location in the dialog box to move it to a new position on the Toolbar.

Dialog Box Options

Add

Moves a selected button from the Available buttons list to the Toolbar buttons list (that is, adds it to the toolbar).

Remove

Moves a selected button from the Toolbar buttons list to the Available buttons list (that is, removes it from the toolbar).

Reset

Resets the toolbar to its default configuration.

Close

Closes the Customize Toolbar dialog box.

Move Up

Moves a button up in the Toolbar buttons list, moving it closer to the left in the VSS Explorer toolbar.

Move Down

Moves a button down in the Toolbar buttons list, moving it closer to the right in the VSS Explorer toolbar.


Check In Command (SourceSafe Menu)

See Also

Updates VSS with changes made to a checked-out file, and unlocks the VSS master copy.

Note In earlier versions of VSS, this command was called Update.

Access Rights

You must have the Check Out access right to use this command.

Remarks

There are two commands you can use to end the check out of a file:

  • The Check In command copies your changes into the VSS database, creating a new version of the file. When other users use the Get Latest Version command or check out the file, they receive all the modifications you have made.

  • The Undo Check Out command voids all your changes and undoes your check out of the file.

When you check in a file, VSS provides a box in which you can enter a comment.

Note To update the master copy of a file while keeping the file checked out, select the Keep Checked Out check box. You can make this the default behavior by selecting the Always Keep Files Checked Out check box on the General tab in the SourceSafe Options dialog box.

You can check in a file that has not changed at all, but still add the unchanged file as a new version to the file history. VSS prompts you in this case to see if you want to perform a checkin operation. If you click No, VSS executes the Undo Check Out command, and no new version is added to the file list.

Note To avoid this message on future occasions, you can disable this notification on the General tab in the SourceSafe Options dialog box on the Tools menu.

Check In from Multiple Check Outs

In a multiple check out situation, when you are the first user to check the file into VSS, your version of the file becomes the latest version. However, if you are a subsequent user to check in the file, VSS performs an automatic merge, creating a new file as the latest version in VSS.

VSS informs you that a merge took place. You can check the file in immediately or keep the merged file in your working folder and review it before returning it to VSS. If there are merge conflicts, you cannot check in the file until you resolve the conflicts.

Dialog Box Options

Comment

Type an optional comment. Comments are limited to 4095 characters.

Keep Checked Out

Updates the master copy with your changes but keeps the file checked out to you.

Remove Local Copy

Removes the local copy from your working folder.

OK

Confirms the selection.

Cancel

Cancels the selection.

Diff

Compares the file you want to check in with the VSS master copy and displays the differences. This feature is useful if you want to enter a meaningful comment when you check in the file.

Recursive (project-level Check In only)

Indicates you want files in all subfolders added when you select an entire project to check in.

Override Working Folders (project-level Check In only)

Overrides the working folder set for the subprojects involved in a recursive operation. This is useful if you have some shared files checked out in more than one project, and want to check them all in at the same time. Available only when you select the Recursive check box.


Differences For File Dialog Box

See Also

Shows differences between a working folder version of the selected file and the VSS database version of the file.

To display the Differences For File dialog box:

  1. Select a file in the file pane of VSS Explorer.

  2. On the Tools menu, click Show Differences.

  3. If the files compared are the same, a message tells you the files are identical. VSS cannot display differences for binary files; it can only tell you whether or not binary files differ. If text files differ, VSS displays the File Difference dialog box.

  4. Make selections in the File Difference dialog box (if it's enabled), then click OK.

Note Enable the display of the File Difference dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

Remarks

The Difference For File dialog box displays two files side-by-side. It uses three colors to show deleted, modified, and changed lines. You can change the colors by setting the options on the Difference tab of the Tools Options dialog box. You cannot make changes to the files from this dialog box [image] it is for display of differences only.

Note To compare a current VSS file to an older version of the same file, select the file in the file pane of VSS Explorer, and on the Tools menu, click Show History. Then click Diff.

Dialog Box Options

This dialog has a toolbar containing all the commands you'll need for finding and marking differences:

Find

Lets you search for a string in the file. The shortcut key is Alt+F3.

Find Next

Lets you search for the next matching occurrence of a string in the file. The shortcut key is F3.

Find Previous

Lets you search for a previous matching occurrence of a string in the file. The shortcut key is Shift+F3.

Toggle Bookmark

Lets you turn a bookmark on or off in a file. The shortcut key is Ctrl+F2.

Next Bookmark

Lets you go to the next bookmark in the file. The shortcut key is F2.

Previous Bookmark

Lets you go to the previous bookmark in the file. The shortcut key is Shift+F2.

Clear All Bookmarks

Lets you clear all bookmarks in the file.

Previous Difference

Lets you find the previous difference in the file. The shortcut key is Shift+F7.

Next Difference

Lets you search for the next difference in the file. The shortcut key is F7.


VSS Viewer Dialog Box

Allows you to edit or view a file without a file association.

Dialog Box Options

This dialog box includes a toolbar with the following buttons:

Save

Saves your edited file to disk.

Cut

Cuts the selection out of the file and places it on the Clipboard. The shortcut key is Ctrl+X.

Copy

Copies the selection and places it on the Clipboard. The shortcut key is Ctrl+C.

Paste

Pastes the Clipboard contents at the cursor location. The shortcut key is Ctrl+V.

Undo

Undoes your last editing action. The shortcut key is Ctrl+Z.

Redo

Redoes your last undone editing action. The shortcut key is Ctrl+A.

Find

Lets you search for a string in the file. The shortcut key is Alt+F3.

Find Next

Lets you search for the next matching occurrence of a string in the file. The shortcut key is F3.

Find Previous

Lets you search for a previous matching occurrence of a string in the file. The shortcut key is Shift+F3.

Toggle Bookmark

Lets you turn a bookmark on or off in a file. The shortcut key is Ctrl+F2.

Next Bookmark

Lets you go to the next bookmark in the file. The shortcut key is F2.

Previous Bookmark

Lets you go to the previous bookmark in the file. The shortcut key is Shift+F2.

Clear All Bookmarks

Lets you clear all bookmarks in the file.


Deploy Dialog Box

Allows you to set options for your Web site project deployment.

Dialog Box Options

If you enable the Deploy command dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu), or hold down the SHIFT key when you click the Deploy command, you have the following options:

To

Type the path where you want VSS to place the files. You can Browse for the appropriate location.

Make Writable

Sets the read-write flag so the file is writable. This is not the default behavior, but may be useful if you want to try a temporary change in the file, or want to rename the file after getting it.


For additional support needs

If you don’t have access to the Internet

FastTips is an automated toll-free, fax-back service that provides popular Knowledge Base articles and quick answers to common technical questions. To gain access, dial (800) 936-4300.

If you need support services for a small, medium-sized, or large business

Priority Annual Support, Priority Plus, and Premier Support provide a selection of annual support packages that are geared for businesses. To determine which account best meets your business needs, go to http://support.microsoft.com/support. Or call (800) 936-3500 for information on support options for small- to medium-sized businesses or (800) 936-3200 for large, enterprise businesses.

If you need on-site, multivendor, or proprietary product support

Microsoft Certified Solution Providers and Authorized Support Centers specialize in providing support packages for hardware, network, and software products from both Microsoft and other vendors. For more information or a referral to a Microsoft Certified Solution Provider, call (800) 765-7768 between 6:30 A.M. and 5:30 P.M. Pacific time, Monday through Friday, excluding holidays, or visit http://support.microsoft.com/support. For more information on Authorized Support Centers, contact your Microsoft account representative, or visit http://www.microsoft.com/enterprise/asc.htm.

If you need text telephone (TTY/TDD) services

In the United States, call (425) 635-4948, or in Canada, call (905) 568-9641.

Microsoft’s support services are subject to Microsoft prices, terms, and conditions in place at the time the service is used and are subject to change without notice.


If you have a simple question and need an answer fast

Quickly find your answers online

Use Support Online to search the Microsoft Knowledge Base and other technical resources for fast, accurate answers. You can also customize the site to control your search. To begin your search, go to http://support.microsoft.com/support. For additional technical resources and information on developing with Microsoft products and technologies, visit MSDN online at http://www.microsoft.com/msdn.


If you need support outside the United States and Canada

Microsoft Technical Support Worldwide

If you are outside the United States and have a question about a Microsoft product, first:

  • Check the information in this Help file or the product manual.

  • Check the readme files that come with your product disks or discs. These files provide general information that became available shortly before the product was released.

  • Go to Support Online from Microsoft Technical Support at http://support.microsoft.com/support.

If you cannot find a solution, you can receive information on how to obtain technical support by contacting the Microsoft subsidiary office in your area.

Important Phone numbers for Microsoft Subsidiaries are subject to change. For the most recent listing, see the options and phone number section on the Support Online Web site at http://support.microsoft.com/support. If there is no Microsoft subsidiary office in your country, contact the establishment from which you obtained your Microsoft product.

  • Argentina

    Microsoft de Argentina S.A.
    Customer Service: (54) (1) 316-4600
    Fax: (54) (1) 316-4698
    Technical Support: (54) (1) 316-4664

  • Armenia

    See Russia

  • Australia

    Microsoft Pty. Ltd.
    Fax: (61) (02) 9805 1108
    Sales Information Centre: (61) (02) 9870-2100
    Internet: //www.microsoft.com.au/
    Technical Support: (61) (02) 9870-2131
    Fax: (61) (02) 9805 0519

  • Austria

    Microsoft Ges.m.b.H.
    Phone: (+43) 1 610 64 -0
    Fax: (+43) 1 610 64 -200
    Information: 0660-6520
    Prices, updates, etc.: 0660-6520
    Standard Support:
    Installation and Handling: 01 50222-2255
    General information about Support Network in Central Europe:
    Fax: 01805-251191

  • Azerbaijan

    See Russia

  • Belgium

    Microsoft NV
    Phone: +32-2-730 39 11
    Fax: +32-2-726 96 09
    Microsoft Information Center: +32-2-481 52 52
    Bulletin Board: +32-2-726 85 45 (14400/1200/2400/9600 bd, 8N1, ANSI)
    Technical Support:
    +32-2-513 32 74 (Dutch speaking)
    +32-2-502 34 32 (English speaking)
    +32-2-513 22 68 (French speaking)

  • Belorussia

    See Russia

  • Bolivia

    See Argentina

  • Brazil

    Microsoft Informatica Ltda.
    Phone: (55) (11) 5514 -7100
    Fax: (55) (11) 5514 - 7106/5514-7107
    Technical Support: (55) (11) 5506-8087
    Fax: (55) (11) 5506-7621
    Automatic Fax: (55) (11) 5506-8506
    Technical Support Bulletin Board Service: (55) (11) 5506-1234
    Customer Support: (55) (11) 822-5764

  • Canada

    Microsoft Canada Inc.
    Head Office Phone: 1 (905) 568-0434
    Customer Information Centre: 1 (800) 563-9048
    Technical Support:
    Desktop Systems including Microsoft Windows 95: (905) 568-4494
    Microsoft Office and Office Components: (905) 568-2294
    Other Standard Technical Support: (905) 568-3503
    Priority Support Information: (800) 668-7975
    Text Telephone (TTY/TDD) (905) 568-9641
    Technical Support Bulletin Board Service: (905) 507-3022

  • Caribbean

    Microsoft Caribbean, Inc.
    Phone: (809) 273-3600
    Fax: (809) 273-3636
    Technical Support: (214) 714-9100

  • Central America

    See Latin America

  • Chile

    Microsoft Chile S.A.
    Phone: 56-2-330-6000
    Fax: 56-2-330-6190
    Customer Service: 56-2-800-213121
    Personal Operating System and Desktop Applications:
    Phone: 56-2-330-6222
    Fax: 56-2-341-1439

  • China

    Microsoft (China) Co. Ltd
    4/F Kai Yuen Commercial Building
    No.28 Zhichunli, Hai Dian District
    Beijing 100086, PRC
    Phone: 011-86-10-6261-7711
    Fax: 011-86-10-6253-6630

  • Colombia

    Microsoft Colombia
    Phone: (571) 618 2245
    Fax: (571) 618 2269
    Technical Support:
    Línea de Respuesta Microsoft
    Phone: (571) 5230022
    Fax: (571) 5231220
    Voice Mail: (571) 5034216

  • Croatia

    Microsoft Hrvatska d.o.o.
    Phone: (+385) (1) 304 555
    Fax: (+385) (1) 335 051
    Technical Support: (Please, contact the subsidiary.)

  • Czech Republic

    Microsoft s.r.o.
    Phone (+42) (2) 611 97 111
    Fax: (+42) (2) 611 97 100
    Technical Support: (+420) (2) 2150 3222

  • Denmark

    Microsoft Denmark
    Phone: (45) 44 89 01 00
    Fax: (45) 44 68 55 10
    Technical Support:
    Phone: (45) 44 89 01 11
    Microsoft Sales Support: (45) 44 89 01 90
    Microsoft FastTips: (45) 44 89 01 44
    (Document 303030 in FastTips contains detailed instructions)
    Microsoft MSDL (BBS): (45) 44 66 90 46

  • Dominican Republic

    See Central America

  • Dubai

    Microsoft Middle East
    Phone: (971) 4 513 888
    Fax: (971) 4 527 444
    Technical Support:
    Personal Operating Systems and Desktop Applications ONLY:
    Phone: (971) (4) 524 488
    Fax: (971)- 4 - 524 495
    email: mts@emirates.net.ae
    Priority Support Information: (971) (4) 555 752
    Customer Service Center:
    (Version upgrade / TechNet and MSDN subscription)
    Phone: (971) (4) 655 082
    Fax: (971) (4) 655 097

  • Ecuador

    Corporation Microsoft del Ecuador S.A.
    Phone: (593) 2 460-447, (593) (2) 460-451
    Customer Service: (593) (2) 460-453, (593) (2) 460-458
    Technical Support: (593) (2) 463-094

  • Egypt

    Microsoft Egypt
    Phone: +202-418-6101
    Fax: +202-4174766
    Technical Support:
    Personal Operating Systems and Desktop Applications ONLY:
    Phone: (202) 261 3991 / 6
    Fax: (971) 403 2718

  • England

    See United Kingdom

  • Estonia

    See Germany
    Technical Support: (+372) 650 49 99

  • Finland

    Microsoft OY
    Phone: +358-(0) 9-525 501
    Fax: +358-(0) 9-878 8770
    Technical Support:
    Phone: +358-(0) 9-525 502 500
    Sales Support: +358-(0) 9-525 5026
    Microsoft MSDL: +358-(0) 9-878 77 99
    (Information in Swedish and English)
    Microsoft FastTips: +358-(0) 9-525 502 550
    (Information in Swedish and English)

  • France

    Microsoft France
    Phone: (33) 01 69-86-46-46
    Fax: (33) 01 64-46-06-60
    Telex: MSPARIS 604322
    Technical Support:
    Phone: (33) 01-69-86-10-20
    Fax: (33) (01) 69-28-00-28

  • French Polynesia

    See France

  • Georgia

    See Russia

  • Germany

    Microsoft GmbH
    Phone: 089/3176-0
    Fax: 089/3176-1000
    Telex: (17) 89/83 28 MS GMBH D
    Information: 089/3176 1199
    Prices, updates, etc.: 08105-25-1199
    Internet: www.microsoft.com/germany
    Standard Support:
    Installation and Handling: 01805/67 22 55
    General information about Microsoft support in Central Europe: Fax: 1805-25-1191

  • Greece

    Microsoft Hellas, S.A.
    Phone: (30)(1) 6806-775 through (30)(1) 6806-779
    Fax: (30)(1) 6806-780
    Technical Support:
    Phone: (30) (1) 9247-030
    Fax: (30) (1) 9215-363

  • Hong Kong SAR, PRC

    Microsoft Hong Kong Limited
    Fax: (852) 2560-2217
    Product support Faxback Service: (852) 2535-9293
    Microsoft Club Hotline: (852) 28044277
    Technical Support: (852) 2804-4222

  • Hungary

    Microsoft Hungary
    Phone: +36 (1) 327-2800
    Fax: +36 (1) 327-2899
    Technical Support: +36 (1) 267-4636 (2MSINFO)

  • Iceland

    See Denmark

  • Ireland

    See United Kingdom

  • India

    Microsoft India
    Phone: (011) (91) (80) 5092678, (011) (91) (11) 646 0767, 646 0813
    Fax: (011) (91) (80) 509-2601, (011) (91) (11) 647- 4714

  • Indonesia (SP)

    Microsoft Indonesia - Jakarta
    Technical Support:
    Phone: 62 21 5721060
    Fax: 62 21 5732077

  • Israel

    Microsoft Israel Ltd.
    Phone: 972-3-613-0833
    Fax: 972-3-613-0834

  • Italy

    Microsoft SpA
    Phone: (39) (2) 7039-21
    Fax: (39) (2) 7039-2020
    Microsoft Rome Office: (39) (6) 5095-01 - Fax: (39) (6) 5095-0600
    Microsoft by Fax (Fax-on-demand service): (39) (2) 70-398-888
    Customer Service (New product info, product literature): (39) (2) 70-398-398
    Dealer Support (Customer Service for resellers only): (39) (2) 70-398-388
    Technical Support: (39) (2) 70-398-398
    Microsoft Consulting Service: (39) (2) 7039-21

  • Japan

    Microsoft Company Ltd.
    Technical Support (Standard Support): (81) (424) 41-8700
    (Technical Support options/ Support Contract)
    Phone: 0120-37-0196 (toll free domestic only)
    Channel Marketing Information Center:
    (Presales Product Support)
    Tokyo Phone: (81) (3) 5454-2300
    Osaka Phone: (81) (6) 245-6995
    Customer Service Phone:
    (Version upgrade/Registration)
    Phone: (81) (48) 226-5500
    Fax: (81) (48) 226-5511

  • Kazakhstan

    See Russia

  • Kirgizia

    See Russia

  • Korea

    Microsoft CH
    Phone: (82) (2) 531-4500
    Fax: (82) (2) 531-1724
    Customer Service: 080-022-7337 (toll free domestic only)
    Technical Support:
    Office Technical Support: (82) (2) 508-0040
    Windows Technical Support: (82) (2) 563-0054
    Developer Technical Support: (82) (2) 566-0071
    Microsoft FastTips: (82) (2) 3453-7555
    Support Sales: (82) (2) 531-4544

  • Latin America

    Microsoft
    Latin American Headquarters (U.S.A.)
    Phone: (305) 489-4800
    Fax: (305) 491-1616
    Customer Service: (425) 936-8661
    Technical Support: (214) 714-9100
    http://www.microsoft.com/latam/soporte

  • Liechtenstein

    See Switzerland (German speaking)

  • Luxembourg

    Microsoft NV
    Phone: +32-2-730 39 11
    Microsoft Information Center: +32-2-481 52 52
    Bulletin Board: +32-2-726 85 45
    (1200/2400/9600/14400 bd, 8N1, ANSI)
    Technical Support:
    +32-2-513 32 74 (Dutch speaking)
    +32-2-502 34 32 (English speaking)
    +32-2-513 22 68 (French speaking)

  • Malaysia (SP)

    Microsoft (Malaysia) Sdn Bhd:
    Phone: (60-3) 793-9595
    Fax: (60-3) 791-6080

  • México

    Microsoft México, S.A. de C.V.
    267-2110 Atencion a Distribuidores
    265-3380 Atencion a Clientes
    265-3399 Soporte Sistemas Operativos y Applicaciones de Escritorio
    267-2190 Soporte de Servidores y Herramientas de Desarrollo
    Fast Tips: (52)(5) 2612199
    Microsoft BBS 628-6200/02 MSMEXICO sin password

  • Morocco

    Microsoft Afrique Du Nord
    Phone: (212) 2 47 10 72
    Fax: (212) 2 47 10 86

  • Netherlands

    Microsoft BV
    Phone: 023-5689189
    Customer Service: 023-5677700
    Bulletin Board: 023-5634221
    (1200/2400/9600/14400bd, 8N1, ANSI)
    Technical Support:
    023-5677877 (Dutch speaking)
    023-5677853 (English speaking)

  • New Zealand

    Microsoft New Zealand Ltd
    Phone: 64 (9) 357-5800
    Fax: 64 (9) 358-3726
    Technical Support:
    Phone: 64 (9) 357-5575
    Fax: 64 (9) 307-0516 and 357-5577

  • Northern Ireland

    See United Kingdom

  • Norway

    Microsoft Norway AS
    Phone: +(47) 22 02 25 00
    Fax: +(47) 22 95 06 64
    Technical Support: +(47) 22 02 25 50
    Microsoft Sales Support: +(47) 22 02 25 80
    Microsoft MSDL: +(47) 22 18 22 09
    Microsoft FastTips: +(47) 22 02 25 70
    (Document 404040 in FastTips contains detailed instructions)

  • Papua New Guinea

    See Australia

  • Paraguay

    See Argentina

  • Peru

    See Latin America

  • Philippines (SP)

    Microsoft Philippines
    Phone: 632 811 0062
    Technical Support:
    Phone: 632 892 2295/2495
    Fax: 632 813 2493

  • Poland

    Microsoft Sp. z o.o.
    Phone: +(48-22) 661-54-00
    Fax: +(48-22) 661-54-34
    Information Service: +(48-22) 865-99-33
    Technical Support: +(48-22) 865-99-66

  • Portugal

    Microsoft Portugal MSFT, Lda.
    Phone: (351) 1 4409200
    Fax: (351) 1 4412101
    Technical Support:
    Standard Support: (351) 1 4409280/1/2/3
    Fax: (351) 1 4411655
    Republic of Ireland
    See United Kingdom

  • Romania

    Microsoft s.r.l.
    Phone: (+40) (1) 222 90 16
    Fax: (+40) (1) 222 90 12
    Technical Support: (+40) (1) 312 09 48

  • Russia

    Microsoft A/O
    Microsoft Information Center: (095)-913-99-88

  • Scotland

    See United Kingdom

  • Saudi Arabia

    Microsoft Saudi Arabia
    Phone: +966-1-488-1165
    Fax: +966-1-488-1576
    Technical Support:
    (Personal Operating System and Desktop Applications only):
    Phone: 800 124 0500
    (toll free within Saudi Arabia)
    Fax: 966-1-4740576

  • Singapore

    Microsoft Singapore Pte Ltd
    Phone: (65) 337-6088
    Fax: (65) 337-6788
    Customer Services:
    Phone: (65) 433-5488
    Fax: (65) 339-9958
    Product Support Services:
    Phone: (65) 337-9946
    Fax: (65) 337-6700

  • Slovenia/Slovenija

    Microsoft d.o.o.
    Phone: (+386) (61) 1800 8-00
    Fax: (+386) (61) 1800 822
    Technical Support: (+386) (61) 185 3449

  • Slovak Republic

    Microsoft Slovakia s.r.o.
    Phone (+421) (7) 37 63 02
    Fax: (+421) (7) 37 66 71
    Technical Support: (+421) (7) 531 20 83

  • South Africa

    Microsoft South Africa
    Phone: (27) 11 445 0000
    Fax: (27) 11 445 0046
    Technical Support:
    (Toll Free): 0 802 11 11 04
    (Toll): (27) 11 445 0000
    Fax: (+27) 11 445-0343

  • South East Africa and Indian Ocean Islands

    See South Africa

  • Spain

    Microsoft Iberica SRL
    Phone: (34) 1-807-9999
    Fax: (34) 1-803-8310
    Technical Support: (34) 1 -3754004
    Customer Service: (34) 1-3754004
    Fax Back telephone: (34) 1-3754004

  • Sweden

    Microsoft AB
    Phone: +46-(0)8-752 56 00
    Fax: +46-(0)8-750 51 58
    Technical Support: +46-(0)8- 752 09 29
    Sales Support: +46-(0)8- 752 56 30
    Microsoft MSDL: +46-(0)8-750 47 42
    Microsoft FastTips: +46-(0)8-752 29 00
    (Document 202020 in FastTips contains detailed instructions)

  • Switzerland

    Microsoft AG
    Phone: 01-839 61 11
    Fax: 01-831 08 69
    Prices, updates, etc.: 01/839 61 11
    Documentation:
    Phone: 155 59 00
    Fax: 064-224294, Microsoft Info-Service, Postfach, 8099 Zürich
    Standard Technical Support: Installation and Handling:
    0848 80 - 2255
    Technical support (French speaking): 022-738 96 88
    General information about Microsoft Support in Central Europe:
    FAX: 0049/2622/167006

  • Tadzhikistan

    See Russia

  • Taiwan Region

    Microsoft Taiwan Corp.
    Phone: (886) (2) 504-3122
    Fax: (886) (2) 504-3121
    Technical Support: (886) (2) 508-9501

  • Thailand

    Microsoft (Thailand) Limited
    Phone: (662) 266-3300
    Fax: (662) 266-3310
    Product Support:
    Phone: (662) 613-7208 through 11
    Fax: (662) 613-7198

  • Turkey

    Microsoft Turkey
    Phone: 90 (212) 258 59 98
    Fax: 90 (212) 258 59 54
    Support Hotline:
    Phone: 90 (212) 258 96 66
    Fax: 90 (212) 258 95 99
    Bulletin Board Service: 90 (212) 227 93 90

  • Turkmenistan

    See Russia
    United Kingdom
    Microsoft Limited
    Fax: (0870) 60 20 100
    Phone: (0870) 60 10 100
    Microsoft KeyData:
    (Bulletin Board Service)
    (0870) 50 30 200 (up to 28.8Kbaud, n, 8, 1)
    Microsoft KeyFax:
    (Faxback Information Service)
    (0870) 50 30 100
    Technical Support:
    Desktop Applications, Home Products, Desktop Systems and hardware:
    0870 50 10 100
    Developer Products: 0870 50 10 200
    Business Systems: 0870 50 10 300
    Customers phoning from Ireland should dial 706 5353 for technical support.
    Minicom Line 0870 50 30 400
    Pre-Sales Information: Microsoft Connection (0345) 00 2000

  • Uruguay

    Technical Support: (598) (2) 77-4934

  • Uzbekistan

    See Russia

  • Venezuela

    Corporation MS 90 de Venezuela S.A.
    Other information: (582) 265-9922
    Fax: (582) 265-0863
    Technical Support: (582) 993-6755

  • Wales

    See United Kingdom


If your question isn't urgent

Send E-mail to a Microsoft Technical Support Engineer

With Web Response, you can conveniently submit questions via e-mail. This option is ideal for detailed questions or questions with attached files. You can submit questions 24 hours a day and will receive a response from an engineer within one business day. To submit your question, go to http://support.microsoft.com/support, find the Web Response option and choose from one of the following options.

Standard No-Charge Web Response

The amount of no-charge support for which you are eligible is described in the preceding Standard No-Charge Support section.

Pay-Per-Incident Web Response

If you have used up your Standard No-Charge Support as described above, you can submit your question for a fee of $95 U.S.


If your question is urgent and more complex

Telephone a Microsoft Technical Support engineer

Microsoft Technical Support provides no-charge and fee-based support via telephone. The amount of no-charge support will vary depending on which edition of the product you purchased, as described below.

Standard No-Charge Support for help during regular business hours

Note No-charge support is available for current versions only.

  • If you acquired Visual Studio Professional Edition, Visual Basic Enterprise Edition, or Visual C++ Enterprise Edition

    You will receive a total of two support incidents at no charge. You can apply these two no-charge incidents toward any of the products included in the edition you acquired. For additional information, see note below.

  • If you acquired Visual Studio Enterprise Edition

    You will receive a total of four support incidents at no charge. You can apply these four no-charge incidents toward any of the products included in the Visual Studio Enterprise Edition. For additional information, see note below.

  • If you acquired Visual Basic Professional Edition, Visual C++ Professional Edition, Visual J++, Visual InterDev, Visual FoxPro, or Visual Source Safe

    You will receive a total of two support incidents at no charge for the product you acquired.

To receive Standard No-Charge Support for the products described above

You can receive Standard No-Charge Support via e-mail or via telephone by calling (425) 635-7012 between 6:00 A.M. and 6:00 P.M. Pacific time, Monday through Friday, excluding holidays.

Note Microsoft Internet Explorer, Windows NT Option Pack, and FrontPage may have been included with one of the products you have purchased, however the available support options are separate from those listed above. If you have a question regarding any of these products, please see the technical support section of the individual product’s Help file.

  • If you acquired Visual Basic Learning Edition, Visual C++ Standard Edition, Visual J++ Standard Edition, or MSDN Library Edition

    You will receive no-charge support for issues related to setup and installation only. For all other issues you will need to purchase Pay-Per-Incident Support as described below. You can receive Standard No-Charge Support via telephone by calling (425) 635-7033 between 6:00 A.M. and 6:00 P.M. Pacific time, Monday through Friday, excluding holidays.

Pay-Per-Incident Support - for help after-hours or to supplement Standard Support

If you need help after-hours, or if you have used up your incidents of Standard No-Charge Support as described above, you can purchase Pay-Per-Incident Support for a fee of $95 U.S. per incident by calling (800) 936-5800. Support fees will be billed to your VISA, MasterCard, or American Express card. In the United States, you can also call (900) 555-2300 to have support fees applied to your telephone bill.


Archive Databases

See Also

Periodically, you may want to back up your VSS database or parts of it. You can now archive databases from the VSS Administrator program. In previous versions of VSS, Archive and Restore were only available from the command line.

Archiving allows you to:

  • Save disk space on your VSS database server.

  • Make the Show History command work more quickly.

  • Transport files and projects between VSS databases, keeping history information intact.

  • Back up all or part of the VSS database to a compressed file

To archive a database:

  1. Open the database from which you want to archive information. See How to Open a Database for more information.

  2. On the Archive menu, click Archive Projects… to display the Archive Wizard.

  3. Select the project you want to archive.

  4. Click OK.

  5. If there are additional projects you'd like to add to the archive, do so in step 1 of the wizard.

  6. Click Next.

  7. In step 2 of the wizard, specify how you want the project to be archived.

  8. If Save data to file or Save data to file, then delete from database to save space is selected, enter the name of the file to save the project(s) to in the Archive File box.
    • Or —

    Click Browse to search for and select an archived file. This will overwrite existing files.

    • Or —

    If Delete Data Permanently is selected, the Archive File box will be disabled.

  9. Click Next.

  10. In step 3 of the wizard, specify the version of the data you'd like archived (version range). You can also add a comment to the Comment box if you'd like.

Note To archive by version number, enter just the number in the Version box, i.e., 5. To archive by label, enter L followed by the label string, i.e., "LmyLabel". To archive by date, enter D followed by a date string, i.e., D11/26/98.

  11. Click Finish to complete the archive.


Clean Temporary Folder

See Also

As the VSS administrator, you are responsible for cleaning the Temp folder pointed to by the Temp_Path initialization variable in the SRCSAFE.INI file.

VSS usually places files in its Temp folder while running, and deletes them before quitting. Some circumstances, such as having to restart, can cause files to remain in the Temp folder [image] a waste of disk space.

Once every few weeks, when no users are running VSS or VSS Administrator, clean the Temp folder.

To clean the temporary folder:

  1. On the Tools menu, click Clean up Temp Directory to display the Clean Up Local Temporary Files Directory dialog box.

  2. Click OK.


Open a Database

To open a VSS database:

  1. From the VSS Administrator Users menu, click Open SourceSafe Database to display the Open SourceSafe Database dialog box.

  2. Select a database from the list.

    Note If the database you want is not in the list of available databases, click Browse. Navigate to the SRCSAFE.INI file for an existing VSS database, then click the SRCSAFE.INI file. Click Open to add the database to the list.

  3. Click Open on the Open SourceSafe Database dialog box.


Restore Databases

See Also

You can now restore databases using the VSS Administrator program. In previous versions of VSS, Archive and Restore were only available from the command line.

To restore a database:

  1. Open the database into which you want to restore information. See How to Open a Database for more information.

  2. On the Archive menu, click Restore Projects… to display the Restore Wizard.

  3. Click Browse to select the archived file you want to restore.

  4. Click Open.

  5. In step 1 of the wizard, click Next.

  6. In step 2 of the wizard, select the project or projects you'd like to restore.

  7. Click Next.

  8. In step 3 of the wizard, specify where you want the project(s) restored to. You may also add a comment in the Comment box if you'd like.

  9. Click Finish to complete the restore.


Command Dialogs Options Tab

In this tab you can specify whether command dialog boxes are displayed when you perform VSS commands.

If you do not use the options provided on the Get Latest Version dialog box, for example, you can turn the dialog box off. When the Get Latest Version command is performed, the dialog box is not shown.

You can specify whether a dialog box appears in the following file commands:

  • Get Latest Version

  • Check Out

  • Undo Check Out

  • Show Differences

  • History

  • View and Edit

You can specify whether a dialog box appears in the following project commands:

  • Get Latest Version

  • Check Out

  • Undo Check Out

  • Show Differences

  • History

  • Deploy

  • Create Site Map

To display the Command Dialogs tab:

  1. On the Tools menu, click Options.

  2. Click the Command Dialogs tab.

Important Override any setting you make in this dialog box by holding down the SHIFT key while performing any of the preceding commands. The command dialog box appears even if the corresponding Options check box has not been selected.


Command Line Options Tab

See Also

In this tab you can specify how VSS's command-line options are performed. These options don't affect the behavior of VSS Explorer.

To display the Command Line Tab:

  1. On the Tools menu, click Options.

  2. Select the Command Line Options tab.

The first two options affect how VSS interacts with your working folder during command-line operations. By default in the Explorer, VSS expects a working folder to be set for each project, and will check out files to that folder only. By default on the command line, VSS assumes your current project and current folder are what you want to be working with, and ignores any working folders set for a specific project. You can modify this behavior by checking one of the following options.

The first two tab options determine how the working folder you've set is used.

Assume Working Folder Based on Current Project

  • If this option is selected, a file is put into your working folder for the project, even if that is not the current folder when you execute a command on a file from the command line.

  • If this option is not selected, subprojects go into their own respective working folders.

Assume Project Based on Working Folder

  • If this option is selected, VSS looks at your current folder whenever you execute any VSS command. If this is the working folder for a VSS project, VSS automatically changes to that project before executing the command. If you set this option, it is highly recommended that you don't give two projects the same working folder; VSS will not know which project to switch into.

  • If this option is not selected, VSS does not change to your current project when you execute any VSS command.

Check Out Comments

  • No Comment on Check Out — select this option if you don't want to be prompted for a comment upon checkout.

  • Apply Same Comment to All Files — select this option if you want VSS to take one comment (up to 64 characters) and apply it to all files involved in the checkout operation.

  • Apply Different Comment to Each File — select this option if you want to add a separate comment for each file involved in the checkout operation.

Comment Prompt

  • Prompt for Comments on the Command Line — select this option if you want VSS to ask for comments on the command line.

  • Use an Editor to Prompt for Comments — select this option if you want to use an editor to enter your command-line comments. After you select it, enter the path for the selected editor in the Editor box. Click Browse to search your file system for this information.

  • Use Prompt String — select this option if you want to specify that a prompt string (asking for a comment) be inserted into your editor when it opens. The prompt string is not saved with your comment unless you change the string in your editor.

  • Editor — enter the path for the selected editor. Click Browse to search for an editor.

Note This option is disabled when Prompt for Comments on the Command Line is selected.


Difference Options Tab

See Also

In this tab you can specify options for viewing differences between files or projects. These options are used in other VSS dialog boxes such as the Project Difference dialog box, the Visual Merge dialog box, the default VSS editor, and the VSS results pane.

To display the Difference options tab:

  1. On the Tools menu, click Options.

  2. Select the Difference tab.

Tab Options

You can specify/change all of the following options.

Colors

Select colors for lines VSS will use. The selected line color is shown in the Sample box.

Foreground

Select the foreground color.

Background

Select the background color.

Font

Select the font to be used in VSS Explorer and all its dialog boxes. To modify the font, click the Modify button.

Sample

The option(s) you've selected are displayed in this box.

Reset

Click here to reset all values on this tab to their defaults.

Tabstop Width

Specify the equivalent number of spaces each tab stop equals.

Shows Line Numbers

Select this box to show line numbers in the visual difference viewers.

Ignore White Space Differences when Merging Files

Select this box to ignore differences in white space (tabs, space characters, and so on) when merging two files.


General Options Tab

In this tab you can set properties for the selected project.

To display the General options tab:

  1. Select a project in VSS Explorer.

  2. On the Tools menu, click Options.

  3. Click the General tab if it isn't already selected.

Note To display this tab from within Visual Basic, after adding a Visual Basic project to VSS, on the Visual Basic Add-Ins menu, choose SourceSafe, and then choose SourceSafe Properties.

Tab Options

You can specify/change all of the following options.

Always Keep Files Checked Out

Select this box to keep a file checked out to your working folder, even if you check it in to the project database. The file is copied to the VSS database, but left checked out to you, so that you can update the database with your changes, but continue working on the file.

Act on Projects Recursively

Select this box to perform all actions on a selected project recursively, that is, the command is applied to the subprojects (and their subprojects, and so on) as well as to the selected project. This is useful if you have a project with many subprojects that you want to check out and check in as a unit.

Reuse Last Comment

Select this box to reuse the last comment for the next command. For example, if you check in a file with the comment "Added hyperlink jumps to our Help menu," and then check another file in, the same comment is entered in that file's comment box. If you modify the comment, VSS uses the changed comment for the next command.

Check In Unchanged Files

When you check in a file, and you have made no changes to it, VSS looks at this option to determine what to do.

Select one of the following:

  • Check In — instructs VSS to record the checkin as a new version, even if no changes to the file are detected.

  • Undo Check Out — instructs VSS to automatically undo checkout on any unchanged file you try to check in.

  • Ask — instructs VSS to display a dialog box asking what you want to do for each unchanged file.

  • Default — instructs VSS to depend on the specific initialization file settings for each project. This tells VSS how to determine what to do with unchanged files.

The default selection is Undo Check Out.

Use Visual Merge

Specify here when you want VSS to use the Visual Merge feature. VSS uses Visual Merge when merging files after a branch or multiple checkout. Your options include using Visual Merge only if there are conflicts, always use it (yes), or never use it (no). The default setting is Use Only If there are Conflicts. Change the setting to yes to see all changes during a merge.

Double-click on a File

Specify which command VSS should execute when you double-click on a file.

Your choices include:

  • Ask — instructs VSS to have a dialog box prompt you for what you'd like to do in every operation.

  • View file — instructs VSS to automatically display the file for viewing — you've no ability to edit the file.

  • Edit file — instructs VSS to check out the file automatically to your working folder, and open it for editing.

The default setting is Ask.

Editor for Viewing Files

If you want to use an editor to view text files, specify the path for the selected editor in this box, or click Browse to search for an editor.

Folder for Temporary Files

Specify here where you want VSS to store temporary files, or click Browse to search for and select a temporary file location. The default is the Temp subfolder under the folder in which SRCSAFE.INI is stored.

Note Creating your Temp folder locally, rather than on a server, may increase VSS performance.


Local Files Options Tab

See Also

In this tab you can set or change how files in the working folder are handled.

To display the Local Files tab:

  1. On the Tools menu, click Options.

  2. Select the Local Files tab.

Tab Options

Remove Local Copy After Add or Check In

This option causes VSS to automatically delete the local copy of files after add or checkin. It helps keep disk usage to a minimum, and ensures that you always get the most recent version when you start work on a file. Do not use this if you are using VSS integration with Visual Basic, Visual C++, or others.

Remove Local Copy After Delete

This option causes VSS to automatically remove the working folder copy of a file you delete in VSS. This helps keep disk clutter to a minimum. And, as long as you haven't destroyed or purged the file in the VSS database, you can always recover the file later.

Use Read-Only Flag for Files That Are Not Checked Out

Select this option to set the read-only flag on files in your working folder. VSS then assumes that files in your working folder that aren't checked out are read-only. It is highly recommended you leave this option turned on.

Copy Keyword-Expanded Files into Working Folder

Select this option to update keyword information in your working folder upon checkin. When you check in a file and have keyword expansion enabled, VSS updates the keyword information in your file. The modified file is replaced directly into VSS. If you do not check this option, a copy of the file will not be automatically placed in your working folder. Not using this option (clearing it) improves performance, but the copy in your working folder won't be up-to-date.

Append End-Of-Line To All Text Files

Set this option to append an end-of-line character whenever VSS retrieves a text file that does not already end with one. Some compilers require that all the files they compile end in an end-of-line character. If you are working in such an environment, you may want to set this option.

Compare Files By

This option allows you to set how VSS determines if your local copy is up-to-date. The following options are in order of increasing speed:

  • Contents [image] Compares the full contents of your local file to VSS's copy. This is the slowest method, but is the most accurate.

  • Checksum [image] Compares by a checksum stored by VSS. Use Checksum comparison for most VSS uses.

  • Time [image] Compares the date/time flags. The exact method of date comparison depends on the setting of the Set Date/Time On Local Files option: If set to Check In, VSS replaces the local copy if the time of the last check in (or add) is more recent than the local copy's modification date. If set to Current (the default) or Modification, VSS replaces the local file if VSS file's modification time is different from the local file's modification time.

Replace Writable Files

When you get or check out a file, VSS copies the file into your working folder. If there is already a writable copy of the file in your working folder, replacing the file may erase your work. This option allows you to specify how you want VSS to handle writable files.

  • Ask [image] Instructs a dialog box to ask you what you'd like to do for every operation.

  • Replace [image] Replaces (overwrites) the local file.

  • Skip [image] Does not replace the local file, and generates an error in the Results pane if you have it displayed.

  • Merge [image] Merges the changes between the checked-out-file and the one you are now getting or checking out. If the file cannot be merged (that is, it is a binary file), an error is displayed in the Results pane if you have it displayed. Your VSS administrator must enable multiple checkouts on the files involved for this to work properly.

Set Date/Time on Local Files

This option allows you to specify how VSS sets the date/time for files in your working folder. The option you choose is the time you will see when you view files in the Windows Explorer.

  • Current [image] Sets the date and time of the file to the current date and time, whenever VSS gets a file. This signals the compiler that the file has just changed, and needs to be recompiled. This is the default.

  • Modification [image] Sets the local copy to the date and time the file was last modified.

  • Check In [image] Sets the local copy to the date and time the file was last checked in.


Resolve Merge Conflicts with Visual Merge

See Also

When there is a conflict, VSS uses its visual merging format, shown below, by default. This is true regardless of whether you initiate the merge or VSS does.

The Visual Merge dialog box

  • The top two panes represent two versions being merged. In the example dialog box shown above, the merge is being performed automatically as a result of multiple checkouts; hence, the file on the left is the one in VSS, and the file on the right is one on your hard disk. In the "Merge Branches" case, the two versions are from different projects.

  • The lower pane represents the result of the merge. It starts off with all nonconflicting changes already made, and changes dynamically as you work. If you are merging branches, the lower pane contains the original file from just before you created the branch.

  • All three panes scroll vertically together, to the extent that this is possible. (Under some circumstances, VSS may temporarily lose synchronization.) The upper panes also scroll together horizontally; the lower pane's horizontal position is independent.

  • The colors and font are controlled by the same options used for difference checking. Font style (bold, italic, and so on) cannot be changed.

  • The lower pane is directly editable, but the upper panes are not.

  • You can also cut/copy from the top two panes and paste into the lower pane.

  • Use the right-click menu to resolve conflicts.


View Options Tab

In this tab you can set VSS Explorer view options.

To display the View options tab:

  1. On the Tools menu, click Options.

  2. Select the View tab.

Tab Options

SourceSafe Window

  • Show Results Pane — Select this option to show the Results pane in VSS Explorer. The Results pane, at the bottom of VSS Explorer, shows you the results of your VSS commands.

  • Show Toolbar — Select this option to show the toolbar in VSS Explorer. The toolbar contains a set of buttons you can use to carry out commonly used commands.

  • Show Status Bar — Select this option to show the status bar in VSS Explorer. The status bar shows you status information about VSS, such as the current file pane sort order, the current username, and the number of items in the file list.

File List

  • Always Use MS-DOS Format Filenames — Select this option to truncate the long file names supported in 32-bit platforms. This option keeps the file name column of the display narrow, and is also useful if you have computers with several different operating systems using your VSS database.

  • Make Selected Project the Current Project — This option is normally selected. However, if your network suffers from poor performance, you may want to be able to scroll the project list without VSS updating the current project as you do so. In this case, turn off this option. If it is turned off, you must press the ENTER key on a project (or double-click with the mouse) to make it the current project.

  • Automatically Refresh File List — Select this option to have VSS automatically refresh its file list. Refreshing keeps VSS Explorer up-to-date, but it also causes a momentary delay (and a network load). If you select this option, enter the refresh interval in minutes in the box below. If you do not select this option, you can manually refresh the file list using the Refresh File List command on the View menu.


Warnings Options Tab

In this tab you can specify whether warnings are displayed before actions that might result in accidental loss or deletion of data.

To display the Warnings options tab:

  1. On the Tools menu, click Options.

  2. Click the Warnings tab.

Tab Options

When you delete a file from the VSS database, VSS asks "Are you sure you want to delete?" Some users find the warning helpful, because it prevents accidental deletion of data. Others find it annoying, because it requires an extra keystroke. This and other VSS warnings are therefore entirely configurable.

You can choose whether you want to receive warnings before VSS executes the following:

  • Undo checkout of a modified file

  • Delete a file or project

  • Destroy a file or project

  • Purge a file or project

  • Roll back a file

  • Check out an already checked-out file — If this option is disabled, multiple checkouts are turned off — see your VSS administrator.

  • Quit VSS


Glossary

A

access rights

Levels of permission users are granted by the VSS administrator to use the VSS database. The levels of access rights are Read, Check Out, Add, and Destroy.

Advanced dialog box

Dialog box that contains optional or additional settings. Many VSS dialog boxes have an Advanced button that displays additional settings.

automatic merge

When multiple users have the same file checked out, their changes to the file are merged by VSS during check in.

B

branched file

File whose share link has been broken using the Branch command.

branching

Process of sharing a file with another project and then separating it into two or more branches. Once a branch has been created, two files (the file in the project, and its counterpart in other projects) will have a shared history up to a certain point, and divergent histories after that time.

C

checked-in file

File stored in the VSS database and unavailable for modification.

checked-out file

File that has been reserved for work by a user. Users check out files to make changes to them. In the default configuration, VSS allows only one user at a time to check out a file. Checking out a file copies its latest version into the user's working folder.

check-out folder

Folder to which a file is checked out in VSS. It is not the working folder. If you check out a file, the file is checked out to your working folder. To another user, the file is in the check-out folder. The check-out folder is displayed in the Check Out Folder column of the file pane; the working folder is displayed under the toolbar.

cloaking

Preventing a project from being affected by certain commands, for example, Get Latest Version, Check Out, Check In, Undo Check Out, and Project Show Difference.

column format

Formatting option used with keyword expansion within a file. This option (using two colons instead of one in the keyword instructions) tells VSS to align columns of keyword information for a more readable display.

conflict

Two or more different changes to the same line of code in a multiple check out situation. VSS recognizes conflicts during a merge operation, and flags them in some way.

conflict marker

Symbol used to designate conflicting changes to a file. These symbols are:

Symbol | Description
<<<<<< | SourceSafe version
====== | Conflict separator
>>>>>> | Local version

VSS places these marks in the file after a conflicting check-in or merge operation, so conflicts can be easily found and resolved.

cross-platform development

VSS supports transparent file-compatibility across multiple processors and operating systems.

current project

Project selected in the project pane of the VSS Explorer window.

current version

Version of a file most recently stored in the VSS database. The current version has the highest version number of a file in VSS.

D

Delete command

Removes files and projects from a VSS project, and marks them as deleted; the items still exist, however, and can be recovered using the Recover command.

delta

In VSS, a delta is the difference between version x of a file and version x [image] 1 of the same file. VSS uses reverse delta technology to store changes.

Destroy command

Permanently removes deleted files and projects from the VSS database. Once destroyed, the items cannot be recovered.

development environment

Set of software development tools, presented as a unified environment in which the software developer can efficiently work. Microsoft Visual Basic and Microsoft Visual C++ are examples of such environments.

drag and drop

Combination of features that allows the user to drag an item and drop it onto another item using the mouse. An item can be a source (the item the user drags) or a target (the item on which the user drops a source).

To drag an object, click the object, then while holding down the mouse button, move it to the new location. Release the mouse button to drop the object.

F

file header

Text at the beginning of a file that contains information, such as the revision number of the file, the author, the date and time of last modification, and so forth. This information usually appears as comments in programming language files so it doesn't interfere with compiling.

file list

List of files in the current project, which can be found in the file pane of the VSS Explorer window.

file pane

Right side of the VSS Explorer window. This pane contains the file list, which is a list of all files in the current project.

H

history

Record of changes to a file since it was initially added to VSS. With the file history, you can return to any point in the file's history and recover the file as it existed at that point. The History of Project dialog box shows the record of significant events in the current project, such as labeling and deleting or adding files and subprojects.

I

inheritance

Inherited effect of variables in VSS initialization files that subprojects receive from their parent projects. Variables in these files can be grouped under headings to specify behavior. If a variable is set before any group heading in the initialization file, the variable affects all projects; the effect is inherited by the subproject variables.

J

journal file

A text file the admin sets up to record any action in VSS that generates a history entry for a file or project. This file is frequently used for auditing purposes.

K

keyword

Specific to VSS. You can use keywords in your text files to automatically create a file header with version-specific information. Use VSS keywords to place information from VSS directly into a text file.

keyword-enabled file

File that contains VSS keyword information.

keyword expansion

Process VSS uses to replace a VSS keyword with meaningful header information when you use the Check In and Add Files commands. For example, the string "$Revision:   $" tells VSS to expand the Revision keyword automatically with the current file version number.

L

label

User-defined name you can attach to a specific version number of a file or project.

local copy

Copy of a file stored in your working folder on your local computer. The local copy may differ from the VSS master copy if the local copy has been changed since the last check out, or if the master copy was changed by another user while you were working on the local copy.

locking

System of ensuring that two processes do not affect the same record in a database at the same time. To coordinate record access, VSS applies native locking, which uses native operating system functions. VSS also can be set to use lockfiles, which create temporary files in the LOCKS folder.

log on

Process of entering and verifying a user's name and password to access the VSS database.

M

master copy

Most recently checked-in version of a file stored in the VSS database, as opposed to the local copy of a file in your working folder.

merging

Process of combining differences in two or more changed copies of a file into a new version of the file. A merge involves at least two different files (which can be different versions of the same file or changes made to the same version of the file) and creates a new file made up of the results of the merge. Merging can occur when the user merges two branches or when the Check In or Get Latest Version command is used.

multiple check out

Simultaneous check outs by two or more users. The VSS administrator must enable multiple check out.

P

parent project

The project a file or subproject exists in. For example, the parent of the file $/Project/Abc.txt is $/Project and the parent of the project $/Project is the root ($/).

password

Text string used as security to verify the identity of a user. A user password is often required to use the VSS database.

project

Group of related files, typically all the files required to develop a software component. Files can be grouped within a project to create subprojects. Projects can be defined in any way meaningful to the user(s). For example, one project per version, or one project per language. Projects tend to be organized in the same way as file directories.

project list

List of all the projects available in the VSS database; the project list is found in the left pane of the VSS Explorer window.

project pane

Left side of the VSS Explorer window. The project pane contains the project list, a list of all available projects in the VSS database.

project security system

The more restrictive of the two security systems provided by VSS. By default, it is disabled. When enabled by the admin, this feature allows an admin to set access rights on a per user, per project basis. See Access Rights.

Purge command

Permanently removes previously deleted files and projects from the VSS database. Once purged, the items cannot be recovered.

R

read-only file

File marked as read-only in its file attributes. Such a file can be viewed in an appropriate text editor, but cannot be modified. VSS marks the file as read-only when you use the Check In and Get Latest Version commands.

recursive operation

Operation applied to a project and to all the files and subprojects of that project. For example, you can use the Check Out command recursively to check out all files in the project list simultaneously and avoid selecting each file individually.

Results pane

Portion of the VSS Explorer window where results from VSS operations are shown. For example, when you check in a file, this pane shows the file name being checked in.

reverse delta

Change-storage technology used by VSS, in which incremental changes to a baseline file are stored, rather than each successive version of the file in its entirety. In VSS, the current version of a file is used as the baseline, and changes from the previous versions are saved. This results in reduced disk storage requirements and faster access times, because only the current version is stored in the database in its entirety.

rights propagation

Default assignment of user-access rights in subprojects based on rights assigned in the parent project. This default assignment can be changed.

root project

The highest-level project with the name $/ in the project list. All projects in a VSS database are subprojects of the root project.

S

security

VSS has two levels of security: default security and project security. Default security provides two access rights: read/write and read-only. When project security is enabled, four access rights are available per user, per project: Read, Check Out, Add, and Destroy. Each succeeding right includes all rights preceding it. The Destroy access right provides unlimited access and is equivalent to Read/Write rights under default security.

shadow folder

Central, optional folder that contains current versions of all the files in a project. The shadow folder does not contain the master copy of a file or the local copy of a file. Instead, it provides a central location from which to view the overall structure of the project and serves as a convenient place to build or compile the project.

share link

Link between a file shared with one or more projects. This link serves to update the shared file with any checked-in changes, regardless of which project the file was checked out from.

shared file

File simultaneously used by, and part of, more than one project.

source code control

The management of a file's change history and the file's relation to a larger grouping of related files known as a project. Source code control is a vital part of the efficient development of software applications. VSS is a project-oriented source code control.

status bar

A bar at the bottom of the VSS Explorer window used for displaying project and file status information and current command information.

subproject

Project within a parent project.

U

user list

List of users who can use the VSS database. The list is maintained by the VSS administrator and displayed in VSS Administrator's main window.

username

Unique identifying string for a given user. Used for logging on.

V

version control

VSS maintains multiple versions of a file, including a record of the changes to the file from version to version.

version number

Number that indicates the number of revisions a file has undergone since it was added to VSS. This number is displayed in the History dialog box. Version numbers are always whole numbers.

version tracking

Record keeping process of tracking a file's history from the initial version to the current version. Changes to a file are tracked as part of this process.

visual merge

Merge operation where conflicts are resolved visually, in an easy-to-use graphical interface.

VSS Administrator

Individual responsible for the VSS database. The administrator uses VSS Administrator program to control the location of the database, the user list, and access rights of each user, and performs setup and backup duties on the database. The administrator's user name is always Admin.

VSS database

Central database where all master copies, history, project structures, and user information is stored. A project is always contained within one database; multiple projects can be stored in one database, and multiple VSS databases can exist to store multiple projects.

VSS Explorer

VSS’s graphical user interface. By default, it comprises three panes: the left project pane and the right file pane, as well as the toolbar, status bar, menus, and so on. VSS Explorer is displayed when you click the VSS icon.

W

Web site project

Project marked as a Web site project in the VSS Administrator. Such a designation allows special Web site commands, such as Deploy, to be used in this project.

wildcard characters

Asterisk (*) and question mark (?) are wildcard characters. You can use these characters to match patterns. You can also use wildcard characters and matching characters to further refine a search.

Symbol | Example | Usage
* | wh* finds what, white, and why; *at finds cat, bat, and what | Like the MS-DOS asterisk (*) wildcard character, this asterisk matches any number of characters.
? | b?ll finds ball, bell, and bill | Like the MS-DOS (?) wildcard character, this symbol matches any single character.

A backslash preceding an asterisk or question mark indicates a literal asterisk or question mark: \* or \? (This is necessary if you want to search for actual asterisks, question marks, or backslashes.) A double backslash (\\) indicates a backslash. Any other use of a backslash is ignored.

working folder

Specified folder on a user's local computer used to store files when they are checked out of the VSS database. A user makes changes to files in the working folder and then checks the modified files back into the VSS database for version tracking.


VSS Naming Syntax, Conventions and Limitations

VSS has the following naming syntax, conventions and limitations:

  • User names and label names can be up to 31 characters long.

  • User passwords can be up to 15 characters long.

  • Filenames can be up to 255 characters long. Filenames can include spaces on operating systems that support them.

  • Project paths can be up to 259 characters long (including the filename).

  • Project or file labels can be up to 31 characters long.

  • Search strings can be up to 63 characters long.

  • Comments can be up to 63 characters long for the check out command, and 4K characters long for other comments.

  • Lines in the VSS initialization files can be up to 511 characters long.

  • Files and projects (added together) in the VSS database can total no more than 4 billion.

  • Files and projects (added together) in any project of the VSS database can total no more than 8191.

  • The size of a file stored in the VSS database is limited to 2 gigabytes.

  • The number of versions of a given file that VSS can store is limited to 32,767.

Most names in VSS cannot begin or end with spaces or tabs. Any character can be used for names or labels, except the following:

  • Dollar sign ($)

  • At sign (@)

  • Angle brackets (< >), brackets ([ ]), braces ({ }), and parentheses (( ))

  • Colon (:) and semicolon (;)

  • Equal sign (=)

  • Caret sign (^)

  • Pipe (vertical bar) (|)

  • Asterisk (*)

  • Exclamation point (!)

  • Forward (/) and backward slash (\)

  • Percent sign (%)

  • Question mark (?)

  • Comma (,)

  • Quotation mark (single or double) (' ")

  • Tab

VSS supports Universal Naming Convention (UNC) filenames. If your network operating system supports UNC pathnames, you can use them anywhere you specify a path name.

VSS does not support the use of @ characters on Banyan Vines networks. Banyan Vines users can access all VSS functionality by using mapped network drive letters.